if (typeof xfin_portal == "object") {

	/******** Declarations ********/
	
	xfin_portal.checkForLoginms = 3000;
	xfin_portal.checkForMailms = 300000;
	xfin_portal.mailBackgroundCheck = true;
	xfin_portal.mailcheckDateFile = "mailcheckDate.dat";
	xfin_portal.nbNewEmailsFile = "nbNewEmails.dat";
	xfin_portal.comcastMailURL = "http://yhm.comcast.net/qry/toolbaryhm.js?nocache=";
	xfin_portal.mailChromeImage = "";
	xfin_portal.noMailChromeImage = "";
	
	/******** End of Declarations ********/
	
	
	/******** Methods ********/	
	// As we now check for new mails every 5 minutes, we need a method that will show the good 
	// number of new messages over the tabs without calling the server.
	xfin_portal.synchronizeMailCountOverTabs = function(){
		if (!xfin_portal.isLogged() || !xfin_portal.mailBackgroundCheck) 
			return;
		
		if (xfin_portal.framework.fileExists(xfin_portal.nbNewEmailsFile)) {
			xfin_portal.updateUnreadCount(parseInt(xfin_portal.framework.loadFile(xfin_portal.nbNewEmailsFile)));
		}
	};
	
	// Check for the number of mail
	xfin_portal.checkForMail = function(){
		if (!xfin_portal.isLogged() || !xfin_portal.mailBackgroundCheck) 
			return;
		
		//check it has really took at least "checkForMailms" before recreate a server query. This will solve the problem of multiple tabs of IE.
		var hbDate = new Date;
		var unixtime_ms = hbDate.getTime();
		var unixtime = parseInt(unixtime_ms / 1000);
		
		if (!xfin_portal.framework.fileExists(xfin_portal.mailcheckDateFile)) {
			xfin_portal.framework.saveFile(xfin_portal.mailcheckDateFile, "0");
		}
		else {
			if ((parseInt(xfin_portal.framework.loadFile(xfin_portal.mailcheckDateFile))) + xfin_portal.checkForMailms / 1000 > unixtime) {
				xfin_portal.synchronizeMailCountOverTabs();
				return; //too soon...
			}
		}
		
		xfin_portal.framework.saveFile(xfin_portal.mailcheckDateFile, unixtime);
		
		// Download the mail xml feed
		xfin_portal.framework.download(xfin_portal.comcastMailURL + (xfin_portal.avoidCacheParameter++), function(url, code, content){
			var mailCount = -1;
			if (code == xfin_portal.SUCCESSFULL_STATUS_CODE) {
				var xml = xfin_portal.framework.loadXML(content);
				var nodes = xml.documentElement.childNodes;
				for (var i = 0; i < nodes.length && mailCount == -1; i++) {
					var node = nodes[i];
					if (node.tagName == "channel") {
						var subnodes = node.childNodes;
						for (var j = 0; j < subnodes.length && mailCount == -1; j++) {
							var subnode = subnodes[j];
							if (subnode.tagName == "newmail") {
								try {
									mailCount = new Number(subnode.childNodes[0].nodeValue);
								}catch (e) {
									mailCount = 0;
								}
							}
						}
					}
				}
			}
			
			if (mailCount == -1) 
				mailCount = 0;
			
			xfin_portal.framework.saveFile(xfin_portal.nbNewEmailsFile, mailCount);
			xfin_portal.updateUnreadCount(mailCount);
		});
	};
	
	// Update the mail count
	xfin_portal.updateUnreadCount = function(count){
		var countStr = "Email";
		if (count > 0) { // We have mail
			countStr += " (" + new String(count) + ")";
            var emailBtn = xfin_portal.framework.getElementById(xfin_portal.framework.applicationId+"-email");
            var mailBtn = xfin_portal.framework.getElementById(xfin_portal.framework.applicationId+"-mail");
			emailBtn.setAttribute("label", countStr);
			mailBtn.setAttribute("image", xfin_portal.mailChromeImage);
		}
		else { // We don't have mail
			var emailBtn = xfin_portal.framework.getElementById(xfin_portal.framework.applicationId+"-email");
            var mailBtn = xfin_portal.framework.getElementById(xfin_portal.framework.applicationId+"-mail");
			emailBtn.setAttribute("label", countStr);
			mailBtn.setAttribute("image", xfin_portal.noMailChromeImage);
		}
	};
	
	/******** End of methods ********/
}