dtxFramework.AboutWindow = function(framework, id) {

    dtxFramework.Window.apply(this, [framework, id]);
    var self = this;

    var xmlFile = this.framework.loadChromeFile("content\\lib\\about.xml");
    var xml = this.framework.loadXML(xmlFile);
    self.loadFromXML(xml.documentElement);
	var informationToClipboard = "";

    self.icon = self.getElementById("about-logo");
    self.trusteLogo = self.getElementById("about-truste-logo");
    self.infoBody = self.getElementById("about-info-body");
    self.infoBodyMore = self.getElementById("about-info-body-more");
    self.moreButton = self.getElementById("about-more-button");
    self.moreInfo = false;
	
	//Invisible button implementation
    //Invisible spot on wich the user clicks and gets the more-info page
    self.hiddenBox = self.getElementById("about-hidden-box");
	self.hiddenBox_informationToClipboard = self.getElementById("about-informationToClipboard-box");
	//Fixed an issue on IE6 where the blank image and Trust logo was not shown properly.
	self.hiddenBox.setAttribute("src", this.framework.makeChromeURL("skin/lib/blank.gif"));
	self.hiddenBox.setAttribute("style", "position: fixed;height:16px; width:16px;");
	if(self.hiddenBox_informationToClipboard)
		self.hiddenBox_informationToClipboard.setAttribute('style', "position: fixed;right:0px;top:0px;");
	var body = self.getElementById("about-window");
	body.setAttribute("style", "background: none; padding-top: 20px;");
	self.setAttribute("style", "background-image:url(../../skin/lib/panels/images/bg-aboutbox.png); background-repeat: none;");
    
    self.getElementById("about").setAttribute("title", self.framework.sprintf(self.framework.localize('About %s'),self.$framework.mainContainer.getAttribute("toolbarname")));

	//Fixed an issue on IE6 where the blank image and Trust logo was not shown properly.
	self.trusteLogo.setAttribute("src",  "skin/lib/panels/images/TRUSTe_about.png");


    self.infoBodyMore.setAttribute("hidden", "true");
    self.trusteLogo.setAttribute("hidden", "true");

    self.$loaded = false;

    this.addEventListener("beforeshowing",
		function() {
		    if (self.$loaded)
		        return;

		    self.$loaded = true;
		    // Set up the About box.
		    var tbName = self.$framework.mainContainer.getAttribute("toolbarname");
		    var version = self.$framework.mainContainer.getAttribute("version") || "";
		    var buildDate = self.$framework.mainContainer.getAttribute("builddate") || "";
		    var fwVersion = self.$framework.getVersion();

		    var tbNameLabel = self.getElementById("about-info-toolbar-name");
		    tbNameLabel.setAttribute("value", self.framework.sprintf(self.framework.localize('About %s'),tbName));
		    
		    var versionLabel = self.getElementById("about-info-version");
		    versionLabel.setAttribute("value", version);
		    var versionLabel2 = self.getElementById("about-info-version-2");
		    versionLabel2.setAttribute("value", version);

		    var updateVersion = self.$getUpdateVersion();
		    var updateLabel = self.getElementById("about-info-update");
		    updateLabel.setAttribute("value", updateVersion);

		    var buildLabel = self.getElementById("about-info-build-time");
		    buildLabel.setAttribute("value", buildDate);
		    var buildLabel2 = self.getElementById("about-info-build-time-2");
		    buildLabel2.setAttribute("value", buildDate);

		    var poweredLabel = self.getElementById("about-lbl-poweredby");
		    var poweredLinkLabel = self.getElementById("about-lbl-poweredby-link");
		    var poweredTMLabel = self.getElementById("about-lbl-poweredby-tm");
		    var footerContainer = self.getElementById("about-footer-container");

		    var dtBandContainer = self.getElementById("about-info-dll1-version-container");
		    var dtxContainer = self.getElementById("about-info-dll2-version-container");
		    var auxiContainer = self.getElementById("about-info-dll3-version-container");
			var dtUserContainer = self.getElementById("about-info-dll4-version-container");

		    var dtBandVersionLabel = self.getElementById("about-info-dll1");
		    var dtBandVersionInfo = self.getElementById("about-info-dll1-version");
		    var dtxVersionLabel = self.getElementById("about-info-dll2");
		    var dtxVersionInfo = self.getElementById("about-info-dll2-version");
		    var auxiVersionLabel = self.getElementById("about-info-dll3");
		    var auxiVersionInfo = self.getElementById("about-info-dll3-version");
			var dtUserVersionLabel = self.getElementById("about-info-dll4");
		    var dtUserVersionInfo = self.getElementById("about-info-dll4-version");

			poweredLabel.setAttribute("style", "font-size:14px;");
			poweredLinkLabel.setAttribute("style", "font-weight:bold; margin:-1px 0px 0px -2px; font-size:14px;");
			poweredTMLabel.setAttribute("style", "font-weight:bold; font-size:14px; margin-left:2px;");
			footerContainer.setAttribute("style", "margin-top:25px;");
			self.trusteLogo.setAttribute("style", "margin-left:180px;");

			dtBandContainer.setAttribute("style", "display:none");
			dtxContainer.setAttribute("style", "display:none");
			auxiContainer.setAttribute("style", "display:none");
			if (dtUserContainer) {
				dtUserContainer.setAttribute("style", "display:none");
			}

		    var fwVersionLabel = self.getElementById("about-info-framework-version");
		    fwVersionLabel.setAttribute("value", fwVersion);

		    var emailnotifierFlag = false;
		    var emailnotifierInstalled = false;
		    var antispywareFlag = false;
		    var antispywareVersion = self.framework.localize(" Installed.");
		    var emailnotifierVersion = self.framework.localize(" Installed.");
			var preinstallWidget  = new Array();
			var preinstallWidgetInformation = "";
			var widgetNotPreinstalledInformation = "";
			var widgetFlag = false;
			
		    self.$framework.mainContainer.$recurse(self.$framework.mainContainer, function(element) {
				var tagName = element.tagName;
				switch (tagName) {
					case "widget": 
						widgetFlag = true;
						preinstallWidget.push(element.getAttribute("manifest"));
						break;
					default:
						break;
				}
				return true;
			});
				
			var elem = self.getElementById("about-info-alexa-container");
			elem.removeAll();

		    if (emailnotifierInstalled) {
		        if (emailnotifierFlag) {
	                self.getElementById("about-info-emailnotifier-label-version").setAttribute("value", self.framework.localize("Email notifier:"));
		            var emailnotifierLabel = self.getElementById("about-info-emailnotifier-version");
		            emailnotifierLabel.setAttribute("value", emailnotifierVersion);
		        }
		        else {
		            var emailnotifierLabel = self.getElementById("about-info-emailnotifier-version");
	            	emailnotifierLabel.setAttribute("value", self.framework.localize("Not installed"));
		        }
		    } else {
		        var elem = self.getElementById("about-info-emailnotifier-container");
		        elem.removeAll();
                elem.parentNode.removeChild(elem);
		    }

		    if (antispywareFlag) {
		        var antispywareLabel = self.getElementById("about-info-antispyware-version");
		        antispywareLabel.setAttribute("value", antispywareVersion);
		    }
		    else {
		        var elem = self.getElementById("about-info-antispyware-container");
		        elem.removeAll();
                elem.parentNode.removeChild(elem);
		    }

            var PATH_WIDGETS = "widgets\\";
            var FILENAME_WIDGETS = "widgets.xml";
            if(self.$framework.fileExists(PATH_WIDGETS + FILENAME_WIDGETS))
                widgetFlag = true;

            if (self.getAttribute("showextraversioninfo") == "true" || self.getAttribute("showtemplateversion") == "true"){
            	var content = framework.loadChromeFile("content/template.xml") ;
            	if (content != null){
                    var templateXML = framework.loadXML(content);
                    if (templateXML != null){
                   	var templateVersion = templateXML.getElementsByTagName("version")[0].getAttribute("value");
                    var templateVersionCont =  self.getElementById("about-info-template-container");
                   	if (templateVersionCont != null){
                        var newHbox   = self.framework.createElement("hbox");
	                    var newLabel1 = self.framework.createElement("label");
	                    newLabel1.setAttribute("value", "Template version: ");
	                    newLabel1.setAttribute("class","aboutpnl-template-label");
	                    newHbox.appendChild(newLabel1);
                        var newLabel2 = self.framework.createElement("label");
                        newLabel2.setAttribute("value", templateVersion);
                        newLabel2.setAttribute("class","pnlttl3");
                        newHbox.appendChild(newLabel2);
	                    templateVersionCont.appendChild(newHbox);
	                }
                 }           		
               }
            }

			if (widgetFlag && (self.getAttribute("showextraversioninfo") == "true" || self.getAttribute("showappversion") == "true")){
			
				var newWidgetInfo =  self.getElementById("about-info-wversion-container");
				if (newWidgetInfo){
                    var newHbox   = self.framework.createElement("hbox");
					var newLabel1 = self.framework.createElement("label");
                    newLabel1.setAttribute("value", "Apps versions");
                    newLabel1.setAttribute("class","aboutpnl-apps-label");
                    newHbox.appendChild(newLabel1);
                    newWidgetInfo.appendChild(newHbox);

					// pre-installed widget
						for (var j = 0; j < preinstallWidget.length; j++){
						
							var code = framework.loadChromeFile( preinstallWidget[j]);
							var widgetRegistryXML = self.framework.loadXML("<widgets>"+code+"</widgets>");
							var widgets = widgetRegistryXML.documentElement.getElementsByTagName("widget");
							var widget   = widgets[0];
							if (!widget)
								continue;
							var name     = widget.getAttribute("name");
							var version  = widgetRegistryXML.documentElement.getElementsByTagName("version")[0].getAttribute("displayversion");
							var appID 	= widget.getAttribute("id");
							preinstallWidgetInformation  += "&appPreinstalledName" + j + "=" + encodeURIComponent(name.replace(/\s/g, "")) + "&appPreinstalledUniqueID" + j + "=" + encodeURIComponent(appID.replace(/\s/g, "")) + "&appPreinstalledVersion" + j + "=" + encodeURIComponent(version.replace(/\s/g, ""));
							var newHbox   = self.framework.createElement("hbox");
							var newLabel1 = self.framework.createElement("label");
							var newLabel2 = self.framework.createElement("label");
									
							newLabel1.setAttribute("value",name+" :");
							newLabel1.setAttribute("class","pnlttl2");
							newLabel1.setAttribute("style","padding-right:5px;");
								
							newLabel2.setAttribute("value",(version == null? "N/A": version));
							newLabel2.setAttribute("class","pnlttl3");
																					
							newHbox.appendChild(newLabel1);
							newHbox.appendChild(newLabel2);
														
							newWidgetInfo.appendChild(newHbox);
						}
					
					// non pre-installed
					var widgetRegistry = self.framework.loadFile(PATH_WIDGETS + FILENAME_WIDGETS, true);
						
					if (widgetRegistry != null) {
						var widgetRegistryXML = self.framework.loadXML(widgetRegistry);
						
						if (widgetRegistryXML != null) {
						
							var widgets = widgetRegistryXML.documentElement.getElementsByTagName("widget");
							
							for (var i = 0; i < widgets.length; i++) {
							
								var widget   = widgets[i];
								var guid     = widget.getAttribute("id");
								var type     = widget.getAttribute("type");
								var status   = widget.getAttribute("status");
								var name     = widget.getAttribute("name");
								var version  = widgetRegistryXML.documentElement.getElementsByTagName("version")[i].getAttribute("displayversion");
								widgetNotPreinstalledInformation  += "&appNotPreinstalledName" + i + "=" + encodeURIComponent(name.replace(/\s/g, ""))+ "&appNotPreinstalledUniqueID" + i + "=" + encodeURIComponent(guid.replace(/\s/g, "")) + "&appNotPreinstalledVersion" + i + "=" + encodeURIComponent(version.replace(/\s/g, ""));
								var inChrome = widget.getAttribute("location") == "chrome";

								if (status != "pending" && status != "updating"){
									var newHbox   = self.framework.createElement("hbox");
									var newLabel1 = self.framework.createElement("label");
									var newLabel2 = self.framework.createElement("label");
										
									newLabel1.setAttribute("value",name+" :");
									newLabel1.setAttribute("class","pnlttl2");
									newLabel1.setAttribute("style","padding-right:5px;");
									
									newLabel2.setAttribute("value",(version == null? "N/A": version));
									newLabel2.setAttribute("class","pnlttl3");
																				
									newHbox.appendChild(newLabel1);
									newHbox.appendChild(newLabel2);
													
									newWidgetInfo.appendChild(newHbox);
								}
							
							}
						
						}
				
					}
				}
			}else{
					var elem = self.getElementById("about-info-wversion-container");
					elem.removeAll();
                    elem.parentNode.removeChild(elem);
			}

			try{
				var informationToClipboard ="http://tbanalyser.vmn.net/tbinfo.php?" +
			 								"toolbarID=" + encodeURIComponent(self.$framework.mainContainer.getAttribute("id").replace(/\s/g, "")) + 
			 								"&partnerName=" + encodeURIComponent(partnerName.replace(/\s/g, "")) +
			 								"&applicationIDIE=" + encodeURIComponent(statsElement.getAttribute("applicationIDIE").replace(/\s/g, ""))+
			 								"&applicationIDFF=" +encodeURIComponent(statsElement.getAttribute("applicationIDFF").replace(/\s/g, "")) +
			 								"&campaignIDIE=" + encodeURIComponent(statsElement.getAttribute("campaignIDIE").replace(/\s/g, "")) +
			 								"&campaignIDFF=" + encodeURIComponent(statsElement.getAttribute("campaignIDFF").replace(/\s/g, ""))+
			 								"&toolbarVersion=" + encodeURIComponent(self.$framework.mainContainer.getAttribute("version").replace(/\s/g, ""))+
			 								"&frameworkVersion=" + encodeURIComponent(self.$framework.getVersion().replace(/\s/g, ""))+
			 								preinstallWidgetInformation +
			 								widgetNotPreinstalledInformation;
			 	informationToClipboard = informationToClipboard.replace(" ","");
			 	if(dtBandVersion != undefined) informationToClipboard += "&DTBand=" + encodeURIComponent(dtBandVersion.replace(/\s/g, ""));
			 	if(dtUserVersion != undefined) informationToClipboard += "&DTUser=" + encodeURIComponent(dtUserVersion.replace(/\s/g, ""));
			 	if(dtxVersion != undefined) informationToClipboard += "&DTX=" + encodeURIComponent(dtxVersion.replace(/\s/g, ""));
				if(self.hiddenBox_informationToClipboard)
					self.hiddenBox_informationToClipboard.addEventListener("click", self.$copyToClipboard(informationToClipboard));
			}catch(ex){}
		});

    self.$renderFirstPage = function() {
        self.infoBodyMore.setAttribute("hidden", "true");
        self.infoBody.setAttribute("hidden", "false");
		self.getElementById("about-footer-container").setAttribute('style', 'margin-top:25px;');
    };


    self.$renderSecondPage = function() {
        self.infoBody.setAttribute("hidden", "true");
        self.infoBodyMore.setAttribute("hidden", "false");
		self.getElementById("about-footer-container").setAttribute('style', 'margin-top:37px;');
    };
	
    self.$getUpdateVersion = function() {
        var versionFile = self.$framework.loadFile("version.xml");

        if (versionFile) {
            var XMLObject = "";
			XMLObject = self.framework.loadXML(versionFile);
            try{
            	var Attribs = XMLObject.getElementsByTagName("update")[0].attributes;
            	return Attribs.getNamedItem("version").nodeValue;
            }catch(e){
            }
        }

        return self.framework.localize("None");
    };

	self.$copyToClipboard = function(text){
		var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
		str.data = text;

            function getLoadContext() {
                return window.QueryInterface(Ci.nsIInterfaceRequestor)
                   .getInterface(Ci.nsIWebNavigation)
                   .QueryInterface(Ci.nsILoadContext);
            }
    
    
		   var trans = Components.classes["@mozilla.org/widget/transferable;1"].
							createInstance(Components.interfaces.nsITransferable);
		   if (!trans)
			  return;

		trans.init(getLoadContext());
		trans.addDataFlavor("text/unicode");
		trans.setTransferData("text/unicode", str, text.length * 2);

		var clip   = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);

		clip.setData(trans, null, Components.interfaces.nsIClipboard.kGlobalClipboard);
	};
		
	self.$getStatElement = function(){
		var statsElement = null;
		for(var i=0;i<self.$framework.mainContainer.childNodes.length;i++){
		if(self.$framework.mainContainer.childNodes[i].tagName == "stat")
		{ statsElement = framework.mainContainer.childNodes[i]; break; }
		}
		return statsElement;
	};
	var statsElement = self.$getStatElement();
		
	var content = framework.loadChromeFile("content/partner.xml") ;
	var partnerName = "";
	if (content != null){
		var partnerXML = self.framework.loadXML(content);
		if (partnerXML != null)
		{	
			var partnernodes = partnerXML.getElementsByTagName("partner"); 
			if(partnernodes.length > 0) 
			 partnerName = partnernodes[0].getAttribute("name"); 
		}
	};
	

	//Changes for the invisible button implementation
    self.$moreButtonClickHandler = function() {
        self.moreInfo = !self.moreInfo;
        if (self.moreInfo) {
            self.moreButton.setAttribute("label", self.framework.localize("Back"));
            self.$renderSecondPage();
        }
        else {
            self.moreButton.setAttribute("label", self.framework.localize("More Details"));
            self.$renderFirstPage();
        }
    };
	

    self.moreButton.addEventListener("click", self.$moreButtonClickHandler);
    //Adding to the invisible spot the same functionality than moreButton
    self.hiddenBox.addEventListener("click", self.$moreButtonClickHandler);
	
    self.icon.addEventListener("click",
		function() {
			if(self.$framework.mainContainer.getAttribute("homepage") != "")
				self.$framework.loadURI(self.$framework.mainContainer.getAttribute("homepage"));
		});
};



dtxFramework.inherits(dtxFramework.AboutWindow, dtxFramework.Window);

dtxFramework.AboutWindow.prototype.setAttribute = function(attrid, value) {
	dtxFramework.Window.prototype.setAttribute.apply(this, [attrid, value]);

	if (!this.icon || !this.trusteLogo)
		return;

	if (attrid == "logo") {
		this.icon.setAttribute("src", this.framework.makeChromeURL(value));
	}
	
	if (attrid == "truste" && value == "true") {
		this.trusteLogo.setAttribute("hidden", "false");
	}

	if (attrid == "trustelink") {
		this.trusteLogo.addEventListener("click", function() {
			loadURI(value);
		});
	}
};

