dtxFramework.Log4DTX = function(framework, id) {

	dtxFramework.DTXElement.apply(this, [framework, id]);
	
	var self = this;
	
	this.Levels = {};
	this.Levels.OFF   = 0;
	this.Levels.INFO  = 1;
	this.Levels.WARN  = 2;
	this.Levels.ERROR = 4;
	this.Levels.FATAL = 8;
	this.Levels.DEBUG = 16;
	this.Levels.ALL = this.Levels.INFO | this.Levels.WARN | this.Levels.ERROR | this.Levels.FATAL | this.Levels.DEBUG;
	
	this.$logLevel = this.Levels.OFF;
	
	//$MOZILLA_START$//
	this.$CONSOLE = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
	//$MOZILLA_START$//
	
	this.$appendToLog = function(level, message){
		var logMessage = level+" "+self.framework.getTimeStamp()+": "+message;
		//$MOZILLA_START$//
		self.$CONSOLE.logStringMessage(logMessage);
		//$MOZILLA_START$//
	};
	
	this.$logLevelFromStr = function (strLoglevel){
		logLevel = this.Levels.OFF;
		if (typeof strLoglevel == 'string'){
			var tmpLevels = strLoglevel.split('|');
			for(var i in tmpLevels){
				 var level = tmpLevels[i].replace(/\s+/g,'');
				 if(level in this.Levels){
				 	logLevel |= this.Levels[level];
				 }
			}
		}
		return logLevel;
	};
	
	this.setLevel = function(strLoglevel){
		this.$logLevel = this.$logLevelFromStr(strLoglevel);
	};
	
	this.addLevel = function(strLoglevel){
		this.$logLevel |= this.$logLevelFromStr(strLoglevel);
	};

	this.info = function(message){
		if (self.Levels.INFO & self.$logLevel){
			self.$appendToLog("[INFO]", message);
		}
	};

	this.warn = function(message){
		if (self.Levels.WARN & self.$logLevel){
			self.$appendToLog("[WARNING]", message);
		}
	};

	this.error = function(message){
		if (self.Levels.ERROR & self.$logLevel){
			self.$appendToLog("[ERROR]", message);
		}
	};

	this.fatal = function(message){
		if (self.Levels.FATAL & self.$logLevel){
			self.$appendToLog("[FATAL]", message);
		}
	};

	this.debug = function(message){
		if (self.Levels.DEBUG & self.$logLevel){
			self.$appendToLog("[DEBUG]", message);
		}
	};
	
	this.clear = function(){
	};
};

dtxFramework.inherits(dtxFramework.Log4DTX, dtxFramework.DTXElement);