//$MOZILLA_START$//

dtxFramework.MenuItem = function(framework, id) {
	// inheritance
	dtxFramework.XULWrapper.apply(this, [framework, id]);
    
	this.tagName = "menuitem";
    //additional attributes to localize
    this.$localeAttributes = this.$localeAttributes.concat(["label","tooltiptext"]);
	this.$mPanelNode = null;
		
	var self = this;
	self.panel = null;

////////////////////////////////////////////////////////////////////////////////   
//render the menu item:
////////////////////////////////////////////////////////////////////////////////   
	this.$render = function() {
	//get the panel node
		var mcollkids = self.childNodes;
		var mFirstKid = null;
		if(mcollkids.length > 0) {
			mFirstKid = mcollkids[0];
			if(!mFirstKid)
				return;
			mcollkids = mFirstKid.childNodes;
			if(mFirstKid.tagName == "menupopup") {
				if(self.$mPanelNode || mcollkids.length > 0) {
					if(!self.$mPanelNode)
						self.$mPanelNode = mcollkids[0];
					
					if(self.$mPanelNode.tagName == "panel") {
						//set up the menu popup and clear 
						mFirstKid.setAttribute("height", 0);
						mFirstKid.setAttribute("width", 0);
						mFirstKid.removeChild(self.$mPanelNode);
						
						mFirstKid.addEventListener("close", function(evt) {
							try{
								if(self.panel) {
									mFirstKid.removeChild(self.$mPanelNode);
									//don't hide the panel if it was clicked (has focus):
									var delayed = function() { 
										if(self.panel.hasFocus() == false) {
											self.panel.hidePanel();
											self.panel = null;
										}
										else {
											self.panel = null;
										}
									};
									setTimeout(delayed, 50);

								}
							}
							catch(e)
							{	}
						}, false);

						mFirstKid.addEventListener("popupshowing", function(evt) {
							try{
								if(!self.panel){
									self.panel = self.$mPanelNode;
									self.panel.setTransparentColor(self.$mPanelNode.getAttribute("transparencycolor"));

									/////////////////////////////////////////////
									//save the real settings for later use
									var ahide = self.$mPanelNode.getAttribute("autohide");
									var aclose = self.$mPanelNode.getAttribute("autoclose");

									self.panel.setRTAutoHide(ahide);
									self.panel.setRTAutoClose(aclose);
									/////////////////////////////////////////////

									var iX = mFirstKid.$domNode.parentNode.boxObject.screenX + mFirstKid.$domNode.parentNode.boxObject.width;
									var iY = mFirstKid.$domNode.parentNode.boxObject.screenY;

									self.panel.show(iX, iY);
								}
								else {
									//self.panel.hidePanel();
								}
								return false;
							}
							catch(e){}
						}, false);
					}
				}
			}
		}
	};

	this.addEventListener("command",
		function() {
			if(self.getAttribute("type") == "radio"){
			    var mSiblings = self.parentNode.childNodes;
			    for(var i = 0; i < mSiblings.length; i++) {
				    var mMenuItem = mSiblings[i];
				    mMenuItem.setAttribute("checked", "false");
				}
			    self.setAttribute("checked", "true");
			}
			
			var url = self.getAttribute("href"); 
			if (typeof url == "string" && url != "") {
				self.framework.loadURI(url);
			}
	});
	
	this.addEventListener("mouseover",
		function(evt) {
			var menuitemID = self.$id;	
			var mSiblings = self.parentNode.childNodes;
			for(var i = 0; i < mSiblings.length; i++) {
				var mMenuItem = mSiblings[i];
				if(mMenuItem && mMenuItem.getAttribute("class") && (mMenuItem.$id != menuitemID)) {
					if(mMenuItem.panel) {
						mMenuItem.panel.hidePanel();			
					}
				}
			}
	}, false);
		
};

dtxFramework.inherits(dtxFramework.MenuItem, dtxFramework.XULWrapper);

dtxFramework.MenuItem.prototype.$applyStyle = function() {
	dtxFramework.XULWrapper.prototype.$applyStyle.apply(this);

	var className = this.getAttribute("class");
	
	if (className == null)
		className = "";
	if (className.indexOf("menuitem-iconic") == -1)
		className += " " + "menuitem-iconic";
	this.setAttribute("class", className);
	
};

dtxFramework.MenuItem.prototype.setAttribute = function(attrid, value) {
	dtxFramework.XULWrapper.prototype.setAttribute.apply(this, [attrid, value]);

	if (attrid == "imageheight"){
		if (this.$domNode){
			if (this.$domNode.boxObject.firstChild && this.$domNode.boxObject.firstChild.tagName == "xul:image")
				this.$domNode.boxObject.firstChild.height = value ;
			else if (this.$domNode.boxObject.firstChild && this.$domNode.boxObject.firstChild.boxObject.firstChild && this.$domNode.boxObject.firstChild.boxObject.firstChild.tagName == "xul:image")
				this.$domNode.boxObject.firstChild.boxObject.firstChild.height = value ;
		}
	}
	
	if (attrid == "imagewidth"){
		if (this.$domNode){
			if (this.$domNode.boxObject.firstChild && this.$domNode.boxObject.firstChild.tagName == "xul:image")
				this.$domNode.boxObject.firstChild.width = value ;
			else if (this.$domNode.boxObject.firstChild && this.$domNode.boxObject.firstChild.boxObject.firstChild && this.$domNode.boxObject.firstChild.boxObject.firstChild.tagName == "xul:image")
				this.$domNode.boxObject.firstChild.boxObject.firstChild.width = value ;
		}
	}
};

dtxFramework.MenuItem.prototype.$applyAttributes = function() {
	dtxFramework.XULWrapper.prototype.$applyAttributes.apply(this);
	this.setAttribute("tooltiptext", "");
	// find a nested popup
	var i = 0;
	for (; i < this.childNodes.length && !this.childNodes[i].$isPopup; i++);
	if (i < this.childNodes.length) {
		this.$popup = this.childNodes[i];
		this.setAttribute("popup", this.$popup.$id);
	}
};

//$MOZILLA_END$//