//$MOZILLA_START$//

dtxFramework.MenuPopup = function(framework, id) {
    // inheritance
    dtxFramework.XULWrapper.apply(this, [framework, id]);

	var self = this;
    
    this.tagName = "menupopup";
	this.$isPopup = true;
    this.$window = null;
	this.$isTopElement = true;
    
	this.$deferRenderChildren = function() {
		return true;
	};
	
	this.$onBeforeShow = function(evt) {
		evt.cancelBubble = true;
		self.$disableUpdates();
		self.$fireEvent("popupshowing", {target: self});
		if (self.$onpopupshowing != null) {
			self.$onpopupshowing();
		}
		self.$enableUpdates();
		self.$update();
	};
	
	this.$onClose = function(evt) {
		self.$fireEvent("close", {target: self});		
	};
	
	this.showPopup = function(element, x, y) {
		this.$update();
		var reference = (this.framework.isNativeElement(element))?element:element.$domNode;
		if (typeof reference.boxObject != "undefined") {
			if (this.$insidePopup()) {
				if (reference.parentNode != null)
					x += Math.min(reference.boxObject.width, reference.parentNode.boxObject.width) - 2;
				else
					x += reference.boxObject.width - 2;
				y += -3;
			}
			else {
				y += reference.boxObject.height;
			}
			this.$domNode.showPopup(reference, 
				reference.boxObject.screenX + x, 
				reference.boxObject.screenY + y, 
				"context", "none", "none");
		}
		else {
			x += element.ownerDocument.defaultView.screenX;
			y += element.ownerDocument.defaultView.screenY;
			var parent = element;
			while (parent != null) {
				x += parent.offsetLeft;
				y += parent.offsetTop;
				parent = parent.offsetParent;
			}
			this.$domNode.showPopup(reference, x, y + reference.offsetHeight, 
				"context", "none", "none");
		}
	};
    
    this.hidePopup = function() {
		if (this.$domNode != null)
			this.$domNode.hidePopup();
    };
    
    this.$insidePopup = function() {
		var node = this.parentNode;
		while (node != null && !node.$isPopup)
			node = node.parentNode;
		return node != null;
    };
    
};

dtxFramework.inherits(dtxFramework.MenuPopup, dtxFramework.XULWrapper);

dtxFramework.MenuPopup.prototype.$applyStyle = function() {
	dtxFramework.XULWrapper.prototype.$applyStyle.apply(this);
};

dtxFramework.MenuPopup.prototype.$applyAttributes = function() {
	dtxFramework.XULWrapper.prototype.$applyAttributes.apply(this);
	
	if (this.parentNode != null &&
		this.parentNode.$domNode != null) {
		
		if (!this.getAttribute("forceposition")  && this.getAttribute("forceposition") != "true"){
			if (this.parentNode.tagName == "menu" || 
				(this.parentNode.parentNode != null && 
				this.parentNode.parentNode.tagName != "toolbar"))

				this.setAttribute("position", "end_before");
			else
				this.setAttribute("position", "after_start");
			
		}
	}	
};

dtxFramework.MenuPopup.prototype.$hookEvents = function() {
	dtxFramework.XULWrapper.prototype.$hookEvents.apply(this);
	
	this.$domNode.removeEventListener("popupshowing", this.$onBeforeShow, false);
	this.$domNode.addEventListener("popupshowing", this.$onBeforeShow, false);

	this.$domNode.removeEventListener("popuphiding", this.$onClose, false);
	this.$domNode.addEventListener("popuphiding", this.$onClose, false);

	this.$domNode.removeEventListener("click", this.$onCancelEvent, false);
	this.$domNode.removeEventListener("mousedown", this.$onCancelEvent, false);
	this.$domNode.removeEventListener("mouseup", this.$onCancelEvent, false);
	this.$domNode.addEventListener("click", this.$onCancelEvent, false);
	this.$domNode.addEventListener("mousedown", this.$onCancelEvent, false);
	this.$domNode.addEventListener("mouseup", this.$onCancelEvent, false);
	
};

dtxFramework.MenuPopup.prototype.$setParent = function(node) {
	dtxFramework.XULWrapper.prototype.$setParent.apply(this, [node]);
};

dtxFramework.MenuPopup.prototype.$createDOMNode = function() {
	var popup = document.createElement("menupopup");
	var popupContainer = null;
	/*
	if (this.parentNode.tagName != "menu")
		popupContainer = this.$framework.getPopupContainer();
	*/
	if (popupContainer == null && this.parentNode != null)
		popupContainer = this.parentNode.$domNode;
	if (popupContainer == null)
		popupContainer = this.$framework.getPopupContainer();
	if (popupContainer == null)
		return null;
	popupContainer.appendChild(popup);
	return popup;
};

//$MOZILLA_END$//