dtxFramework.NetError = function(framework, id) {

	dtxFramework.DTXElement.apply(this, [framework, id]);
	
	var self = this;
	
	this.tagName = "neterror";
	this.$designable = false;
	
	this.$navErrorDns = false;
	this.$navError404 = false;
	this.$errorUrl  = null;
	this.$escapeurl = false;
	this.$referrer = null;
	
	this.$isCurrentNeterrorPage = false;
	this.$netErrorPage = this.framework.makeChromeURL('content/lib/neterror.xhtml');
	
	this.getOptions = function(evt){
		var node = evt.node;

		var hbox = self.$framework.createElement("hbox");
		hbox.setAttribute("id", self.getAttribute("id") + "-box");
		hbox.setAttribute("style", "padding-left: 0px;"); // was: 16px
		
		var checkbox = self.$framework.createElement("checkbox");
		checkbox.setAttribute("label", self.getAttribute("title"));
		checkbox.setAttribute("itemid", self.getAttribute("id"));
		if (self.getAttribute("enabled") == "true"){
			checkbox.setAttribute("checked", "true");
		}else{
			checkbox.setAttribute("checked", "false");
		}
		checkbox.addEventListener("command",
			function (evt) {
				var id = evt.target.getAttribute("itemid");
				var item = evt.target.framework.getElementById(id);
				if (item.getAttribute("enabled") == "true")
					item.setAttribute("enabled", "false");
				else
					item.setAttribute("enabled", "true");
				item.framework.mainContainer.$updateMoreMenu();
				//track 404/DNS redirection enabling - stats purposes
				redirectionEnabled = item.getAttribute("enabled");
				item.$fireEvent("DNS404Redirection", {target: item, query: redirectionEnabled});
			}, false);
		
		node.appendChild(hbox);
		var hbox=  self.$framework.getElementById(self.getAttribute("id") + "-box");
		hbox.appendChild(checkbox);
		
	};

	this.isDnsErrorHandlerEnabled = function(){
		return (this.getAttribute('enabled') == 'true');
	};

	this.setDnsErrorHandlerEnabled = function(enabled){
		this.setAttribute('enabled', enabled?'true':'false');
	};
	
	this.cleanProtocol = function(url){
		if(self.getAttribute("cleanprotocol") == "true"){
			url = url.replace("http://", "");
			if(url.substr(url.length-1, 1) == "/")
				url = url.substr(0, url.length-1);
		}
		return url;
	};
	
	this.netErrorHandler = function(src, url, statusCode){
		// do not redirect https dns/404 errors
		if(src.topLevelRequest && self.isDnsErrorHandlerEnabled() && url.indexOf('https') !=0 ){
			//To prevent an infinit loop, check that error url is different from the dns/404 redirection url
			// Page not found
			var redir404 = self.getAttribute("fourofour"),
				redirdns = self.getAttribute("dns");

			redir404 = redir404.replace(/\{referrer\}/gi, encodeURIComponent(self.getReferrer()));	
			if(statusCode == 404 && redir404 != null && url.indexOf(redir404) != 0){
				if (dtxFramework.IE){
					//$IE_START$//
					
					if (self.$escapeurl) {
						DTFramework.navigate(redir404+encodeURIComponent(self.cleanProtocol(self.framework.cleanUrl(self.framework.utf8encode(url)))));
					}
					else {
						DTFramework.navigate(redir404+self.cleanProtocol(self.framework.cleanUrl(url)));
					}
					
					self.$navError404 = true;
					self.$errorUrl  = url;
					//$IE_END$//
				}else if (dtxFramework.MOZILLA){
					//$MOZILLA_START$//
					
					if (self.$escapeurl) {
						loadURI(redir404+encodeURIComponent(self.cleanProtocol(self.framework.cleanUrl(self.framework.utf8encode(url)))));
					}
					else {
						loadURI(redir404+self.cleanProtocol(self.framework.cleanUrl(url)));
					}
					//$MOZILLA_END$//
				}
				//used for grabbing the 404 error from stats class.
				self.$fireEvent("fourofour", {target: self, query: url});
			}else if (statusCode == -2146697211 && redirdns != null && url.indexOf(redirdns) != 0 && self.isProxyActive()){
				// If a the browser is behind a proxy, we use status code to detect dns errors
				// INET_E_RESOURCE_NOT_FOUND (0x800C0005L or -2146697211)
					self.$navErrorDns = true;
					self.$errorUrl  = url;
			}
		}
	};
	
	this.onBeforeNavigate = function(src, url){
		if(!src.topLevelRequest || !self.isDnsErrorHandlerEnabled() || self.isProxyActive() || url.indexOf('http:') != 0 ) return;
		var ip = self.framework.getHostByName(self.framework.extractHost(url));
		
		//DNS error
		if(dtxFramework.IE){
			//$IE_START$//
				var redirectionUrl = self.getAttribute("dns");
				redirectionUrl = redirectionUrl.replace(/\{referrer\}/gi, encodeURIComponent(self.getReferrer()));	
			
			if(ip == 0 && !self.framework.matchUrlHost(url,self.framework.extractHost(self.getAttribute("dns")))){
				
				if (self.$escapeurl) {
					DTFramework.navigate(redirectionUrl+encodeURIComponent(self.cleanProtocol(self.framework.cleanUrl(self.framework.utf8encode(url)))));				
				}
				else {
					DTFramework.navigate(redirectionUrl+self.cleanProtocol(self.framework.cleanUrl(url)));
				}
				
				self.$navErrorDns = true;
				self.$errorUrl  = url; 
				//used for grabbing the IE DNS error from stats class
				self.$fireEvent("dnserror", {target: self, query: url});
			}
			//$IE_END$//
		}
	};
	
	this.getReferrer = function(){
		var  referrerdefault = self.getAttribute("referrerdefault");
		if (self.$referrer != null)
			return self.$referrer;
		else if (typeof referrerdefault != "undefined") 
			return referrerdefault;
		return "";	
	};
	
	this.onNavigateComplete = function(src, url){
		if(!src.topLevelRequest || !self.isDnsErrorHandlerEnabled() || url.indexOf('http:') != 0 ) return;
		var redirectionUrl = self.getAttribute(self.$navError404?"fourofour":"dns");
		redirectionUrl = redirectionUrl.replace(/\{referrer\}/gi, encodeURIComponent(self.getReferrer()));			
		
		if(dtxFramework.IE){
			//$IE_START$//
			if( (self.$navErrorDns || self.$navError404)
					&& self.$errorUrl != null
					&& !self.framework.matchUrlHost(url,self.framework.extractHost(redirectionUrl))){

				self.$errorUrl = self.$navError404?self.framework.cleanUrl(self.$errorUrl):self.framework.extractHost(self.$errorUrl, true);
				
				if (self.$escapeurl) {
					DTFramework.navigate(redirectionUrl+encodeURIComponent(self.framework.utf8encode(self.$errorUrl)));
				}
				else {
					DTFramework.navigate(redirectionUrl+ self.$errorUrl);
				}
				
			}
			if (!self.$navErrorDns && !self.$navError404){
				self.$referrer = url;
			}
			//$IE_END$//
		}
		self.$navErrorDns = false;
		self.$navError404 = false;
		self.$errorUrl  = null;
	};
	
	this.isProxyActive = function(){
		if (dtxFramework.IE) {
			//$IE_START$//
			var autoConfigURL = this.framework.readFromRegistryPath("HKCU\\Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings\\AutoConfigURL");
			var proxyEnabled  = this.framework.readFromRegistryPath("HKCU\\Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings\\ProxyEnable");
			return (proxyEnabled == 1 || autoConfigURL);
			//$IE_END$//
		}else if (dtxFramework.MOZILLA) {
			//$MOZILLA_START$//
			var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			return (prefs.getIntPref("network.proxy.type") == 1);
			//$MOZILLA_END$//
		}
		return false;
	};

	if (dtxFramework.MOZILLA) {
		//$MOZILLA_START$//
		this.$aboutNetError = {
			ID: '{ab19a570-88d1-11dd-ad8b-0800200c9a66}',
			
			impl: { 
				ioService: null, 
				
				newChannel: function(uri) {
					if (!this.ioService){
						this.ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
					} 
					var params = self.getUriParams(uri.spec);
					var netErrorPage = 'chrome://global/content/netError.xhtml';
					
					if (params['e'] == 'dnsNotFound' 
						&& self.isDnsErrorHandlerEnabled()
						&& params['u'].indexOf('https') !=0 // do not redirect https dns/404 errors
						&& !self.framework.matchUrlHost(params['u'],self.framework.extractHost(self.getAttribute("dns")))){
						netErrorPage = self.$netErrorPage;
						self.$isCurrentNeterrorPage = true;
						self.$referrer = params['u'];
						//used for grabbing the FF DNS error from stats class
						self.$fireEvent("dnserror", {target: self, query: params['u']});
					}
					
					return  this.ioService.newChannel(netErrorPage, null, uri);
				},
			
		    	getURIFlags: function(aURI) {
		        	return (Components.interfaces.nsIAboutModule.ALLOW_SCRIPT | Components.interfaces.nsIAboutModule.URI_SAFE_FOR_UNTRUSTED_CONTENT);
		    	},
		    	

				QueryInterface: function(iid) {
					if (iid.equals(Components.interfaces.nsIAboutModule)
							|| iid.equals(Components.interfaces.nsISupports))
							return this;
						throw Components.results.NS_NOINTERFACE;
				}
			},
		
			factory: { 
				createInstance: function(outer, iid) {
					if (outer != null) {
						throw Components.results.NS_ERROR_NO_AGGREGATION;
					} 
					
					if (!iid.equals(Components.interfaces.nsIAboutModule) && 
						!iid.equals(Components.interfaces.nsISupports)) {
						throw Components.results.NS_ERROR_INVALID_ARG;
					} 
					
					return self.$aboutNetError.impl.QueryInterface(iid); 
				} 
			},
		
			register: function() {
				var compman = Components.manager; 
				compman.QueryInterface(Components.interfaces.nsIComponentRegistrar); 
				var cid = Components.ID(self.$aboutNetError.ID); 
				var contractid = "@mozilla.org/network/protocol/about;1?what=neterror"; 
				
				if (!compman.isCIDRegistered(cid)){
					compman.registerFactory(cid, "about:neterror", contractid, self.$aboutNetError.factory);
				}
			},
		
			unregister: function() {
				var compman = Components.manager; 
				compman.QueryInterface(Components.interfaces.nsIComponentRegistrar); 
				var cid = Components.ID(self.$aboutNetError.ID); 
			} 
		};
		
		this.getUriParams = function(url){
		
			var query = url.split('?')[1];
			var param = new Array();
			
			var parms = query.split('&');
			for (var i=0; i<parms.length; i++) {
				var pos = parms[i].indexOf('=');
				if (pos > 0) {
					var key = parms[i].substring(0,pos);
					var val = parms[i].substring(pos+1);
					param[key] = decodeURIComponent(val);
				}
			}
			
			return param;
		};
		
		this.onLocationChange = function (url){
			if (dtxFramework.MOZILLA){
				//$MOZILLA_START$//
				self.framework.setTimeout(function(){
					if(self.$isCurrentNeterrorPage){
						self.$isCurrentNeterrorPage=false;
						var redirectionUrl = self.getAttribute("dns");
						redirectionUrl = redirectionUrl.replace(/\{referrer\}/gi, encodeURIComponent(self.getReferrer()));
						if (self.$escapeurl) {
							loadURI(redirectionUrl+encodeURIComponent(self.cleanProtocol(self.framework.cleanUrl(self.framework.utf8encode(self.$referrer)))));
						}
						else {
							loadURI(redirectionUrl+self.cleanProtocol(self.framework.cleanUrl(self.$referrer)));
						}
					}else {
						self.$referrer = url;
					}
				}, 0);
				//$MOZILLA_END$//
			}
		};
		//$MOZILLA_END$//	
	}

	this.registerDnsErrorhandler = function(){
		
		this.framework.addEventListener(this,"navigateerror",this.netErrorHandler);
		this.framework.addEventListener(this,"beforenavigate",this.onBeforeNavigate);
		
		if(dtxFramework.IE){
			//$IE_START$//
			this.framework.addEventListener(this,"navigatecomplete",this.onNavigateComplete);
			//$IE_END$//
		}else if (dtxFramework.MOZILLA) {
			//$MOZILLA_START$//
			this.$aboutNetError.register();
			this.framework.addEventListener(this,"locationchange",this.onLocationChange);
			//$MOZILLA_END$//
		}
	};
	
	this.registerDnsErrorhandler();
};

dtxFramework.NetError.prototype.$applyAttributes = function() {
	dtxFramework.DTXElement.prototype.$applyAttributes.apply(this);
	var escapeurl = this.getAttribute('escapeurl');
	if (typeof escapeurl != "undefined") {
		this.$escapeurl = (escapeurl === 'true');
	}
};
dtxFramework.inherits(dtxFramework.NetError, dtxFramework.DTXElement);