dtxFramework.PrefWindow = function(framework, id) {

    // inheritance
    dtxFramework.Window.apply(this, [framework, id]);

    this.tagName = "prefwindow";
    this.$loaded = false;
    this.$panels = null;
    this.$tabs = null;
    this.$currentIndex = -1;
    this.setAttribute("id", "prefwin");
    var self = this;
    
    this.selectTabById = function(tabId) {
		var tab = this.getElementById(tabId);
		var i = 0;
		for (var i = 0; i < this.$panels.length; i++) {
			var panel = this.$panels[i];
			if(this.$panels[i].$id == tabId){
			 	this.$selectTab(i);				
				panel.setAttribute("hidden", "false");
			}else
				panel.setAttribute("hidden", "true");
		}
    };
    
    this.selectTabByFeatureId = function(featureId) {
		var i = 0;
		for(; i < this.$panels.length && this.$panels[i].getAttribute('for') != featureId; i++);
		if (i < this.$panels.length)
			this.$selectTab(i);
    };
    
    this.$selectTab = function(index) {
        if (this.$currentIndex != -1) {
        	for (var i = 0; i < this.$panels.length; i++) {
          		var tmpPanel = this.$panels[i];
          		if(i !=  index){
            		tmpPanel.setAttribute("hidden", "true");
             		this.$tabs[i].$domNode.style.backgroundColor = "";
           		}
        	}
		}
		var tab = this.$tabs[index];
		tab.$domNode.style.backgroundColor = "#c1d2ee";
		var panel = this.$panels[index];
		panel.setAttribute("hidden", "false");
		panel.$fireEvent("select", {target: panel});
		
		this.$currentIndex = index;
    };
 
	this.addEventListener("beforeshowing", 
		function() {	
			if (self.$loaded)
				return;
			
			// get panels in window		
			var panels = new Array();
			for (var i = 0; i < self.childNodes.length; i++) {
				var node = self.childNodes[i];
				if (node.tagName == "prefpane") {
					panels.push(node);
				};
			}
			
			// get custom panels
			framework.mainContainer.forEach(
				function(element) {
					var evtObj = {result: null};
					element.$fireEvent("getprefpane", evtObj);
					if (evtObj.result) {
						panels.push(evtObj.result);
					}
				});
						
			self.$panels = panels;
			self.$tabs = new Array();
			
			var topRow = framework.createElement("hbox");
			topRow.setAttribute("style", "width: 100%; background-color: White; border-bottom: solid 1px gray");
			var tabsContainer = framework.createElement("hbox");
			tabsContainer.setAttribute("style", "width: 50px; margin-left: 20px");
			var panelContainer = framework.createElement("hbox");			
			//panelContainer.setAttribute("style", "padding: 10px; padding-left: 20px; background-color: ThreeDFace; width: 100%; height: 100%;");
			panelContainer.setAttribute("class", "dtx-prefwindow-panelContainer");
			panelContainer.setAttribute("flex", "1");
			
			for (var i = 0; i < panels.length; i++) {
				var panel = panels[i];
				
				// add tab
				var tab = framework.createElement("vbox");
				tab.setAttribute("style", "padding: 0px; margin: 0px;text-align:center;");
				var image = framework.createElement("image");
				var flexer = framework.createElement("hbox");
				flexer.setAttribute("flex", "1");
				tab.appendChild(flexer);
				var box = framework.createElement("hbox");
				flexer = framework.createElement("hbox");
				flexer.setAttribute("flex", "1");
				box.appendChild(flexer);
				image.setAttribute("style", "margin-top: 5px; margin-left: 10px; margin-right: 10px; margin-bottom: 5px");
				image.setAttribute("src", panel.getAttribute("image"));
				//uncommented by supita - BEGIN: size of the image needed to apply the fixPng in ie6
				//image.setAttribute("width", "32");
				//image.setAttribute("height", "32");
				//image.setAttribute("maxwidth", "32");
				//uncommented by supita - END: size of the image needed to apply the fixPng in ie6
				box.appendChild(image);
				flexer = framework.createElement("hbox");
				flexer.setAttribute("flex", "1");
				box.appendChild(flexer);
				flexer = framework.createElement("hbox");
				flexer.setAttribute("flex", "1");
				tab.appendChild(flexer);
				var label = framework.createElement("label");
				label.setAttribute("value", panel.getAttribute("label"));
				label.setAttribute("style", "padding: 10px; padding-top: 0px; text-align: center");
				tab.appendChild(box);
				tab.appendChild(label);
				tab.setAttribute("tabIndex", i);
				tabsContainer.appendChild(tab);
				self.$tabs.push(tab);
				tab.addEventListener("click",
					function(evt) {
						var index = new Number(evt.target.getAttribute("tabIndex"));
						self.$selectTab(index);
					});
				
				// add panel
				self.removeChild(panel);
				panel.setAttribute("style", "margin: 10px; margin-top: 0px");
				panel.setAttribute("hidden", "true");
				panelContainer.appendChild(panel);
					
				// add UI elements to panel
				var elementId = panel.getAttribute("for");
				var element = framework.getElementById(elementId);
				var isEmpty = false;
				if (element != null) {
					var count = panel.childNodes.length;
					element.$fireEvent("getoptions", {
						target: element, 
						node: panel, 
						full: true, 
						window: self.$domWindow,
						document: self.$document});
					isEmpty = panel.childNodes.length == 0;
					if (isEmpty) {
						count = panel.childNodes.length;
						element.$renderOptions(panel);
						isEmpty = panel.childNodes.length == count;
					}
				}
				else
					isEmpty = true;
				if (isEmpty) {
					var label = framework.createElement("label");
					label.setAttribute("value", self.framework.localize("There are no options for this feature"));
					panel.appendChild(label);
				}
			}
			
			topRow.appendChild(tabsContainer);
			self.appendChild(topRow);
			self.appendChild(panelContainer);
			
			self.$loaded = true;
		});
		
	this.addEventListener("aftershowing", 
		function() {	
			if (self.$loaded && self.$tabs.length > 0) {
				var selected = self.getAttribute("selected");
				if (typeof selected == "string" && selected != "")
					self.selectTabById(selected);
				else
					self.selectTabById(framework.mainContainer.getAttribute('id') + "-preferences-general");
			}
		});
		
};

dtxFramework.inherits(dtxFramework.PrefWindow, dtxFramework.Window);

