
dtxFramework.Searchbar = function(framework, id) {
	// inheritance
	dtxFramework.DTXElement.apply(this, [framework, id]);

	// self !!!
	var self = this;
    //additional attributes to localize
    this.$localeAttributes = this.$localeAttributes.concat(["label","title","tooltiptext"]);

//debugger;
		
	//--------------------------------------
	//
	// BEGIN: Autocomplete support classes 
	//

	//
	// CHistory
	//
	// public methods:
	//   Load	- loads search history from a configuration file, returns no value
	//   Add	- adds a new entry to the toolbar's search history, returns no value
	//   Clear  - clears the toolbar's search history, returns no value
	//

	var CHistory = function(AOwner) {
		this.Owner = AOwner;				// The owner is Searchbar, not a CAutocomplete instance!
		var Me = this;

		var $PATH_SEARCH		= "search\\";
		var $FILENAME_HISTORY	= "-history.xml";
		
		this._history		= [];
		var _historyXML		= null;
		var historyFileName	= $PATH_SEARCH + this.Owner.$id + $FILENAME_HISTORY;

		this.getItems	= function() { return this._history; };
		this.getXML		= function() { return _historyXML; };
		
		
		this.getFilePath = function(){
			var path = "";
			
			//$MOZILLA_START$//
			var service_ = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
			var ProfilePath = service_.get("ProfD", Components.interfaces.nsIFile).path;
			var separator = (ProfilePath.indexOf('/')>=0) ?'/':'\\';
			path = (ProfilePath + "\\" + self.framework.dataFolder +"\\" + historyFileName);
			if(separator == "/")
				path = path.replace(/\\/g, "/");
			else
				path=path.replace(/\//g, "\\");		
			//$MOZILLA_END$//
			
			return path;
		};

	
		// Extracts the search history entries from XML data and puts them in an array.
		function Parse() {
			Me._history.length = 0;
			
			var lastSearchEngineId = "";
			if (_historyXML) 
			{
				var last = unescape(_historyXML.documentElement.getAttribute("last"));
				var nodes = _historyXML.documentElement.childNodes;
				for (var i = 0; i < nodes.length; i++) 
				{
					var node = nodes[i];
					if (node.nodeType == 1) // What is 1 ???
					{
						var nodeQuery = unescape(node.getAttribute("query"));
						if (node.nodeName === "search" && nodeQuery.replace(/ /, "") !== "") 
						{
							Me._history.push({
								query:	node.getAttribute("query"),
								engine:	node.getAttribute("engine")
							});
							
							if (nodeQuery == last)
								lastSearchEngineId = node.getAttribute("engine");
						}
					}
				}
			}
			
			var lastSearchBtn = Me.Owner.$lastSearchBtn;
			if (lastSearchBtn) {
				if (lastSearchEngineId != "") {
					lastSearchBtn.setAttribute("hidden", "false");
					lastSearchBtn.setAttribute("image", Me.Owner.$getEngineById(lastSearchEngineId).icon);
				}
				else {
					lastSearchBtn.setAttribute("hidden", "true");
				}
			}
			
			Me.Owner.$lastSearchEngineId = lastSearchEngineId;
		} // Parse

		
		// Loads the search history data from a file.
		this.Load = function() {
			var history = self.framework.loadFile(historyFileName);
			if (history)
				var _historyXML = self.framework.loadXML(history);
			else
				var _historyXML = self.framework.loadXML("<search-history />");
			
			Parse();
		};

		// Adds a new entry to the search history.
		this.Add = function(searchTerms, url, engineId) {
		};
		
		
		// Removes all the entries from the search history.
		this.Clear = function() {
			var _historyXML = self.framework.loadXML("<search-history />");
			Parse();

			var path = Me.getFilePath();
			if (self.framework.$fileExists(path)) {
				try{
					self.framework.$deleteFile(path);
				} catch(ex) {}
			}
		};

		// Call initialization function(s)
		this.Load();
	};
	
	//
	// CAutocomplete
	//
	// public methods:
	//
	
	var CAutocomplete = function(AOwner) {
		this.Owner = AOwner;			// The owner is Searchbar
		var Me = this;
		
		
		function getAttrBoolean(sAttrName, bDefault) {
			var bAttrVal = bDefault || false;
			var b = Me.Owner.getAttribute(sAttrName.toLowerCase());
			if (b != undefined) bAttrVal = ("true" == b);				// Use the config value only when "b" is *not* undefined
			return bAttrVal;
		}

		function getAttrInt(sAttrName, iDefault) {
			var iAttrVal = Me.Owner.getAttribute(sAttrName.toLowerCase());
			return iAttrVal || iDefault;
		}


		var bSuggestEnabled  = getAttrBoolean("suggest"); 										// TEMP FIX until templates will work well
		var bSponsorsEnabled = getAttrBoolean("sponsor"); 										// TEMP FIX until templates will work well

		this.getSuggestEnabled = function() {
			//return bSuggestEnabled;
			return getAttrBoolean("suggest");
		};
		
		this.getSponsorsEnabled = function() {
			//return bSponsorsEnabled;
			return getAttrBoolean("sponsor");
		};

		
		// bAlwaysShowSponsorsSection (alwaysshowsponsorssection in toolbar.xml)
		//   true	= The 'Sponsors' section is always shown, even when there are no results found for a search term.
		//   false	= The 'Sponsors' section is hidden until any result would be available to show.

		//var bAlwaysShowSponsorsSection = getAttrBoolean("AlwaysShowSponsorsSection", true);		// TEMP FIX until templates will work well
		this.getAlwaysShowSponsorsSection = function() {
			//return bAlwaysShowSponsorsSection;
			return getAttrBoolean("AlwaysShowSponsorsSection", true);
		};
		
		var MaxSponsorItems = 2;	// How many sponsored items to display in the popup 
		var MinSuggestLength = getAttrInt("MinSuggestionQueryLength", 2);
		
		this.getDropdownDisabled = function() { 
			//return bDropdownDisabled;
			return getAttrBoolean("DisableDropdown");
		};
	

		// Section type flags for building the autocompletion popup contents
		var stHistory		= 0;
		var stSuggestions	= 1;
		var stSponsors		= 2;

		// Other flags
		var $AUTOCOMPLETE_POPUP_TIMEOUT		= 500;
		var $SUGGESTIONS_REQUEST_TIMEOUT	= 500;
		var $HISTORY_DISPLAY_LENGTH			= 10;

		var $ID_AUTOCOMPLETE_POPUP_BODY		= "-autocomplete-body";
		var $ID_AUTOCOMPLETE_POPUP			= "-autocomplete";
		var $ID_HISTORY_CONTAINER			= "-history";
		var $ID_HISTORY_LABEL				= "-history-label";
		var $ID_SUGGESTIONS_LABEL			= "-suggestions-label";
		var $ID_SUGGESTIONS_CONTAINER		= "-suggestions";
		var $ID_SPONSORS_LABEL				= "-sponsors-label";
		var $ID_SPONSORS_CONTAINER			= "-sponsors";
		var $ID_AUTOCOMPLETE_DIVIDER		= "-divider";

		this.$Popup			= null;			// Search popup list 
		
		var $DEFAULT_POPUP_HEIGHT			= 300;
		var $MIN_POPUP_WIDTH				= 150;
		var $MAX_POPUP_WIDTH				= 600;
		var $MIN_POPUP_HEIGHT				= 50;
		var $MAX_POPUP_HEIGHT				= 600;
		

		this.$getItems = function () { return null; };	// Fix for 6488

		var _autocompleteIndex		= -1;
		var _autocompleteLength		= 0;

		
		this.History = new CHistory(AOwner);		
		
		function getDocument() 
		{
			if (!this.$Popup) return null;
			
			if (dtxFramework.MOZILLA) {
				return document;
			} else {
				return null;
			}
		}

		
		function ClearItems() 
		{
			//arAutocompleteItems.length = 0;
			//_autocompleteIndex	= -1;
			//_autocompleteLength	= 0;
			//_autocompleteLast	= null;
		}


		this.getCurrentSearchItemProps = function() 
		{
			var sQuery	  = Me.Owner.$textbox.value;
			var sClickUrl = '';
			var iEngineID = null;
			var bCopyText = true;		

			sQuery = sQuery.replace(/^\s+|\s+$/g, ''); // Trim spaces at the right and left to prevent empty search from launching.
			
			return {
				sQuery   : sQuery,
				iEngineID: iEngineID,
				sClickUrl: sClickUrl,
				bCopyText: bCopyText
			};
		};


		// BEGIN: Helper functions for CAutocomplete.Show 
		
		function initDocObjRefs() 
		{
			var doc = getDocument();
			
			if (dtxFramework.MOZILLA) {
				try {	//Bug 16308
					this.$Popup.$domNode.onclick = function(evt) { 
						focusTextboxWithoutSelection();
						return true;
					};
					this.$Popup.$domNode.oncontextmenu = function(evt) {
						focusTextboxWithoutSelection();
						evt.preventDefault();
						return false;
					};
				} catch(e) {}
			}
		}
		function focusTextboxWithoutSelection(evt){
			Me.Owner.$textbox.focus(); 
			Me.Owner.$textbox.setAttribute("value", Me.Owner.$textbox.value);  
		};
		function onPopupResize(evt) 
		{
			var doc = getDocument(); 
			var elt = doc.getElementById(Me.Owner.$id + '-Content');
			if (dtxFramework.MOZILLA) {
				var box = this.$Popup.$domNode.boxObject;
				var w = parseInt( box.width  ? box.width  : this.$Popup.getAttribute("width") );
				var h = parseInt( box.height ? box.height : this.$Popup.getAttribute("height") );
				
				if (w < $MIN_POPUP_WIDTH) {w = $MIN_POPUP_WIDTH;} else if (w > $MAX_POPUP_WIDTH) {w = $MAX_POPUP_WIDTH;}
				if (h < $MIN_POPUP_HEIGHT) {h = $MIN_POPUP_HEIGHT;} else if (h > $MAX_POPUP_HEIGHT) {h = $MAX_POPUP_HEIGHT;}
				
				elt.style.width  = (w - 10) + "px";
				elt.style.height = (h - 18) + "px";

				this.$Popup.setAttribute("width", w);
				this.$Popup.setAttribute("height", h);
			}
		}
		
		function onPopupLoad(evt) 
		{
			onPopupResize(evt);
		}
		
		function onPopupItemClick(index, iSearchType) 
		{
			Me.Owner.$doSearch(false);
		}
		
		function onPopupClearHistoryClick() 
		{
			Me.History.Clear();
			Me.Hide();
			Me.Owner.$textbox.value = "";
		}

		function PopupHiliteRow(newIndex, bScroll) {
		
		}

		
		function onPopupMouseOver(evt) 
		{
			evt = evt || getDocument().parentWindow.event;
			var elt;
			if (evt.target)
				elt = evt.target;
			else
				elt = evt.srcElement;

			// Check if the given HTML element 'elt' belongs to one of the suggestion items, 
			// and if so, highlight this item's row. 
			var ix = -1;
			if (elt) {
				do {
					// IE has elt.tagName value in UPPERCASE, FF has it in lowercase. 
					if (elt.tagName.toUpperCase() == 'A' && elt.getAttribute('isSuggestion') == "true") {
						ix = parseInt(elt.id.match(/\d+/)[0], 10);
						ix = isNaN(ix) ? -1 : ix;
						break;
					}

					elt = elt.parentNode;
				} while (elt && elt.tagName);
			}

			PopupHiliteRow(ix);
		}
		

		if (dtxFramework.MOZILLA) {
			this.onPopupItemClickFF = function(index, iSearchType) {
				index = parseInt(index, 10);
				onPopupItemClick(index, iSearchType);
			};
			
			this.onPopupClearHistoryClickFF = function () {
				onPopupClearHistoryClick();
			};
		}
		// end: leonidb 3.apr.2009
		// END: Helper functions for CAutocomplete.Show 
		
		this.$positionToOwner = function(oOwner, dx, dy) {
            var width = Me.Owner.getAttribute("width");
            var height = $DEFAULT_POPUP_HEIGHT;
            
            var oOwnerLeft = window.screenLeft;
            var oOwnerTop = window.screenTop;
            
            var offsParent = oOwner.$domNode;
            while (offsParent != null) {
                oOwnerLeft += offsParent.offsetLeft;
                oOwnerTop += offsParent.offsetTop;
                offsParent = offsParent.offsetParent;
            }
            
            var oOwnerWidth = oOwner.$domNode.offsetWidth;
            var oOwnerHeight = oOwner.$domNode.offsetHeight;
            
            dx += 3;
            dy -= 1;
            
            return this.positionToOwnerCommon({left: oOwnerLeft, top: oOwnerTop, width: oOwnerWidth, height: oOwnerHeight}, dx, dy, 10);
        };
        
        this.positionToOwnerCommon = function(oOwnerBox, dx, dy, yAdjust) {
            var x, y;
            var width = Me.Owner.getAttribute("width");		
            var height = $DEFAULT_POPUP_HEIGHT;
                    
            var screenWidth = window.screen.availWidth;
            var screenHeight = window.screen.availHeight;
        
                
            if(oOwnerBox.left + dx + width <= screenWidth) {
                x = oOwnerBox.left + dx;
            }
            else {
                x = oOwnerBox.left - width - dx + oOwnerBox.width;
            }
            
                    
            if(oOwnerBox.top + dy + height + 3<= screenHeight) {
                y = oOwnerBox.top + dy + 3;
            }
            else if (oOwnerBox.top + oOwnerBox.height - height - dy >= 0){
                y = oOwnerBox.top + oOwnerBox.height - height - dy + yAdjust;
            } else {
                var d1  = oOwnerBox.top + dy + height - screenHeight;
                var d2 = height - (oOwnerBox.top + oOwnerBox.height - dy);
                    
                if(d1 < d2) {
                    y = oOwnerBox.top + dy;
                } else {
                    y = oOwnerBox.top + oOwnerBox.height - height - dy + yAdjust;
                }			
            }
            return {x: x, y: y};	
        };
		
		this.Show = function() 
		{
			return; //function is not firefox 40+ compatible.
		};

		
	    function ClearTimeouts() {		        
	    }
		
		
		this.Hide = function()
		{
			ClearItems();
		    if (!this.$Popup) return;
		    ClearTimeouts();
		        
			if (dtxFramework.MOZILLA) {
				/*$MOZILLA_START$*/ 
				if (typeof this.$Popup.$domNode.hidePopup != "undefined")
					this.$Popup.$domNode.hidePopup();
				/*$MOZILLA_END$*/
			}
		};
		

		this.Update = function() 
		{
			try {
			ClearItems();
			
			var textbox		= Me.Owner.$textbox;
			var searchTerms	= textbox.value.toUpperCase();
			var control		= Me.Owner.$domNode;
			var engineIcon	= Me.Owner.$engineIcon;

			//
			// begin: leonidb 3.apr.2009
			//
			
			
			
			//var sTextboxValue = textbox.value.replace(/[\\^=:;.*+?!()|{,}[\u005d\\]/g, '\\$&');	// Escape possible regexp control chars from the source string
			//alert(sTextboxValue);
			
			
			// Elements to be used to highlight matching substrings in the history/suggestions.
			// We check if there's any word in a suggestion text *starting* with the textbox.value text,
			// and highlight such a word.
			var reWordsBeginWith = new RegExp(textbox.value, 'gi'); // This will highlight any matching substring in an autocomplete string (not the beginning of the words)
			var itemCount = 0;
			
		    // Creates a line in the search popup window:
			function MakeLine(index, sQueryObj, imgSrc, iSearchType, bSectionStart, bEscapeTags) 
			{
				return "";
			}//MakeLine
			

			var sList, i, imgSrc;
			
			//
			// FF EVENT HANDLERS FIX
			// Instead of IE, FF doesn't recognize href="javascript:..." we put here in the document.
			// We need to attach OnClick event handlers using the same functions and parameters:
			//
			if (dtxFramework.MOZILLA) {
				var doc = getDocument();
				var links = doc.getElementsByTagName('a');
				var re = /(\d+),(\w+)/;  
				
				for (var i = 0; i < links.length; i++) {
					//
					// This code assumes there are 2 link handling function types can be in the document: 
					// 1. Having a number and a boolean value as parameters - it is considered to be onPopupItemClick.
					//    The params variable (see the code below) receives the values of these params if they exist.
					// 2. Having no parameters - it is considered to be onPopupClearHistoryClick.
					//
					// We need to add extra checks if in case we want to use another function(s).
					//
					var params = re.exec(links[i].href);
					if (params) {
						// Case #1
						links[i].setAttribute('list_index', params[1]);
						links[i].setAttribute('list_is_history', params[2]);
						
						links[i].addEventListener('click', 
							function() {
								Me.onPopupItemClickFF(this.getAttribute('list_index'), this.getAttribute('list_is_history')); 
							},
							false
						);

						links[i].addEventListener('mouseover', onPopupMouseOver, false);
					} else {
						// Case #2
						links[i].addEventListener('click', Me.onPopupClearHistoryClickFF, false);
					}
				}
			}

			//
			// end: leonidb 3.apr.2009
			//
			} catch(e) {
				self.framework.getLogger().error("Searchbar suggestions update error: " + e.message);
			}
		};
		
		
		this.TogglePopup = function() {
			Me.Show(); 			// FF doesn't fire the OnClose event, so the Popup could not be properly uninitialized and always remains assigned.
								// Thus we always just call Show() to display the popup on the dropdown button click in Searchbar.
		};


		function requestSuggestions() {
			return;
		}


		function requestSponsors() {			
			return;
		}

		
		function ShowUpdatedPopup() 
		{
		}
		
		
		this.onKeyDown = function(evt) 
		{
			var keyCode = evt.keyCode;
			
			if (keyCode == 13) {
				Me.Owner.$doSearch(false);
			} 
			else if (keyCode == 27) {
				Me.Owner.$textbox.setAttribute("value", Me.Owner.$textbox.value); 
				Me.Hide();
			}
			else if (keyCode == 37 || keyCode == 39) { // Right/Left
				// ignore these keys
			}
		};
		
		
		this.onKeyUp = function(evt) 
		{
			var keyCode = evt.keyCode;
			
			ClearTimeouts();
				
			if (keyCode == 8 && Me.Owner.$textbox.value.length == 1) {		// Backspace (skanderk: mimic Google suggest behavior).
				Me.Hide();
				return;
			}
			
			// leonidb: this is already called in $onKeyDown
			//if (keyCode == 13){
			//	self.$hideAutoComplete();
			//    return;
			//}
			
			if (
				evt.altKey || evt.altLeft 
				|| evt.ctrlKey || evt.ctrlLeft 
				|| evt.shiftKey || evt.shiftLeft

				|| keyCode == 9		// Tab 
				|| keyCode == 12	// NumPad 5 when NumLock is OFF
				|| keyCode == 13	// Enter 
				|| keyCode == 16	// Shift key alone
				|| keyCode == 17	// Ctrl key alone
				|| keyCode == 19	// Pause 
				|| keyCode == 20	// CAPS 
				|| keyCode == 27	// Esc

				|| keyCode == 45	// Insert 
				|| keyCode == 144	// NumLock 
				|| keyCode == 145	// ScrollLock 

				|| (keyCode >= 33 && keyCode <= 40)		// PgUp, PgDn, End, Home, ...
				|| (keyCode >= 91 && keyCode <= 93)		// Left WIN button, Right WIN button, Windows context menu button
				|| (keyCode >= 112 && keyCode <= 123)	// F1 - F12
			) return;

			ShowUpdatedPopup();
		};
		
		/* 
		// A class function template
		this. = function() {
		};
		*/
	}; // end of CAutocomplete

	

	
	//
	// END: Autocomplete support classes 
	//--------------------------------------

	//
	// CURLSearchHook Class
	// Manage Address Bar search
	var CURLSearchHook = function($searchbar) {
		var self = this;

		// Detect Windows version
		var parts = navigator.userAgent.split(/\s*[;)(]\s*/);		// Split on ;, ( or ), removing the white-space at either side 
		var sVerOS;
		if (/^Linux/.test(parts[3]))
			sVerOS = parts[6].split("/").pop(); // "8.10" (Ubuntu)
		else
			sVerOS = parts[3].split(" ").pop(); // "6.1" (Win 7)
		
		var isXP = ('5.1' == sVerOS || '5.2' == sVerOS);			// 5.1 = XP (5.2 = XP x64 Edition or WinServer 2003)
		//var isXP = (/nt\s5\.1/gi).test(navigator.userAgent);
		//alert(['isxp=',isXP,'ver=',sVerOS]);
		
		var REG_AUTO_SEARCH_ENTRY    = "HKEY_CURRENT_USER\\Software\\Microsoft\\Internet Explorer\\URLSearchHooks\\"+$searchbar.framework.getToolbarCLSID();
		var REG_AUTO_SEARCH_DISABLED = "HKEY_CURRENT_USER\\Software\\"+(isXP?"":"AppDataLow\\Software\\")+$searchbar.framework.applicationId+"\\AutoSearchDisabled";
		var REG_AUTO_SEARCH_URL      = "HKEY_CURRENT_USER\\Software\\"+(isXP?"":"AppDataLow\\Software\\")+$searchbar.framework.applicationId+"\\AutoSearchURL";

		this.$init = function(){
			//use the existence of skipAddressBarSearch.dat as a switch to bypass the enabling of addressbar search
			if(!$searchbar.framework.fileExists("skipAddressBarSearch.dat")){
			if($searchbar.getAttribute('persist').indexOf("enableaddressbarsearch") == -1)
				$searchbar.setAttribute('persist', $searchbar.getAttribute('persist') + ' enableaddressbarsearch');
			if ($searchbar.getAttribute('activateaddressbarsearch') == 'true'){
				if($searchbar.getAttribute('addressbarurl')){
					self.setSearchBarUrl($searchbar.getAttribute('addressbarurl')+((dtxFramework.IE)?'%s':''));
				}

				if ($searchbar.getAttribute('enableaddressbarsearch') == 'true'){
					self.$enable();
				}

				$searchbar.addEventListener('attributechange', function(event){
					if(event.id == 'enableaddressbarsearch'){
						if (event.value == 'true'){
							self.$enable(); 
						}else{
							self.$disable();
						}
					}
				});

				//If this is the first time the toolbar is loaded (no preference is present) then enable address bar search if it has been activated
				if(!$searchbar.getAttribute('enableaddressbarsearch')){
					$searchbar.setAttribute('enableaddressbarsearch','true');
				}
			}
			}
		};
		
		this.$setEnabled = function(enabled){
		};
		
		this.isActive = function(){
			if (dtxFramework.MOZILLA){
				var keywordUrl = this.getSearchBarUrl();
				var engines = $searchbar.$getEngines();
				
				if($searchbar.getAttribute('addressbarurl')){
					return $searchbar.getAttribute('addressbarurl') == keywordUrl;
				}
				
				for(var i in engines){
					if(engines[i].query.indexOf(keywordUrl) >= 0) return true;
				}
				
				return false;
			}
		};

		this.isEnabled = function(){
			/* part here removed not FF 40+ compatible */
			return false;
		};

		this.$enable = function(){
			this.$setEnabled(true);
		};

		this.$disable = function(){
			this.$setEnabled(false);
		};
	
		this.setSearchBarUrl = function(url){
			if (dtxFramework.MOZILLA) {
				try
				{
					/* part here removed //not FF 40+ compatible */
				}
				catch(e) {
					$searchbar.framework.getLogger().error("key no longer supported in FF24+ :: " + e.message);
				}
			}
		};
		
		this.getSearchBarUrl = function(){
			if (dtxFramework.MOZILLA) {
				try
				{
					/* part here removed //not FF 40+ compatible */
				}
				catch(e) {
					$searchbar.framework.getLogger().error("key no longer supported in FF24+ :: " + e.message);
				}
			}
		};

		this.$init();
	};//end of CURLSearchHook
	
	
	// constants
	this.$initialized = false;
	
	this.$ID_MAIN = "-main";
	this.$ID_ENGINE_POPUP = "-engine-popup";
	this.$ID_ENGINE_POPUP_DIVIDER = "-engine-popup-divider";
	this.$ID_ENGINE_POPUP_ITEM = "-engine-popup-item";
	this.$ID_LASTSEARCH_BUTTON = "-lastsearch-button";
	this.$ID_ENGINE_ICON_CELL = "-engine-iconcell";
	this.$ID_ENGINE_NO_ICON_CELL = "-engine-noiconcell";
	this.$ID_ENGINE_ICON = "-engine-image";
	this.$ID_ENGINE_DROPDOWN ="-engine-dropdown";
	this.$ID_TEXTBOX = "-textbox";
	this.$ID_AUTOCOMPLETE_DROPDOWN_CELL = "-autocomplete-dropdownd-cell";
	this.$ID_GO = "-go";
	this.$ID_GO_CELL = "-go-cell";
	this.$ID_POPUPREFERENCE = "-popup-reference";
	this.$ID_SPLITTER = "-splitter";
	this.$ID_LASTSEARCH_POPUP = "-lastsearch-popup";
	
	this.$ATTR_ENGINES = "dtx-engines";
	this.$ATTR_SELECTED_ENGINE = "selectedengine";
	this.$ATTR_VALUE = "dtx-value";
	this.$ATTR_INDEX = "dtx-index";
	this.$ENGINE_FRAG_ID	= "search";
	
	this.$BUTTON_GO = null;
	this.$DEFAULT_WIDTH = 200;
	
	this.$ID_HIGHLIGHT_MARKER = "-highlight-marker";
	this.$ID_HIGHLIGHTER = "-highlighter";
	this.$ID_HIGHLIGHT_BTN = '-highlight-btn';
	this.$ATTR_HIGHLIGHT_TERM = "dtx-highlight-term";
	this.$ATTR_HIGHLIGHT_COLOR = "dtx-highlight-color";
	this.$MAX_HIGHLIGHT_BUTTONS = 5;
	this.$HIGHLIGHT_REQUEST_TIMEOUT = 1000;
	this.$HIGHLIGHT_COLORS = new Array(
		"lime", 
		"yellow", 
		"magenta", 
		"cyan", 
		"blue");
	this.$HIGHLIGHT_ICONS = new Array(
		"highlight_lime.png", 
		"highlight_yellow.png", 
		"highlight_magenta.png", 
		"highlight_cyan.png", 
		"highlight_blue.png");
	
	this.$EngineInfo = function () {
		this.id = "";
		this.publicId = "";
		this.shortName = "";
		this.description = "";
		this.longName = "";
		this.query = "";
		this.icon = "";
		this.geoip = "";
		this.type = "";
		this.detectURLRegEx = "";
	};
	this.$engineLoaded = false;
	
	// variables
	
	this.tagName = "searchbar";
	
    this.$resizeable = true;
	
	this.$textbox = null;
	this.$enginePopup = null;
	this.$enginePopuDivider = null;
	this.$lastSearchBtn = null;
	this.$splitter = null;
	this.$lastSearchPopup = null;
	this.$highlightMarker = null;
	this.$currentUrl = "";
	this.$lastSearchEngineId = "";
	this.$autocompleteDropDownCell = null;

	this.$engineIcon = null;
	this.$engineIconCell = null;
	this.$goCell = null;

	this.$highlighterBtn = null;
	this.$highlightButtons = null;
	this.$highlightRanges = null;
	this._highlightTimeout = null;

	this.$_engines = new Array();
	this.$customEngines = null;
	var _rivalEngines = new Array();
	

	this.setAttribute("disablemove", "true");
	
	this.$imgSearch = 'skin/lib/search-go.png';
	
	function getEventTarget(evt) {
		if (!evt) evt = self.$document.parentWindow.event;
		if (!evt) return null;
	
		if (dtxFramework.MOZILLA)
			return evt.target;
	}
	
	
	this.$clearHistory = function() {
		self.$Autocomplete.History.Clear();
	};

	
	this.$render = function() {
		var iconSrc = "";
		var engineId = this.getAttribute(this.$ATTR_SELECTED_ENGINE);
		if (typeof engineId != "string" || engineId == "") {
			// default to first engine
			if (this.$getEngines().length > 0)
				engineId = this.$getEngines()[0].id;
			else
				engineId = "";
		}
		if (engineId != "") {
			var engineInfo = this.$getEngineById(engineId);
			if (engineInfo)
				iconSrc = this.framework.makeChromeURL(engineInfo.icon);
		}
		
		var type = this.getAttribute("type");
		if (typeof type != "string" || type == "")
			type = "default";
		
		var disableDropdown = this.$Autocomplete.getDropdownDisabled();
		/*
		var disableDropdown = this.getAttribute("disabledropdown");	
		if(typeof disableDropdown != "string" || disableDropdown == "")
			disableDropdown = "false";
		disableDropdown = (disableDropdown == 'true');
		*/
			
		var imgUrl = this.getAttribute("image");			
		if (typeof imgUrl == "string" && imgUrl != "")
			this.$imgSearch = imgUrl;
			
			
		
		if (dtxFramework.MOZILLA) {
			//$MOZILLA_START$//
			
			var bDisableLeftBorder = this.getAttribute("disableleftborder") || false;

			this.$domNode.setAttribute("minwidth", "70");
			//this.$domNode.setAttribute("maxheight", "26");
			//this.$domNode.setAttribute("height", "26");
			if (this.boxObject.width != -1)
				this.$domNode.setAttribute("width", this.boxObject.width);
			
			var hbox = document.createElement("hbox");
			hbox.setAttribute("id", this.$id + this.$ID_MAIN);
			hbox.setAttribute("class", "dtx-searchbar-table");
			hbox.setAttribute("style", "padding-bottom: 1px;"  + (disableDropdown && !bDisableLeftBorder? "border-left: 1px solid #96969d;" : "") );
            hbox.setAttribute("flex", "1");
          //  hbox.setAttribute("maxheight", "22"); // FF needs this
            if (parseInt(this.framework.getBrowserVersion().substr(0,1)) >= 4 && navigator.platform.indexOf('Win') == -1){
                this.setAttribute("style", "margin-top:0px; padding:0px;");
                hbox.setAttribute("style", "height:100%; margin:0px; padding:0px;");
            }
			
			//
			// Search engines dropdown
			//
			var cell = document.createElement("hbox");
			cell.setAttribute("id", this.$id + this.$ID_ENGINE_ICON_CELL);
	
			if (type == "drop-right")
				cell.setAttribute("class", "dtx-searchbar-icon-cell-drop-right");
			else
				cell.setAttribute("class", "dtx-searchbar-icon-cell");
	
			// engine image cell
			var imgCell = document.createElement("vbox");
			
			var flexer = document.createElement("vbox");
			flexer.setAttribute("flex", "1");
			imgCell.appendChild(flexer);
		
			var img = document.createElement("image");
			img.setAttribute("id", this.$id + this.$ID_ENGINE_ICON);
			img.setAttribute("class", "dtx-searchbar-engineicon");
			if(!disableDropdown)
				img.setAttribute("src", iconSrc);
			img.setAttribute("width", "16");
			img.setAttribute("height", "16");
			if(!disableDropdown)
				imgCell.appendChild(img);

			flexer = document.createElement("vbox");
			flexer.setAttribute("flex", "1");
			imgCell.appendChild(flexer);
			
			
			cell.appendChild(imgCell);
			//hbox.appendChild(cell);
			var engineImage = cell;
			if (type == "default")
				hbox.appendChild(engineImage);
			

			// dropdown engine image
			cell = document.createElement("hbox");
			cell.setAttribute("class", "dtx-searchbar-textbox-cell");
			cell.setAttribute("id", this.$id + "-hbox-textbox-cell");
			imgCell = document.createElement("vbox");
			imgCell.setAttribute("id", this.$id + this.$ID_ENGINE_DROPDOWN);
			var flexer = document.createElement("box");
			flexer.setAttribute("flex", "2");
			imgCell.appendChild(flexer);
			
			img = document.createElement("image");
			img.setAttribute("class", "dtx-searchbar-engine-dropdown");
			if(!disableDropdown)
				img.setAttribute("src", this.framework.makeChromeURL('skin/lib/arrow-dn.gif'));
			img.setAttribute("width", "5");
			img.setAttribute("height", "3");
			img.setAttribute("flex", "0");
			if(!disableDropdown)
				imgCell.appendChild(img);

			flexer = document.createElement("box");
			flexer.setAttribute("flex", "1");
			imgCell.appendChild(flexer);
		
			cell.appendChild(imgCell);
			//hbox.appendChild(cell);
			var engineImageDropdown = cell;
			if (type == "default")
				hbox.appendChild(engineImageDropdown);

			//
			// NOTE: This hides the engine selection control, but keeps the search feature working
			//
			if (disableDropdown)
			{
				engineImage.setAttribute("hidden", "true");
				engineImageDropdown.setAttribute("hidden", "true");
			}

			// textbox
			var cell = document.createElement("vbox");
			cell.setAttribute("flex", "1");
			if (type == "drop-right")
				cell.setAttribute("class", "dtx-searchbar-textbox-cell-drop-right");
			else
				cell.setAttribute("class", "dtx-searchbar-textbox-cell");
			
			cell.setAttribute("id", this.$id + "-vbox-textbox-cell");
			var flexer = document.createElement("box");
			flexer.setAttribute("flex", "0");
			cell.appendChild(flexer);
			
			//var textbox = document.createElement("textbox");
			var textbox = document.createElementNS("http://www.w3.org/1999/xhtml","input");
			textbox.setAttribute("id", this.$id + this.$ID_TEXTBOX);
			textbox.setAttribute("class", "dtx-searchbar-textbox");
			if(this.getAttribute("backgroundimage") != "" && !this.getAttribute("value") && iconSrc.indexOf("web") != -1){
				textbox.setAttribute("style", "margin-top: 4px; background-position: center center; background-repeat: no-repeat; background-image: url('" + this.getAttribute("backgroundimage") + "')");
			}else{
				textbox.setAttribute("style", "margin-top: 3px;");
			}
			textbox.setAttribute("type", "text");
			
			cell.appendChild(textbox);

			flexer = document.createElement("box");
			flexer.setAttribute("flex", "1");
			cell.appendChild(flexer);
				
			hbox.appendChild(cell);
			
			if (type == "drop-right") {
				hbox.appendChild(engineImage);
				hbox.appendChild(engineImageDropdown);
			}
			
			// autocomplete dropdown
			cell = document.createElement("hbox");
			cell.setAttribute("id", this.$id + this.$ID_AUTOCOMPLETE_DROPDOWN_CELL);
			cell.setAttribute("class", "dtx-searchbar-autocomplete-dropdown-cell");
			cell.setAttribute("width", "15");
			imgCell = document.createElement("vbox");
			
			var flexer = document.createElement("box");
			flexer.setAttribute("flex", "2");
			imgCell.appendChild(flexer);
			
			img = document.createElement("image");
			img.setAttribute("id", this.$id + "_dtx-searchbar-engine-dropdown-right");
			img.setAttribute("class", "dtx-searchbar-engine-dropdown");
			img.setAttribute("src", this.framework.makeChromeURL('skin/lib/arrow-dn.gif'));
			img.setAttribute("width", "5");
			img.setAttribute("height", "3");
			img.setAttribute("flex", "0");
			imgCell.appendChild(img);

			var flexer = document.createElement("box");
			flexer.setAttribute("flex", "1");
			imgCell.appendChild(flexer);
			
			cell.appendChild(imgCell);
			if (type == "drop-right") {
				cell.setAttribute("hidden", "true");
			}
			hbox.appendChild(cell);
						
			// go button
            var hboxCell = document.createElement("hbox");
            hboxCell.setAttribute("flex", "0");
            var vboxCell = document.createElement("vbox");
            var hboxTopCell = document.createElement("hbox");
            hboxTopCell.setAttribute("flex", "1");
            var hboxBottomCell = document.createElement("hbox");
            hboxBottomCell.setAttribute("flex", "1");
			cell = document.createElement("hbox");
			cell.setAttribute("id", this.$id + this.$ID_GO_CELL);
			cell.setAttribute("class", "dtx-searchbar-go-cell");
            cell.setAttribute("flex", "0");
			
			img = document.createElement("image");
			img.setAttribute("id", this.$id + this.$ID_GO);
			img.setAttribute("class", "dtx-searchbar-go");
			img.setAttribute("src", this.framework.makeChromeURL(this.$imgSearch));
            
            /*************************************************************/
            /* PLEASE STOP SETTING DEFAULT STYLE VALUES IN SEARCHBAR.JS!!
             * 
             * FF does not need this but you did in your particular project. By doing this, you deny to everyone else to have images higher than 22px.
             * If your searchbutton image is 22px height, you could solve your stretch problem by adding the following css rule into your custom.css
             * 
             * toolbaritem[REPLACE_WITH_YOUR_TOOLBAR_ID] image.dtx-searchbar-go{
             * 	height: 22px;
             * 	max-height: 22px;
             * }
             * 
             * If you encounter a similar problem in the future, please allow people to override default values using css
             ********************/
             
            //img.setAttribute("height", "22"); // FF needs this
            
            /*************************************************************/

			var self = this;
			
			if(typeof this.getAttribute("mouseoverimage") == "string" && this.getAttribute("mouseoverimage") != ""){
				self.framework.addEventListener(img, "mouseover", function(evt) {
					img.setAttribute('src' , self.getAttribute("mouseoverimage"));
				}, false);
			}
			
			if(typeof this.getAttribute("mouseoutimage") == "string" && this.getAttribute("mouseoutimage") != ""){
				self.framework.addEventListener(img, "mouseout", function(evt) {
					img.setAttribute('src' , self.getAttribute("mouseoutimage"));
				}, false);
			}


			cell.appendChild(img);
            vboxCell.appendChild(hboxTopCell);
            vboxCell.appendChild(cell);
            vboxCell.appendChild(hboxBottomCell);
            hboxCell.appendChild(vboxCell);
			hbox.appendChild(hboxCell);

            this.$domNode.appendChild(hbox);
			this.$domNode.setAttribute("minwidth", "200");
			//this.$domNode.setAttribute("maxwidth", "800");			
			
			//$MOZILLA_END$//
		}
		if (typeof this.getAttribute("minwidth") == 'undefined')
			this.setAttribute("minwidth", "200");
	};
	
	this.$reloadEngines = function(template) {
		this.$customEngines = null;
		if (this.getAttribute("menutemplate") != "" && typeof this.getAttribute("menutemplate") == "string"){
			this.$loadEngines(true);
		}else{
			this.$loadEngines(false);
		}
	};

	this.$loadEngines = function(template) {
		if (!this.$initialized)
			return;
	
		function genId(name) {
			name = new String(name);
			name = name.replace(/ /, "");
			return name;
		}
		
		function getNodeName(node) {
			if (dtxFramework.MOZILLA) {
				//$MOZILLA_START$//
				return node.localName;
				//$MOZILLA_END$//
			}
		}
		
		// load engines
		var engineFile = this.getAttribute("engines");
		var enginesFile = self.framework.loadChromeFile(engineFile);

		if (enginesFile != null) {
			var enginesXML = self.framework.loadXML(enginesFile);
			var root = enginesXML.documentElement;
			var nodes = root.childNodes;
			

			var k = 1;
			for (var i = 0; i < nodes.length; i++) {
				// parse node
				var node = nodes[i];
				var iconFilename = "";
				if (node.nodeType == 1){
					if (getNodeName(node) == "OpenSearchDescription" && !this.$engineLoaded) {
						var engineInfo = new this.$EngineInfo();
						var subnodes = node.childNodes;
						for (var j = 0; j < subnodes.length; j++) {
							var subnode = subnodes[j];
							var nodeName = getNodeName(subnode);
							if (nodeName == "ShortName") {
								engineInfo.shortName = subnode.firstChild.nodeValue;
								engineInfo.id = genId(this.$ENGINE_FRAG_ID + k);
							}
							else if (nodeName == "LongName")
								engineInfo.longName = subnode.firstChild.nodeValue;
							else if (nodeName == "Description")
								engineInfo.description = subnode.firstChild.nodeValue;
							else if (nodeName == "Image") {
								if (dtxFramework.MOZILLA) {
									var DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
									var iconPath = (new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path;
									if (iconPath.search(/\\/) != -1)
										iconFilename = subnode.firstChild.nodeValue.replace(/\//g, "\\");
									else
										iconFilename = subnode.firstChild.nodeValue;
									
								}
								
								engineInfo.icon = subnode.firstChild.nodeValue;
							}
							else if (nodeName == "interpret" && subnode.getAttribute("type") == "resulturl") {
								engineInfo.detectURLRegEx = subnode.getAttribute("data");
							}
							else if (nodeName == "Geoip") {
								engineInfo.geoip = subnode.firstChild.nodeValue;
							}
							else if (nodeName == "Url" && subnode.getAttribute("type") == "text/html"){
								if (subnode.getAttribute("template") != null) {
									engineInfo.query = subnode.getAttribute("template");
								}else if (dtxFramework.MOZILLA && subnode.getAttribute("templateFF") != null) {
									engineInfo.query = subnode.getAttribute("templateFF");
								}
							}else if (nodeName == "OutputEncoding") {
								engineInfo.outputencoding = subnode.firstChild.nodeValue;
							}else if (nodeName == "InputEncoding") {
								engineInfo.inputencoding = subnode.firstChild.nodeValue;
							}else if(nodeName == "EngineId") {
								engineInfo.publicId = subnode.firstChild.nodeValue;
							}
						}
						k++;
						self.$_engines.push(engineInfo);
					}
					//Jaouadb FEA#78857064: get rival search engine info for keyword capture
					else if (getNodeName(node) == "RivalSearch" && !this.$engineLoaded)
					{ 
						var subnodes = node.childNodes;
                        for (var x = 0; x < subnodes.length; x++) {
                        	var subnode = subnodes[x];
                            var nodeName = getNodeName(subnode);
                            
							if (nodeName == "item" && subnode.getAttribute("type") == "resulturl") {
	                           _rivalEngines.push(subnode.getAttribute("data"));
							}
                        }
					}
					/*******************************************/
				}
			}
			this.$engineLoaded = true;
		}

		if (!this.$customEngines || (dtxFramework.IE && DTFramework.WEB)) {
			this.$customEngines = new Array();
			if (!this.$_engines && dtxFramework.IE && DTFramework.WEB)
				this.$_engines = new Array();
			var i=0;
			this.recurse(this,
				function(element) {
					if (element.tagName == "searchengine" /*&& element.parentNode == self*/) {
						var engineInfo = new self.$EngineInfo();
						engineInfo.id = element.$id;
						engineInfo.publicId = null;
						engineInfo.shortName = element.getAttribute("label");
						engineInfo.description = element.getAttribute("tooltiptext");
						engineInfo.longName = element.getAttribute("label");
						engineInfo.query = element.getAttribute("query");
						engineInfo.icon = element.getAttribute("image");
						if(element.getAttribute("resulturl"))
								engineInfo.detectURLRegEx = element.getAttribute("resulturl");
						engineInfo.inputencoding = "UTF-8";
						engineInfo.outputencoding = "UTF-8";
						self.$_engines.push(engineInfo);
						if (i==0)
							self.setAttribute("selectedengine", element.$id);
						self.$customEngines.push(element);
						i++;
					}
					return true;
				});
		}
		
		// create engine selector popup
		this.$enginePopup = self.framework.createElement("menupopup");
		this.$enginePopup.$setDOM(this.$document);
		this.$enginePopup.$disableUpdates();
		this.$enginePopup.setAttribute("id", this.$id + this.$ID_ENGINE_POPUP);
		this.$enginePopup.setAttribute("nonserialize", "true");
		
		this.$enginePopup.Flip = function() 
		{
			self.$enginePopup.showPopup(self.$engineIconCell, 0, 0);		
		};

		
		/*
		if (template == true){
			this.$enginePopup.setAttribute("template", this.getAttribute("menutemplate"));	
			this.$enginePopup.setAttribute("feed", this.getAttribute("engines"));	
		}
		*/
		
		for (var i = 0; i < this.$customEngines.length; i++) {
			var element = this.$customEngines[i];
			var item = framework.createElement("menuitem");
			item.setAttribute("id", this.$id + "-" + element.$id + this.$ID_ENGINE_POPUP_ITEM);
			item.setAttribute("label", element.getAttribute("label"));
			if (element.getAttribute("tooltiptext"))
				item.setAttribute("tooltiptext", element.getAttribute("tooltiptext"));
			if (element.getAttribute("image"))
				item.setAttribute("image", element.getAttribute("image"));
			item.setAttribute("dtx-engine-id", element.$id);
			item.setAttribute("isengineitem", "true");
			var engineId = new String(element.$id);
			framework.addEventListener(item, "command", 
				function(evt) {
					var target = self.$getEventTarget(evt);
					var engineId = target.getAttribute("dtx-engine-id");
					self.$engineSelected(engineId);
				}, false);
			this.$enginePopup.appendChild(item);
		}
		
		for (var i = 0; i < this.$_engines.length; i++) {
			var engine = this.$_engines[i];
			var item = self.framework.createElement("menuitem");
			item.setAttribute("id", this.$id + "-" + engine.id + this.$ID_ENGINE_POPUP_ITEM);
			item.setAttribute("label", engine.shortName);
			item.setAttribute("tooltiptext", engine.description);
			item.setAttribute("image", engine.icon);
			item.setAttribute("dtx-engine-id", engine.id);
			item.setAttribute("isengineitem", "true");
			var engineId = new String(engine.id);
			self.framework.addEventListener(item, "command", 
				function(evt) {
					var target = self.$getEventTarget(evt);
					var engineId = target.getAttribute("dtx-engine-id");
					self.$engineSelected(engineId);
				}, false);
			this.$enginePopup.appendChild(item);
		}
		
		this.$enginePopup.$enableUpdates();
		this.$enginePopup.setAttribute("nonserialize", "true");
		this.appendChild(this.$enginePopup);
		
		var engineId = this.getAttribute(this.$ATTR_SELECTED_ENGINE);
		if (engineId)
			this.$engineSelected(engineId);
	};	// loadEngines
	
	this.$init = function() 
	{
		this.$initialized = true;
		
		this.$Autocomplete = new CAutocomplete(this);

		this.framework.addEventListener(this, "documentload",
			function(url, disp) {
				self.$onLoad(url);
			});

		this.framework.mainContainer.addEventListener("load", function() {
				self.$URLSearchHook = new CURLSearchHook(self);
		});
	};
	
	

	this.$getEngines = function() {
		return this.$_engines;
	};
	
	this.$getEngineById = function(id) {
		var i = 0;
		for (; i < this.$_engines.length && this.$_engines[i].id != id; i++);
		if (i < this.$_engines.length)
			return this.$_engines[i];
		else
			return null;
	};
	
	//Looks up an engine using its public Id.
	this.$getEngine = function(pid) {
		for(var i = 0; i < this.$_engines.length; i++) {
			if(this.$_engines[i].publicId == pid)
				return this.$_engines[i];
		}
		return null;	
	};
	
	this.$clearSelection = function()
	{
		this.recurse(this.$enginePopup,
			function(element) {
				if (element.getAttribute("isengineitem") == "true") {	// ??? WARNING: Enabling this will put back the multiple selection bug!
					element.setAttribute("checked", "false");
				}
				return true;
			});
    
	};


	this.$engineSelected = function(engineId) {
		if (typeof engineId != "string" || engineId == "") {
			// default to first engine
			if (this.$getEngines().length > 0)
				engineId = this.$getEngines()[0].id;
		} else {
			if (this.$getEngineById(engineId) == null && this.$getEngines().length > 0)
				engineId = this.$getEngines()[0].id;
		}

		this.$clearSelection();
		if (typeof engineId == "string" && engineId != "") {
			var iconId = id + this.$ID_ENGINE_ICON;
			var itemId = this.$id + "-" + engineId + this.$ID_ENGINE_POPUP_ITEM;
			var item = this.framework.getElementById(itemId);
			var engine = this.$getEngineById(engineId);
			if(engine && engine.publicId)
				var eventObject = {target: this, id: engine.publicId, item: null};
			else 
				var eventObject = {target:this, id:engineId, 'item':item};
			
			this.setAttribute(this.$ATTR_SELECTED_ENGINE, engineId);
			
		    if (this.$engineIcon != null && item != null){
			    if (typeof item.getAttribute("image") == "string" && item.getAttribute("image") != ""){
			    	this.$engineIcon.setAttribute("src", item.getAttribute("image"));
			    }else{
			    	this.$engineIcon.setAttribute("src", item.parentNode.parentNode.getAttribute("image"));
			    	item.setAttribute("checked", "true");
			    }
		    }		
			//this.setAttribute(this.$ATTR_SELECTED_ENGINE, engineId);
		}
		this.$engineLoaded = true;
	};
	
	//Selects a search engine given its public Id.
	this.selectEngine = function(pid) {
		var engine = this.$getEngine(pid);
		
		if(engine != null) {
			this.$engineSelected(engine.id);
		}
	};
	
	
	this.$itemPicked = function(value) {
		this.$doSearch(false);
	};

	
	this.$doSearch = function(bUseDefaultSearchEngine) 
	{
		this.$Autocomplete.Hide();
		var info = this.$Autocomplete.getCurrentSearchItemProps();

		if (info.bCopyText) {
			self.$textbox.style.backgroundImage = "";
			self.$textbox.value = unescape(info.sQuery);
		}

		//var searchTerms = new String(this.$textbox.value);
		var searchTerms = info.sQuery;
		
		var engineId;
		if (info.iEngineID && !bUseDefaultSearchEngine) {
			engineId = info.iEngineID;
		} else {
			engineId = this.getAttribute(this.$ATTR_SELECTED_ENGINE);
		}
		

		var searchQuery;
		if (info.sClickUrl && !bUseDefaultSearchEngine) {
			searchQuery = info.sClickUrl;
		} else {
			var engine = this.$getEngineById(engineId);
			searchQuery = engine.query;

			//TODO: support more encodings
			if (engine.inputencoding.toLowerCase() == 'utf-8') {
				searchTerms = escape(this.framework.utf8encode(searchTerms));
				searchTerms = searchTerms.replace(/\+/gim, "%2B"); //encode "+" chars from the string
			} else if (engine.inputencoding.toLowerCase() == 'utf-8-enhanced') {
				searchTerms = encodeURIComponent(searchTerms);
			}
		}

		if((self.getAttribute("allowemptysearch") != "true") && (!searchTerms)) 
			return; // Do not search for an empty string
		
		searchQuery = searchQuery.replace(/{searchTerms}/g, searchTerms);			// Using /g to replace {searchTerms} globally in the url
		var version = self.$framework.mainContainer.getAttribute("version");

		searchQuery = searchQuery.replace(/{tbversion}/, version);
		var domainRegEx = new RegExp("http://(.*?)/", "gim");
		var matches = domainRegEx.exec(this.$currentUrl);
		var domain = "";
		if (matches != null && matches.length > 1) {
			domain = matches[1];
		}
		searchQuery = searchQuery.replace(/{location}/, domain);
		
		var statsElement = self.$framework.getStatElement();
		if(statsElement != null)
			searchQuery = searchQuery.replace(/___campaignID___/g, statsElement.getAttribute("campaignIDIE"));	//using campaignIDIE here is not an error. We do use campaignIDIE inside search urls for Firefox since a long time now.

        var installTime = self.framework.loadFile("installtime.dat");
		if (!installTime) {
            var today = new Date();
            var dd = today.getDate();
            var mm = today.getMonth()+1;
            var yyyy = today.getFullYear();

            if(dd<10)
                dd='0'+dd;

            if(mm<10)
                mm='0'+mm;

            installTime = yyyy+'-'+mm+'-'+dd;
            self.framework.saveFile("installdate", installTime);
        }
        
        searchQuery = searchQuery.replace(/__installtime__/g, installTime);
        
		var beforeSearchData = {
			target: this, 
			url: searchQuery, 
			query: searchTerms,
			cancel: false
		};
		this.$fireEvent("beforesearch", beforeSearchData);
		if (!beforeSearchData.cancel) {
			searchQuery = beforeSearchData.url;
			
			this.$currentUrl = searchQuery;
			this.$updateLastSearch();
			
			self.framework.loadURI(searchQuery);
			
			//used for grabbing the searchterm from stats class.
			this.$fireEvent("search", {target: this, query: searchTerms});
		}
		self.$Autocomplete.Update();
 	};
	

 	// LB 18.jun.2009: Is this ever called?
 	this.search = function(terms) {
		this.setAttribute("value", terms);
		this.$doSearch(true);
	};
	
	this.getSearchTerms = function() {
		if (this.$textbox != null)
			return this.$textbox.value;
		else
			return "";
	};
	
	

	//-----------------------------
	//
	// Autocomplete routines
	//
	//-----------------------------
	
	
	this.$onKeyDown = function(evt) {			
		self.$Autocomplete.onKeyDown(evt);
	};
	
	
	this.$onKeyUp = function(evt) {
		self.$Autocomplete.onKeyUp(evt);
		
		// set timeout for highlighting
		if (self._highlightTimeout != null)
			framework.clearTimeout(self._highlightTimeout);
		
		self._highlightTimeout = self.framework.setTimeout(
			function() { self.$updateHighlights(); }, self.$HIGHLIGHT_REQUEST_TIMEOUT
		);
	};
	
	this.$onChange = function(evt) {
		self.setAttribute("value", self.$textbox.value);
	};
	

	//-----------------------------
	//
	// Highlighting routines - START
	//
	//-----------------------------


	//Extracts and cleans up search words and phrases for highlighting purposes (skander 07/07/2009)
	this.$extractSearchTerms = function() {
		var terms = new Array();

		//Extract search phrases first
		var searchString = this.$textbox.value;	
		var searchRegEx = new RegExp('"([^"]+)"', 'g');
		var matches;
		
		while((matches = searchRegEx.exec(searchString)) != null) {
			if(matches.length > 1) {
				terms.push(matches[1]);
			}
		}
		
		//Extract simple search words then 
		searchString = searchString.replace(searchRegEx, '');
		var words = searchString.split(" ");

		// split() makes an one element array on an empty searchString.
		// concat() in turn, adds an empty element 
		// The toolbar, in turn creates an empty Highlight button for such an element.

		/*
		if (searchString && words.length)
			return terms.concat(words);
		else
			return terms;
		*/

		// Includes only non-empty strings:
		for (var i = 0; i < words.length; i++) {
			if (words[i]) 
				terms.push(words[i]);
		}
		return terms;
	};
	
	
	this.$toggleHighlights = function() {
		if (this.getAttribute("highlight") != "true" || this.$highlighterBtn == null)
			return;
			
		var highlightsOn = this.$highlighterBtn.getAttribute("checked") == "true";
		if (highlightsOn)
			this.$addHighlights();
		else
			this.$removeHighlights();
	};
	
	this.$updateHighlights = function() {
		this.$highlightRanges = new Array();

		if (this.getAttribute("highlight") != "true" || this.$highlighterBtn == null)
			return;

		var highlightsOn = this.$highlighterBtn.getAttribute("checked") == "true";
		if (highlightsOn)
			this.$addHighlights();
	};
	
	
	this.$updateHighlightButtons = function() {
	};
	
	function getContainerInput(node) {
		var iterations = 4;
		while (node != null && node.tagName != "INPUT" && (iterations > 0)) {
			node = node.parentNode;
			iterations--;
		}
		if (node != null && node.tagName == "INPUT")
			return node;
		else
			return null;
	};
	
	
	//This method should be used instead of getting the highlighter buttons by ID (skanderk 08/12/2009)
	this.getHighlighterButtons = function() {
		var highlighters = new Array();
		
		if (this.$highlighterBtn) 
		{
			highlighters.push(this.$highlighterBtn);
			if(this.$highlightButtons) 
			{
				for(var i = 0; i < this.$highlightButtons.length;  i++)
					highlighters.push(this.$highlightButtons[i]);
			}
		}
		
		return highlighters;
	};

	
	this.$addHighlights = function() {
		var highlightsOn = this.$highlighterBtn.getAttribute("hidden") == "true";
		if (highlightsOn)
		  return;
	};

	this.$removeHighlights = function()
	{
	};
	
	
	// NOT IN USE?!
	this.$restaureHighlights = function(){
		var spans = this.framework.getContentDocument().getElementsByTagName("span");
		var hasHighlight = false;
		for (var i = 0; i < spans.length; i++) {
			var span = spans[i];
			var color;
			if (span.getAttribute("dtx-highlight") == id ||
				span.getAttribute("dtx-highlight-single") == id) {
				color = span.getAttribute("dtx-highlight-color");
				hasHighlight = true;
				span.style.backgroundColor = color;
				span.style.backgroundImage = "";
			}
		}
		this.$updateHighlightButtons();
		return hasHighlight;
	};

	// BUG: IE branch tests the parent element's visiblity, while FF - doesn't!
	this.$highlightNext = function(btnId) 
	{
	};
	
	//Sets highlight colors and highlight buttons icons
	// NOT IN USE?!
	this.customizeHighlights = function(highlights) {
	};
	
	
	//-----------------------------
	//
	// Highlighting routines - END
	//
	//-----------------------------


	
	this.$updateLastSearch = function() {
		if (dtxFramework == undefined) {
			return;
		}
		var url = this.$currentUrl;
		var engines = this.$getEngines();
		var engine = null;
		var query = null;
		var searchTerms = "";
		
		for (var i = 0; i < engines.length && searchTerms == ""; i++) {
			engine = engines[i];
			var engineRegEx = new RegExp(engine.detectURLRegEx, "gim");
			var matches = engineRegEx.exec(url);
			if (matches != null && matches.length > 1) {
				searchTerms = matches[1];
				var index = 0;
				for (; index < searchTerms.length && searchTerms.charAt(index) != "&" /*&& searchTerms.charAt(index) != "/"*/; index++);
				searchTerms = new String(searchTerms).slice(0, index);
				break;
			}
		}

		//Jaouadb FEA#78857064: capture search keyword from other search engines
        for (var i = 0; i < _rivalEngines.length ; i++) 
        {
            var engineRegEx = new RegExp(_rivalEngines[i], "i");
            if (url.match(engineRegEx)){
                searchTerms = RegExp.$1;
                break;
            }
        }

		// We attempt extracting a searchphrase from the webpage first.
		// If not found (or empty), then we use one from the toolbar searchbox:
		if (searchTerms == "")
			searchTerms == this.$textbox.value;
		
		if (searchTerms != "") {
			searchTerms = unescape(searchTerms);
			//TODO: support more encodings
			if(engine.outputencoding.toLowerCase() == 'utf-8'){
				searchTerms = unescape(searchTerms);
				searchTerms = this.framework.utf8decode(searchTerms);
			}
			else if(engine.outputencoding.toLowerCase() == 'utf-8-enhanced'){
				searchTerms = decodeURIComponent(searchTerms);
			}
	
			//searchTerms = searchTerms.replace(/\+/gim, " ");
			var textbox = this.$textbox;
			
			textbox.style.cssText= 'margin-top:3px';
				
			textbox.value = searchTerms;
			this.$Autocomplete.History.Add(searchTerms, url, engine.id);
			//textbox.focus();
            textbox.style.backgroundImage = "";			
		}
	};
	
	this.$buildLastSearchPopup = function() {
	
		if (dtxFramework.MOZILLA) {
			//$MOZILLA_START$//
		    var historyXML = this.$Autocomplete.History.getXML();
		    var lastQuery = historyXML.documentElement.getAttribute("last");
		    var nodes = historyXML.getElementsByTagName("search");
		    var found = false;
		    var node = null;
		    for (var i = 0; i < nodes.length && !found; i++) {
			    node = nodes[i];
			    found = node.getAttribute("query") == lastQuery;
		    }
		    var engineId = node.getAttribute("engine");
		    var engine = this.$getEngineById(engineId);
		    var type = engine.type;
		    var xmlDOM = node;
    		
		    var resultNodes = node.getElementsByTagName("results");
		    var resultNode = resultNodes[0];
    		
		    var popupNode = document.getElementById(this.$id+ "-lastsearch-popup");
		    var popupBottomNode = document.getElementById(this.$id + "-lastsearch-popup-bottom");

		    var vboxContainerNode = document.createElement("vbox"); // create the container that will replace the old 

		    var url = new String(resultNode.getAttribute("url")); //.slice(7);
		    var domain = "";

		    // Start the loop to render the images
		    var nodesList = xmlDOM.getElementsByTagName("node");
		    var captionsList = xmlDOM.getElementsByTagName("caption");
		    var descriptionsList = xmlDOM.getElementsByTagName("desc");

		    // Get the next URL
		    var nextList = xmlDOM.getElementsByTagName("next");
		    var nextUrl = (nextList.length > 0)?nextList.item(0).getAttribute("url"):"";
		    if (nextUrl.indexOf("http") != 0){
			    var domainIdx = url.slice(7).indexOf('/');
			    domain = url.slice(0,domainIdx + 7);
		    }
			
			var self = this;
			

			var el = document.getElementById(this.$id + "-lastsearch-popup-next");			    
			if (el) {
				self.framework.addEventListener(el, "click", function(evt) {
					document.getElementById(self.$id + "-lastsearch-popup").hidePopup();
					window._content.location = domain + nextUrl;
				}, false);
			}

		    // Get the prev URL
		    var prevList = xmlDOM.getElementsByTagName("prev");
		    if (prevList.length >0) 
		    {
			    var prevUrl = prevList.item(0).getAttribute("url");
			    var prevNode = document.getElementById(this.$id + "-lastsearch-popup-prev");
			    prevNode.setAttribute("hidden", "false");
				
				self.framework.addEventListener(prevNode, "click", function(evt) {
					document.getElementById(self.$id + "-lastsearch-popup").hidePopup();
					window._content.location = domain + prevUrl;
				}, false);
		    }
		    else 
		    {
			    el = document.getElementById(this.$id + "-lastsearch-popup-prev");
			    if (el)
			      el.setAttribute("hidden", "true");
			}

		    if (type == "web") 
		    {
			    // Get the index of the page
			    var startIndex = xmlDOM.getElementsByTagName("start").item(0).getAttribute("index");

			    // Start the loop to process the node
			    for (var i=0; i < nodesList.length; i++, startIndex++) {
    			
				    // We retrieve the values fron the XML
				    var hrefLocation = nodesList.item(i).getAttribute("url");
				    if (hrefLocation.indexOf("http") != -1) domain = "";        				
    				
				    var caption = new String(captionsList.item(i).firstChild.data);
				    caption = unescape(decodeURI(caption));
				    caption = caption.replace(/<.*?>/gi, "");
				    var description = "";
				    if (i < descriptionsList.length) {
					    description = new String(descriptionsList.item(i).firstChild.data);
					    description = unescape(decodeURI(description));
					    description = description.replace( /<.*?>/gi, "" );
					    description = description.slice(0,70) + "...";  // >> use CSS ellipsis
				    }
				    var hboxNode = document.createElement("hbox");
				    var hboxTextNode = document.createElement("hbox");
				    var vboxTextNode = document.createElement("vbox");
				    var titleNode = document.createElement("label");
				    titleNode.setAttribute("style", "font-weight:bold"); // >> use CSS class for this
				    var descriptionNode = document.createElement("label");
				    titleNode.setAttribute("value",caption);
				    descriptionNode.setAttribute("value",description);

				    // Append the hbox for image container
				    var hboxIdxNode = document.createElement("hbox");
				    hboxIdxNode.setAttribute("align", "right");
				    hboxIdxNode.setAttribute("style", "color: white; background-color: lightgray; width: 25px; padding: 5px"); // >> use CSS class
				    var labelIdxNode = document.createElement("label");
				    labelIdxNode.setAttribute("style", "margin: 0px"); // >> use CSS class for this
				    labelIdxNode.setAttribute("value", startIndex);
				    hboxIdxNode.appendChild(labelIdxNode);
				    hboxNode.appendChild(hboxIdxNode);

				    // Append the hbox for title and description
				    vboxTextNode.appendChild(titleNode);
				    vboxTextNode.appendChild(descriptionNode);
    				
					self.framework.addEventListener(hboxNode, "click", function(evt) {
						document.getElementById(self.$id + "-lastsearch-popup").hidePopup();
						window._content.location = domain + hrefLocation;
					}, false);
					
				    hboxNode.setAttribute("style", "margin-bottom: 2px;");  // >> use CSS class	

				    hboxTextNode.appendChild(vboxTextNode);

				    hboxNode.appendChild(hboxTextNode);
				    vboxContainerNode.appendChild(hboxNode);
			    }
		    }
		    else if (type == "image") {
			    var hboxNode = null;
			    for (var i=0; i < nodesList.length; i++)
			    {
				    // We retrieve the values fron the XML
				    var imgSrc = nodesList.item(i).getAttribute("src");
    				
				    // Every 5 pictures we create a new line
				    if (i % 5 == 0) 
					    var hboxNode = document.createElement("hbox");
				    var imgSrc = nodesList.item(i).getAttribute("src");
				    var imgWidth = new Number(nodesList.item(i).getAttribute("width"));
				    var imgHeight = new Number(nodesList.item(i).getAttribute("height"));
				    var newWidth = (65*imgWidth)/imgHeight; 
				    var imgvboxContainerNode = document.createElement("vbox");
				    imgvboxContainerNode.setAttribute("align","center");
				    imgvboxContainerNode.setAttribute("width","70");
				    imgvboxContainerNode.style.border = "2px solid lightgray";
				    imgvboxContainerNode.style.margin = "2px";
					
				    var imgNode = document.createElement("image");
				    imgNode.setAttribute("src", imgSrc);
				    imgNode.setAttribute("width", newWidth +"px");
				    imgNode.setAttribute("height", "65px");
				    imgNode.setAttribute("align", "center");
				    imgNode.setAttribute("class", "lastsearch_img_f");
					
					self.framework.addEventListener(imgNode, "click", function(evt) {
						document.getElementById(self.$id + "-lastsearch-popup").hidePopup();
						window._content.location = domain + nodesList.item(i).getAttribute("url");
					}, false);
					
				    imgvboxContainerNode.appendChild(imgNode);
				    hboxNode.appendChild(imgvboxContainerNode);
				    vboxContainerNode.appendChild(hboxNode);
			    }
		    }
		    popupNode.replaceChild(vboxContainerNode, popupNode.firstChild);
			//$MOZILLA_END$//
		}
	};

	// event handlers
	
	this.$onLoad = function(url) {

		this.$updateHighlights();
		this.$currentUrl = url;
		this.$updateLastSearch();
		this.$attachOnSelectHandler();
	};
	//------------------------------------------------------------------------------
	//
    // Get selected text from the page and put it in the searchbar 
    //
    //------------------------------------------------------------------------------
	this.$OnSelectHandler = function() {
		
		if (self.getAttribute("captureselection") != "true")
			return;
		
        // check if the browser support W3C DOM2 Ranges
        var w3Range = document.implementation.hasFeature("Range", "2.0");
       
        var windowContent = self.framework.getContentWindow();
        var documentContent = self.framework.getContentDocument();
        var userSelection;
        var userText = '';
        
        if (w3Range || windowContent.getSelection){
            userSelection = windowContent.getSelection();
			if (userSelection && userSelection != "") {
				var selectionRange = userSelection.getRangeAt(0);
				userText = selectionRange.toString();
			}
        } 
		else if (document.selection){ 
            userText = documentContent.selection.createRange().text;
        }
		
		userText = userText.replace(/\s+/g, ' ');				// Keep only one space between words
		userText = userText.replace(/^\s/, '');					// Remove opening space (if present)
        if (userText != ''){
			userText = userText.split(' ', 6).join(' ');		// Show up to 6 words in the searchbar
			
			//Bug 9593 - Selected text overwrite the background image on the search bar
			self.$textbox.style.backgroundImage = "";
            self.$textbox.value = userText;
            //Bug 9588 - Under FF the user cannot copy selected text
            //self.$textbox.select();
        }
 
    };
    
    this.$attachOnSelectHandler = function(){
    	
        var documentContent = self.framework.getContentDocument();
        
        documentContent.addEventListener("mouseup", this.$OnSelectHandler, true);
    };
    //------------------------------------------------------------------------------
	
};



dtxFramework.inherits(dtxFramework.Searchbar, dtxFramework.DTXElement);

dtxFramework.Searchbar.prototype.$connectDOM = function() {
	dtxFramework.DTXElement.prototype.$connectDOM.apply(this);

	this.$BUTTON_GO 		= this.$getNode(this.$id + this.$ID_GO);
	this.$textbox			= this.$getNode(this.$id + this.$ID_TEXTBOX);
	this.$engineIcon		= this.$getNode(this.$id + this.$ID_ENGINE_ICON);
	this.$engineIconCell	= this.$getNode(this.$id + this.$ID_ENGINE_ICON_CELL);
	this.$engineNoIconCell	= this.$getNode(this.$id + this.$ID_ENGINE_NO_ICON_CELL);
	this.$goCell			= this.$getNode(this.$id + this.$ID_GO_CELL);
	this.$resizeTarget		= this.$getNode(this.$id + this.$ID_MAIN);
	this.$autocompleteDropDownCell = this.$getNode(this.$id + this.$ID_AUTOCOMPLETE_DROPDOWN_CELL);
};

dtxFramework.Searchbar.prototype.$applyAttributes = function() {
	dtxFramework.DTXElement.prototype.$applyAttributes.apply(this);
		
	if (this.getAttribute("menutemplate") != "" && typeof this.getAttribute("menutemplate") == "string"){
		this.$loadEngines(true);
	}else{
		this.$loadEngines(false);
	}

	var engineId = this.getAttribute(this.$ATTR_SELECTED_ENGINE);
	this.$engineSelected(engineId);

	// update last search button
	if (this.$lastSearchBtn != null) {
		if (this.$lastSearchEngineId != "") {
			this.$lastSearchBtn.setAttribute("hidden", "false");
			var engine = this.$getEngineById(this.$lastSearchEngineId);
			if (engine != null)
				this.$lastSearchBtn.setAttribute("image", engine.icon);
		}
		else {
			this.$lastSearchBtn.setAttribute("hidden", "true");
		}
	}
};

dtxFramework.Searchbar.prototype.getAttribute = function(attrid, value) {
	var inherited = dtxFramework.DTXElement.prototype.getAttribute.apply(this, [attrid]);
	if (attrid == "label")
		return this.$labelCaption;
	else if (attrid == "priority")
		return "-1";
	else
		return inherited;
};

dtxFramework.Searchbar.prototype.setAttribute = function(attrid, value) {
	//constraints
	if (attrid == "width") {
		var minwidth = this.getAttribute("minwidth");
		if(typeof minwidth == "undefined")
			minwidth = 0;
		var maxwidth = this.getAttribute("maxwidth");
		if(typeof maxwidth == "undefined")
			maxwidth = Infinity;
		
		if((Number(value) < Number(minwidth)) || (Number(value) > Number(maxwidth)))
			return;
	}
	if (attrid == "minwidth") {
		var maxwidth = this.getAttribute("maxwidth");
		if(typeof maxwidth == "undefined")
			maxwidth = Infinity;

		if(Number(value) > Number(maxwidth))
			return;
	}
	if (attrid == "maxwidth") {
		var minwidth = this.getAttribute("minwidth");
		if(typeof minwidth == "undefined")
			minwidth = 0;
		
		if(Number(value) < Number(minwidth))
			return;
	}			
	
	//end constraints
	
	var reload  = attrid == "engines" ;
	var proceed = false;
	var applyTemplate = attrid == "menutemplate" && this.getAttribute(attrid) != value;
	var self = this;
	
	dtxFramework.DTXElement.prototype.setAttribute.apply(this, [attrid, value]);
	if (attrid == "value") {
		if (this.$textbox != null && this.$textbox.value != value)
			this.$textbox.value = value;
	}
	if (reload){
		proceed = value.indexOf(this.getAttribute("engines")) == -1;
		if (proceed){
			if (this.getAttribute("menutemplate") != "" && typeof this.getAttribute("menutemplate") == "string"){
				 if (applyTemplate)
					this.$loadEngines(true);
			}else{
				this.$loadEngines(false);
			}
		}
	}
	if (attrid == "menutemplate"){
		if (value != "" && typeof value == "string"){
		
	    if (applyTemplate)
		    this.$loadEngines(true);
		}else{
			this.$loadEngines(false);
		}
	}
	
	
	if (attrid == "image") {
		if (this.$BUTTON_GO != null ) {
			if (this.$BUTTON_GO.src != this.$framework.makeChromeURL(value))
			    this.$BUTTON_GO.setAttribute("src", this.$framework.makeChromeURL(value));
			
			this.framework.addEventListener(this.$BUTTON_GO, "mouseout", function(evt) {
				self.$BUTTON_GO.setAttribute('src' ,self.$framework.makeChromeURL(value));
			}, false);
		}
	}
	
	
	if (attrid == "mouseoverimage") {
		if (this.$BUTTON_GO != null && this.$BUTTON_GO.src != this.$framework.makeChromeURL(value)) {
			this.framework.addEventListener(this.$BUTTON_GO, "mouseover", function(evt) {
				self.$BUTTON_GO.setAttribute('src' , self.$framework.makeChromeURL(value));
			}, false);
		}
	}

	if (attrid == "width" && this.$resizeTarget != null) {
		this.$resizeTarget.style.width = value + "px";
	}
	if (attrid == "minwidth") {
		var width = this.getAttribute("width");
		if((typeof width != "undefined") && (Number(value) > Number(width)))
			this.setAttribute("width", value);
	}
	if (attrid == "maxwidth") {
		var width = this.getAttribute("width");
		if((typeof width != "undefined") && (Number(value) < Number(width)))
			this.setAttribute("width", value);
	}	
	if (attrid == "highlight") {
		if (this.getAttribute("hidehighlight") == "true" && this.$highlighterBtn != null){
			// 17.12.2009 - Disabled because the highlight button keeps on showing because of this line of code, even when the button is hidden from Prefs.
			//this.$highlighterBtn.setAttribute("hidden", (value == "true") ? "false" : "true");
		}
	}	
	
};


dtxFramework.Searchbar.prototype.$hookEvents = function() {
	dtxFramework.DTXElement.prototype.$hookEvents.apply(this);
	
	if (this.$designMode)
		return;

	if (this.$engineIconCell == null && this.$engineNoIconCell == null)
		return;
		
	var self = this;
	if (this.$engineIconCell != null) {
		if (dtxFramework.MOZILLA) {
			//$MOZILLA_START$//
			var engineDropdown = this.$getNode(this.$id + this.$ID_ENGINE_DROPDOWN);
			engineDropdown.onmousedown = function(evt) {
				evt = self.$getEvent(evt);
				if ((evt.button != '1' && dtxFramework.IE && !DTFramework.WEB) || (evt.button != '0' && dtxFramework.MOZILLA))
			    return ;

				self.$enginePopup.showPopup(self.$engineIconCell, 0, 0);
				evt.cancelBubble = true;
			};
			//$MOZILLA_END$//
		}
		
		this.$engineIconCell.onmousedown = function(evt) {
			evt = self.$getEvent(evt);
			if ((evt.button != '1' && dtxFramework.IE && !DTFramework.WEB) || (evt.button != '0' && dtxFramework.MOZILLA))
				return ;
			
			self.$enginePopup.Flip();
			
			self.$enginePopup.showPopup(self.$engineIconCell, 0, 0);
			evt.cancelBubble = true;
		};
	}
	
	this.$autocompleteDropDownCell.onmousedown = function(evt) {
	    evt = self.$getEvent(evt);
		if ((evt.button != '1' && dtxFramework.IE  && !DTFramework.WEB) || (evt.button != '0' && dtxFramework.MOZILLA))
	        return;
	        
		self.$Autocomplete.TogglePopup();
		evt.cancelBubble = true;
	};
	
	this.$goCell.onmousedown = function(evt) {
		try{
			evt = evt || window.event;
		}catch(e){}
			
		if ((evt.button != '1' && dtxFramework.IE  && !DTFramework.WEB) || (evt.button != '0' && dtxFramework.MOZILLA))
	        return;
		var clickType=1;
		
		if (!(dtxFramework.IE && DTFramework.WEB)){
			if (dtxFramework.MOZILLA) clickType=evt.which;
			else if (dtxFramework.IE) clickType=evt.button;
		}
		
		if(clickType == 1){
			self.$doSearch(true);
			//fire event everytime a click on searchbtn has been made - stat purpose
			self.$fireEvent("searchBtnClick", {target: self});
		}
	};
	
	this.$textbox.onkeydown = function(evt) {
		evt = self.$getEvent(evt);
		if (evt.keyCode == 9) 
			this.setAttribute("isBackground", "false");
		else
			this.setAttribute("isBackground", "true");

		self.$onKeyDown(evt);
		self.$onKeyUp(evt);
	};
	
	this.$textbox.onfocus = function(evt) {
		evt = self.$getEvent(evt);
		if (dtxFramework.MOZILLA) {
			this.style.cssText = 'margin-top:3px;';
		}
		
		this.activated = true;
	};

	this.$textbox.onchange = function(evt) {
		//self.framework.getContentDocument().title = "Changed"; // TEST ONLY!!!
		evt = self.$getEvent(evt);
		self.$onChange(evt);
	};
	
	//HERE
	//This solve the issue that when there is text pasted into the textbox, the onchange event doesn't get fired and therefore when resizing the bar  value disappears
	this.$textbox.onpaste = function(evt)
	{
		self.$Autocomplete.$getItems().SelectedIndex = null;	// Fix for 6488, affects CAutocomplete.getCurrentSearchItemProps()
		self.framework.setTimeout( function()
		{
			self.setAttribute("value", self.$textbox.value);
		},100);	
	};
	//END
	
	this.$textbox.onblur  = function (evt){
		if (dtxFramework.MOZILLA) {
			if (this.value == '' && String(self["$engineIcon"].src).indexOf("web") != -1)
				this.style.cssText= 'margin-top:4px;background-position: center center; background-repeat: no-repeat;background-image:url(' + self.getAttribute("backgroundimage") + ')' ; 
			
		}
	};
	
	this.$textbox.onclick  = function (evt){
		if(this.activated){
			this.activated = false;
			this.select();
		}
	};
	if (dtxFramework.MOZILLA) {
		this.$textbox.oncontextmenu= function(evt) {
			var contextPopup = document.getElementById("contentAreaContextMenu");
			var VisibleItemsIndexes = new Array();
			for (var i = 0; i < contextPopup.childNodes.length; i++) {
				var childID = contextPopup.childNodes[i].getAttribute("id");
				if(childID == "context-cut" || 
					childID == "context-copy" || 
					childID == "context-paste" || 
					childID == "context-delete" || 
					childID =="context-selectall" || 
					childID == "context-undo"){
					contextPopup.childNodes[i].hidden = false;
					VisibleItemsIndexes.push(i);
				}else
					contextPopup.childNodes[i].hidden = true;
			}
			contextPopup.openPopup(null, null, evt.clientX, evt.clientY, true, true);
			contextPopup.addEventListener("popupshown",  
				function(evt){
					for (var i = 0; i < VisibleItemsIndexes.length; i++) {
						var childID = contextPopup.childNodes[VisibleItemsIndexes[i]].getAttribute("id");
						if ( childID =="context-paste" || childID == "context-undo" ) continue; 
						if ( childID == "context-selectall" && self.$textbox.value != '') continue;
						if(self.$textbox.value != '' && self.$textbox.selectionStart != self.$textbox.selectionEnd) //text & selected: enable copy/cut/delete
							contextPopup.childNodes[VisibleItemsIndexes[i]].setAttribute("disabled","false");
						else
							contextPopup.childNodes[VisibleItemsIndexes[i]].setAttribute("disabled","true");
					}
				},true);
			evt.preventDefault();
		};
	}
};


dtxFramework.Searchbar.prototype.$setParent = function(node) {
	dtxFramework.DTXElement.prototype.$setParent.apply(this, [node]);

	if(node == null)
		return;

	var self = this;
	
	this.$init();
	
	if (this.getAttribute("menutemplate") != "" && typeof this.getAttribute("menutemplate") == "string"){
		this.$loadEngines(true);
	}else{
		this.$loadEngines(false);
	}
	
	if (this.$splitter == null) {
		this.$splitter = this.framework.createElement("ToolbarSplitter");
		this.$splitter.setAttribute("id", this.$id + this.$ID_SPLITTER);
		this.$splitter.setAttribute("nonserialize", "true");
		this.$splitter.setAttribute("persist", "index image"); 
		this.$splitter.setAttribute("designable",this.getAttribute("designable"));
		this.$splitter.setAttribute("tooltiptext", this.framework.localize("Press and move to resize the searchbox", this.$splitter.$id, 'tooltiptext'));
		if(this.getAttribute('splitterimage') != null) this.$splitter.setAttribute("image", this.getAttribute('splitterimage'));
		this.parentNode.appendChild(this.$splitter);
	}
	
	// create last search button and popup
	if (this.getAttribute("lastsearch") == "true" && this.$lastSearchBtn == null) {
		this.$lastSearchBtn = this.framework.createElement("ToolbarButton");
		this.$lastSearchBtn.setAttribute("nonserialize", "true");
		this.$lastSearchBtn.setAttribute("id", this.$id + this.$ID_LASTSEARCH_BUTTON);
		this.$lastSearchBtn.setAttribute("label", this.framework.localize("Last"));
		this.$lastSearchBtn.setAttribute("title", this.framework.localize("Last Search"));
		this.$lastSearchBtn.setAttribute("hidden", "true"); 
		this.$lastSearchBtn.setAttribute("optional", "true"); 
		this.$lastSearchBtn.setAttribute("type", "menu");
		
		this.$lastSearchPopup = this.framework.createElement("menupopup");
		this.$lastSearchPopup.setAttribute("id", this.$id + this.$ID_LASTSEARCH_POPUP);
		this.$lastSearchPopup.addEventListener("popupshowing",
			function() {
				self.$buildLastSearchPopup();
			});
		this.$lastSearchBtn.appendChild(this.$lastSearchPopup);
		
		this.parentNode.appendChild(this.$lastSearchBtn);
	}
	
	// create find word buttons
	if (this.getAttribute("highlight") == "true" && this.$highlightButtons == null) {
		this.$highlightButtons = new Array();
		for (var i = 0; i < this.$MAX_HIGHLIGHT_BUTTONS; i++) {
			var btn = this.framework.createElement("ToolbarButton");
			btn.setAttribute("id", this.$id + this.$ID_HIGHLIGHT_BTN + new String(i));
			btn.setAttribute("nonserialize", "true");
			btn.setAttribute("title", this.framework.localize("Highlight Word",btn.$id,'title'));
			btn.setAttribute("tooltiptext", this.framework.localize("Highlight Word",btn.$id,'tooltiptext'));
			btn.setAttribute("label", new String(i));
			btn.setAttribute("image", this.framework.makeChromeURL("skin/lib/" + this.$HIGHLIGHT_ICONS[i]));
			btn.setAttribute("dtx-highlight-color", this.$HIGHLIGHT_COLORS[i]);
			btn.setAttribute("dtx-highlight-index", i);
			btn.setAttribute("hidden", "true");
			btn.addEventListener("command",
				function(evt) {
					var target = self.$getEventTarget(evt);
					var id = target.getAttribute("id");
					self.$highlightNext(id);
				});
			this.parentNode.appendChild(btn);
			this.$highlightButtons.push(btn);
		}
	}
};


dtxFramework.Searchbar.prototype.$createDOMNode = function() {
	if (dtxFramework.MOZILLA) {
		/*$MOZILLA_START$*/
		return document.createElement("toolbaritem");
		/*$MOZILLA_END$*/
	}
};

dtxFramework.Searchbar.prototype.$renderOptions = function(node) {
	var self = this;

	// Last Search	
	if (self.getAttribute("lastsearch") == "true") {
		var checkbox = this.framework.createElement("checkbox");
		checkbox.setAttribute("label", self.framework.localize("Show Last Search"));
		if (self.$lastSearchBtn.getAttribute("hidden") != "true") 
			checkbox.setAttribute("checked", "true");
		checkbox.addEventListener("command",
			function() {
				if (self.$lastSearchBtn.getAttribute("hidden") != "true") {
					self.$lastSearchBtn.setAttribute("hidden", "true");
				}
				else {
					self.$lastSearchBtn.setAttribute("hidden", "false");
				}
			}, false);
		node.appendChild(checkbox);
	}

	// Highlighter
	if (self.getAttribute("highlight") == "true" && self.getAttribute("hidehighlightoption") != "true") {
		var checkbox = this.framework.createElement("checkbox");
		checkbox.setAttribute("label", self.framework.localize("Enable Keyword Highlight")); // TODO: Generalize label
		if (self.$highlighterBtn.getAttribute("hidden") != "true") 
			checkbox.setAttribute("checked", "true");
		checkbox.addEventListener("command",
			function() {
				var highlight_btn = document.getElementById(self.$id + self.$ID_HIGHLIGHTER);
				if (self.$highlighterBtn.getAttribute("hidden") != "true") {
					self.$highlighterBtn.setAttribute("hidden", "true");
					//if(self.$highlighterBtn.getAttribute("checked") == "true")
				//	{	
						self.$highlighterBtn.setAttribute("checked", "false");
						if (dtxFramework.MOZILLA)
							highlight_btn.click();
					//}
					self.setAttribute("hidehighlight", "true");

				}
				else {
					self.$highlighterBtn.setAttribute("hidden", "false");
					self.setAttribute("hidehighlight", "false");
				}
			}, false);
		checkbox.setAttribute("id", "highlight-enablekey");	
		node.appendChild(checkbox);
		node.addEventListener("select", function(evt) {
			var highlightHidden = self.$highlighterBtn.getAttribute("hidden");
			var checkbox = evt.target.getElementById("highlight-enablekey"); // FF
			checkbox.setAttribute("checked", !(highlightHidden == "true"));
			var checkboxNode = evt.target.childNodes;
			var checkbox = checkboxNode[0].$document.getElementById("highlight-enablekey-checkbox"); // IE
			if (checkbox)
				checkbox.setAttribute("checked", !(highlightHidden == "true"));
		
		});
	}
		
	// Hide searchbox
	if(self.getAttribute("optional") == "true")
	{
		var checkbox = this.framework.createElement("checkbox");
		checkbox.setAttribute("label", self.framework.localize("Show Searchbox"));
		
		if (self.getAttribute("hidden") == "true")
			checkbox.setAttribute("checked", "false");
		else
			checkbox.setAttribute("checked", "true");
		
		checkbox.addEventListener("command",
			function() {
				if (self.getAttribute("hidden") == "true")
					self.setAttribute("hidden", "false");
				else
					self.setAttribute("hidden", "true");
			}, false);
		node.appendChild(checkbox);
	}
	
	// Save history
	var checkbox = this.framework.createElement("checkbox");
	checkbox.setAttribute("label", self.framework.localize("Keep search history between different sessions"));
	
	if (self.getAttribute("history") == "true")
		checkbox.setAttribute("checked", "true");
	else
		checkbox.setAttribute("checked", "false");
	
	checkbox.addEventListener("command",
		function() {
			if (self.getAttribute("history") == "true") {
				self.setAttribute("history", "false");
				if (self.getAttribute("deletehistoryafteruncheck") == "true") 
					self.$clearHistory();
			}
			else
				self.setAttribute("history", "true");
		}, false);
	node.appendChild(checkbox);
	
	//Selection Search
	var spacer = this.framework.createElement("vbox");
	spacer.setAttribute("height", "5");
	node.appendChild(spacer);
	
	checkbox = this.framework.createElement("checkbox");
	checkbox.setAttribute("label", self.framework.localize("Add selected text into the search box"));
	
	if(self.getAttribute("captureselection") == "true")
		checkbox.setAttribute("checked", "true");
	else
		checkbox.setAttribute("checked", "false");
	
	checkbox.addEventListener("command",
		function() {
			if(self.getAttribute("captureselection") == "true")
				self.setAttribute("captureselection","false");
			else
				self.setAttribute("captureselection","true");
		}, false);
	node.appendChild(checkbox);

	// Use suggestions
	if (this.getAttribute("disablesuggest") != "true") {
		var checkbox = this.framework.createElement("checkbox");
		checkbox.setAttribute("label", self.framework.localize("Suggest popular searches"));
		
		if (self.getAttribute("suggest") == "true")
			checkbox.setAttribute("checked", "true");
		else
			checkbox.setAttribute("checked", "false");
		
		checkbox.addEventListener("command",
			function() {
				if (self.getAttribute("suggest") == "true")
					self.setAttribute("suggest", "false");
				else
					self.setAttribute("suggest", "true");
			}, false);
		node.appendChild(checkbox);
		
	}

	spacer = this.framework.createElement("vbox");
	spacer.setAttribute("height", "20");
	node.appendChild(spacer);
	
	// Clear history
	var button = this.framework.createElement("button");
	button.setAttribute("id", "ClearHistoryButton");
	button.setAttribute("label", self.framework.localize("Clear Search History"));
    button.setAttribute("persist", "disabled");
	
	var path = self.$Autocomplete.History.getFilePath();
	if( !self.framework.$fileExists(path) )
		button.setAttribute("disabled", "true");
	
	button.addEventListener("command", function () {
			button.setAttribute("disabled", "true");
			self.$clearHistory();
	}, false);
		
	node.appendChild(button);
};

dtxFramework.Searchbar.prototype.$setDesignMode = function(on) {
	this.$designMode = on;
};
