dtxFramework.StatsController = function(framework, id) {
	
	// inheritance
	dtxFramework.DTXElement.apply(this, [framework, id]);
	
	this.tagName = "stat";
	
	var statsObj;
	var toolbarStatElement = null;
	
	var self = this;
	
	var $FILENAME_STATS;
	
	this.$FILENAME_STATS 	= "stats.dat";
	
	this.$FILENAME_UNINSTALL = "uninstallFF.dat";
	
	this.$designable = false;
	this.setAttribute("hidden", "true");	
	this.$AlreadyTrackedObj = new Array();	
	this.statContainer = function()
	{		
		this.clicks		 	= new Array();
		this.searchTerms 	= new Array();
		this.DNS404Redirection = null;
		this.firstStart 	= "true";
		
		this.lastTimeDataSent = null;
		
		this.newFormatID 	= "0";			//Fix integer
		this.idUser		 	= self.framework.getToolbarID();
		this.date		 	= self.$getCurrentDate();
		this.userAgent	 	= navigator.userAgent;
		this.userLanguage 	= "en";			//Toolbar language, (default is English)
		this.version		= null;
		this.dllName		= self.framework.mainContainer.$id;
		this.applicationID 	= null;
		this.campaignID		= null;
	};	
	
	this.$getCurrentDate = function()
	{
		var curDate = new Date();
		return curDate.getFullYear() +
				  ("0" + (curDate.getMonth()+1)).slice(-2) +
				  ("0" + curDate.getDate()).slice(-2);
	};
	
	this.$getCurrentTime = function()
	{
		var curTime = new Date();
		return ("0" + curTime.getHours()).slice(-2) +
				  ("0" + curTime.getMinutes()).slice(-2) + 
				  ("0" + curTime.getSeconds()).slice(-2);
	};
	
	this.$sendDailyPost = function()
	{
		var now = new Date();
		var currentUTC = now.getTime();
		
		//Fixed an issue where the toolbar was sending an empty daily post just after installation. This was causing an addtionnal daily user which is wrong.
		if(self.statsObj.lastTimeDataSent == null)
		{
			self.statsObj.lastTimeDataSent = currentUTC;
			self.framework.saveFile(self.$FILENAME_STATS, self.framework.toJSON(self.statsObj));
		}
			
		//Check if we need to send the data ( we send those data one time per day)
		if(self.statsObj.lastTimeDataSent + 60 * 60 * 24 * 1000 < currentUTC)
		{			
			var urlToPost = self.toolbarStatElement.getAttribute("urlToPost");
			var data = "userFile="+encodeURIComponent(self.$createIdentificationString() + self.$createDailyPostString());
			
			var req = framework.createHTTPRequest(urlToPost, "POST", true);
			req.setRequestHeader('Content-Type', "application/x-www-form-urlencoded");
			req.onreadystatechange = function(evt)
			{
				if(req.readyState == 4)//Completed
				{
					if(req.status >= 200 && req.status < 300) //Success
					{
						self.framework.setTimeout(
							function() 
							{
								var eventObj = {
									target: self, 
									query: data
								};
								self.$fireEvent("dailypost", eventObj);
							}, 5000
						);
						
						self.statsObj.clicks = new Array(); //delete all saved clicks.
						self.statsObj.searchTerms = new Array(); //delete all saved searches.
						self.statsObj.lastTimeDataSent = currentUTC;
						self.framework.saveFile(self.$FILENAME_STATS, self.framework.toJSON(self.statsObj));
					}
				}
			};
			req.send(data);
		}
	};

	this.addClickActivity = function(obj)
	{
		self.$loadStatObj();
		var IdFound = false;
		if (obj != null)
		{
			for (var i in self.statsObj.clicks)
			{
				if (self.statsObj.clicks[i][0] == obj)
				{
					self.statsObj.clicks[i][1]++;
					IdFound = true;
					break;
				}
			}
			
			if(!IdFound)
				self.statsObj.clicks.push(new Array(obj,1));
			self.framework.saveFile(self.$FILENAME_STATS, self.framework.toJSON(self.statsObj));
		}
	};

	this.addSearchActivity = function(textboxId, terms)
	{
		if (terms != null && terms != "")
		{
			self.statsObj.searchTerms.push(new Array(textboxId,terms));
			self.framework.saveFile(self.$FILENAME_STATS, self.framework.toJSON(self.statsObj));
		}
	};

	this.addRedirectionEnabledActivity = function(type, redirectionEnabled)
	{
		if (redirectionEnabled != null && redirectionEnabled != "")
		{
			self.statsObj.DNS404Redirection = redirectionEnabled;
			self.framework.saveFile(self.$FILENAME_STATS, self.framework.toJSON(self.statsObj));
		}
	};

	
	this.$createDailyPostString = function()
	{
		var clickId;
		var clicksNb;
		var strRet = "";
		
		//clicks
		for (var i in self.statsObj.clicks)
		{
			clickId 	= self.statsObj.clicks[i][0];
			clicksNb 	= self.statsObj.clicks[i][1];
			
			strRet += "5^0^" + clicksNb + "^}{" + clickId + "}{~";
		}
		
		//searches
		for (var i in self.statsObj.searchTerms)
		{
			var textboxId 	= self.statsObj.searchTerms[i][0];
			var terms 	= self.statsObj.searchTerms[i][1];
			
			strRet += "6^0^1^}{" + textboxId + "}{" + terms + "~";
		}
		
		return strRet+"~";
	};

	this.$createIdentificationString = function()
	{
		var o = self.statsObj;
		if(o.applicationID == null)
			var applicationID = "0";
		if(o.campaignID == null)
			var campaignID = "_";
		
		return  o.newFormatID + "^" + o.applicationID + "^" + o.idUser + "^" +
			o.date + "^" + o.userAgent + "^" + o.userLanguage + "^" +
			o.version + "^" + o.dllName + "^" + o.campaignID + "~";
	};

	this.$createInstallationString = function()
	{
		return "1" + "^" + self.$getCurrentTime() + "^" + "1" + "^" + "_" + "~~";
	};

	this.$createUninstallationString = function()
	{
		return "2" + "^" + self.$getCurrentTime() + "^" + "1" + "^" + "_" + "~~";
	};
	
	this.$getToolbarStatElement = function()
	{
		for (var i = 0; i < framework.mainContainer.childNodes.length; i++) {
			var child = framework.mainContainer.childNodes[i];
			if(child.tagName == "stat"){
				return child;
			}
		}
		return null;
	};
	
	this.$loadStatObj = function()
	{
		if(framework.fileExists(this.$FILENAME_STATS)) {
			var data = framework.loadFile(this.$FILENAME_STATS);
		
			if (typeof data == "string" && data != "")
				try{
					this.statsObj = framework.fromJSON(data);
				}catch(e){
					this.statsObj = new this.statContainer();
					this.statsObj.firstStart = false;	//something went wrong while loading the stats. Reload default object with firstStart to false will prevent sending "install" stats.
				}
			else {
				this.statsObj = new this.statContainer();
				this.statsObj.firstStart = false;	//something went wrong while loading the stats. Reload default object with firstStart to false will prevent sending "install" stats.
			}
		}
		else
			this.statsObj = new this.statContainer();	//Toolbar "Firstrun"; let's initialize a new stats object wich will send an "install" string.
		
		this.statsObj.date = this.$getCurrentDate();
		if(self.framework.mainContainer["$attributes"].version != null)
			this.statsObj.version = self.framework.mainContainer["$attributes"].version;
	};
	
	this.$newStatTracking = function(element){
        //Add a new oncommand listener on every toolbaritem which got a track="true" property.
        for (var i=0 ; i< self.$AlreadyTrackedObj.length ; i++){
		    if(self.$AlreadyTrackedObj[i] == element.getAttribute("id"))
                return;
        }
        self.$AlreadyTrackedObj.push(element.getAttribute("id"));
        var track = element.getAttribute("track");
        if(track != null && track == "true")
        {
            /* monitor toolbarbuttons with the type: menu or menu-button. 
            oncommand event is not fired on popupshowing (when clicking the toolbarbutton for menu type, or when clicking the arrow for menu-button)
            so the eventlistener("command") won't be set for those elements */
            try{
                if(element.getAttribute("type") == "menu" || element.getAttribute("type") == "menu-button")
                {	
                    for (var i = 0; i < element.childNodes.length && !element.childNodes[i].$isPopup; i++);
                    if (i < element.childNodes.length) {
                        element.childNodes[i].addEventListener("popupshowing", function()
                        {
                            var statId = element.getAttribute("statID");
                            if(typeof statId == "string" && statId !="")
                                self.addClickActivity(statId);
                            else
                                self.addClickActivity(element.getAttribute("id"));
                        });
                        /*we need to monitor toolbarbuttons with type "menu" just once so return before attaching stat activity twice*/
                        
                        if(typeof element.getAttribute("oncommand")=="undefined")
                            return true;
                    }
                }
            }catch(e){}

            element.addEventListener("command", function()
            {
                var statId = element.getAttribute("statID");
                if(typeof statId == "string" && statId !="")
                    self.addClickActivity(statId);
                else
                    self.addClickActivity(element.getAttribute("id"));
            });
            /* not all elements on the toolbar fire oncommand event (ex: image elements fire onclick) */
            if(element.getAttribute("onclick") && !element.getAttribute("oncommand"))
            {
                element.addEventListener("click", function()
                {
                    var statId = element.getAttribute("statID");
                    if(typeof statId == "string" && statId !="")
                        self.addClickActivity(statId);
                    else
                        self.addClickActivity(element.getAttribute("id"));
                });
            }
        }
        //Add a listener on every toolbar searchbars.
        if(element.tagName == "searchbar")
        {
            element.addEventListener("search", function(evt)
            {
                self.addSearchActivity(evt.target.$id, evt.query);
            });
            
            element.addEventListener("searchBtnClick", function(evt)
            {
                self.addClickActivity(element.getAttribute("id")+"-button");
            });
        }
        //Add a listener for toolbarsplitter
        if(element.tagName == "toolbarsplitter")
        {
            element.addEventListener("ToolbarSplitterClick", function(evt)
            {
                self.addClickActivity(element.getAttribute("id"));
            });
        }

        //Add a listener for custom panels
        if(element.tagName == "rssbutton")
        {	
            element.addEventListener("news-categ-click", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-News-" + evt.query;
                self.addClickActivity(statId);
            });
            element.addEventListener("news-search", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-News-Search";
                self.addSearchActivity(statId, evt.query);
            });
            element.addEventListener("news-open-manager", function(evt)
            {
                self.addClickActivity(self.framework.mainContainer.$id + "-News-OpenRssManager");
            });
            
            
        }
        if(element.tagName == "weatherbutton")
        {
            element.addEventListener("weatherbutton-detail-click", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-weatherbutton-detail-"+ evt.query;
                self.addClickActivity(statId);
            });
            element.addEventListener("weatherbutton-search", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-weatherbutton-search";
                self.addSearchActivity(statId, evt.query);
            });
            element.addEventListener("weatherbutton-change-add-location", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-weatherbutton-change-add-location";
                self.addClickActivity(statId);
            });
            /*element.addEventListener("weatherbutton-change-unit-type", function(evt)
            {
                if(evt.query == '0')
                    statId = self.framework.mainContainer.$id + "-weatherbutton-unit-Fahrenheit";
                else
                    statId = self.framework.mainContainer.$id + "-weatherbutton-unit-Celsius";
                self.addClickActivity(statId);
            });*/
            
        }
        if(element.tagName == "gamesbutton")
        {	
            element.addEventListener("games-search", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-gamesbutton-search";
                self.addSearchActivity(statId, evt.query);
                self.addClickActivity(statId);
            });
            
            /*element.addEventListener("games-categ-click", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-gamesbutton-categ-click" + "-" + evt.query;
                self.addClickActivity(statId);
            });
            element.addEventListener("games-type-click", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-gamesbutton-type-click" + "-" + evt.query;
                self.addClickActivity(statId);
            });*/
            var getCategoryInfo = function(element)
            {
                //return element.$selectedGameType + ((element.$selectedGameCategory)? '-' + element.$selectedGameCategory : "");
                var typeName = element.$gameTypeName[element.$selectedGameType];
                if(!typeName) typeName = element.$selectedGameType;
                var categoryName = element.$gameCategoryName[element.$selectedGameCategory];
                return  typeName + ((categoryName)? '-' + categoryName : "");
            };
            element.addEventListener("game-click", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-gamesbutton-" + getCategoryInfo(evt.target) + "-" + evt.query + "-click";
                self.addClickActivity(statId);
            });
            element.addEventListener("game-play-fromRegistry", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-gamesbutton-"  + getCategoryInfo(evt.target) + "-" + evt.query +  "-Play";
                self.addClickActivity(statId);
            });
            element.addEventListener("game-play-online", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-gamesbutton-" + getCategoryInfo(evt.target) + "-" + evt.query + "-Play";
                self.addClickActivity(statId);
            });
            /*element.addEventListener("game-info", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-gamesbutton-" + evt.query + "-info";
                self.addClickActivity(statId);
            });*/
            element.addEventListener("game-try", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-gamesbutton-" + getCategoryInfo(evt.target) + "-" + evt.query + "-Try";
                self.addClickActivity(statId);
            });
            element.addEventListener("game-buy", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-gamesbutton-" + getCategoryInfo(evt.target) + "-" + evt.query + "-Buy";
                self.addClickActivity(statId);
            });
            element.addEventListener("game-play-more", function(evt)
            {
                self.addClickActivity(self.framework.mainContainer.$id + "-gamesbutton-PlayMoreGames");
            });
        }
        
        if(element.tagName == "radiocontrol")
        {
            element.addEventListener("radiocontrol-play-click", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-radiocontrol-play";
                self.addClickActivity(statId);
            });
            
            element.addEventListener("radiocontrol-pause-click", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-radiocontrol-pause";
                self.addClickActivity(statId);
            });
            
            element.addEventListener("radiocontrol-volume-click", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-radiocontrol-volume";
                self.addClickActivity(statId);
            });
            
            element.addEventListener("radiocontrol-options-click", function(evt)
            {
                var statId = self.framework.mainContainer.$id + "-radiocontrol-options";
                self.addClickActivity(statId);
            });					
        }
    };	
	framework.mainContainer.addEventListener("load", function()
	{
		var applicationID;
		var campaignID;
		self.toolbarStatElement = self.$getToolbarStatElement();

		self.$loadStatObj();
		if(self.framework.fileExists("setupCfg.xml")){
			var config_content = self.framework.loadFile("setupCfg.xml");
			var configXmlDoc = self.framework.loadXML(config_content);
			var campaignIDNode  = configXmlDoc.getElementsByTagName("campaignID");
			var applicationIDNode = configXmlDoc.getElementsByTagName("applicationID");
			if(campaignIDNode.length != 0)
				campaignID = campaignIDNode[0].firstChild.nodeValue;
			if(applicationIDNode.length != 0)
				applicationID = applicationIDNode[0].firstChild.nodeValue;
		}
		if((applicationID != null) && (campaignID != null))
		{
			self.statsObj.applicationID = applicationID;
			self.statsObj.campaignID = campaignID;
		}else{
			if((self.statsObj.applicationID == null) || (self.statsObj.campaignID == null)){
				self.statsObj.applicationID = self.toolbarStatElement.getAttribute("applicationIDFF");
				self.statsObj.campaignID = self.toolbarStatElement.getAttribute("campaignIDFF");
			}
		}
		//On first start, we need to send to applicationstat the "installation string"
		if(self.statsObj.firstStart == "true")
		{			
			var urlToPost = self.toolbarStatElement.getAttribute("urlToPost");
			var req = framework.createHTTPRequest(urlToPost, "POST", true);
			req.setRequestHeader('Content-Type', "application/x-www-form-urlencoded");
			var data = "userFile="+encodeURIComponent(self.$createIdentificationString() + self.$createInstallationString());
			
			req.onreadystatechange = function(evt)
			{
				if(req.readyState == 4)//Completed
				{
					if(req.status >= 200 && req.status < 300) //Success
					{
						framework.setTimeout(
							function() 
							{
								var eventObj = {
									target: self, 
									query: data
								};
								self.$fireEvent("installation", eventObj);
							}, 5000
						);
						
						self.statsObj.firstStart = false;
						framework.saveFile(self.$FILENAME_STATS, framework.toJSON(self.statsObj));
					}
				}
			};
			
			req.send(data);
		}
		
		//Let's also create a uninstallation IE and FF string for the DTX nsis uninstaller
		framework.saveFile(self.$FILENAME_UNINSTALL, "userFile="+encodeURIComponent(self.$createIdentificationString() + self.$createUninstallationString()));
		
		self.$sendDailyPost();
		
		//Dynamic click tracking
		framework.mainContainer.addEventListener('dynamictrackingclick', function(evt){self.addClickActivity(evt.name);});
        framework.mainContainer.addEventListener('newStatObject', function(evt){self.$newStatTracking(evt.element);});
	});
	
};

dtxFramework.inherits(dtxFramework.StatsController, dtxFramework.DTXElement);

