dtxFramework.Toolbar = function(framework, id) {

    // inheritance
    dtxFramework.BoxElement.apply(this, [framework, id]);
    
    this.tagName = "toolbar";
    
	// constants

    this.$ID_MAIN_TABLE = "-main-table";
	this.$ID_MAIN_CONTAINER = "-main-container";
	this.$ID_MAIN_SCROLLER = "-main-scroller";
	this.$ID_APPEND_NODE = "-append-node";
	this.$ID_MORE_CONTAINER = "-more-container";
	this.$ID_RIGHT_CONTAINER = "-right-container";
	this.$ID_SCROLL_ICON_LEFT = "-scroll-icon-left";
	this.$ID_SCROLL_ICON_RIGHT = "-scroll-icon-right";
	this.$ID_MORE_ITEM = "-more-item";
	this.$ID_SPECIAL_CONTAINER = "-special-container";
	this.$ID_OPTIONS_POPUP = "-options-popup";
	this.$ID_MOVE_TARGET = "-move-target";
    this.$ID_AUTOHIDDEN_CONTAINER = "-autohidden-container";

	var PATH_WIDGETS = "widgets\\";
	var FILENAME_WIDGETS = "widgets.xml";
	var FILENAME_WIDGET = "widget.js";

	this.$document = document;
	this.$mainTable = null;
	this.$mainContainer = null;
	this.$mainScroller = null;
	this.$scrollIconLeft = null;
	this.$scrollIconRight = null;
	this.$rightContainer = null;
	this.$moreMenu = null;
	this.$moreButton = null;
	this.$moreImage = null;
	this.$updatingMore = false;
	this.$resizingDisabled = false;
	this.$isTopElement = true;
	this.$resizeTimeout = 0;
	this.$optionsPopup = null;
	this.$moveTarget = null;
	this.$draggedElement = null;
	this.$movedElement = null;
	this.$lastWidth = -1;
	this.$flexer = null;
	this.$designScrollTimer = 0;
	this.$designScrollDir = 0;
	
	this.$currentModifyPanel = null;
	this.$currentModifyElementId = null;
	
	this.$openPopup = null;					//Keeps track of the top-level open menupopup (used for keyboard navigation)
	
	this.$initialized = false ;
	
	this.$WIDGET_TEXT = "Toolbar App";
	
	// add "more" interface controls
	this.$disableUpdates();
	this.$moreButton = this.$framework.createElement("toolbarbutton");
	this.$moreButton.$designable = false;
	this.$moreButton.setAttribute("id", this.$id + this.$ID_MORE_ITEM);
	this.$moreButton.setAttribute("image", "skin/lib/chevron.png");
	this.$moreButton.setAttribute("class", "dtx-more-item");
	this.$moreButton.setAttribute("priority", "-1");
	this.$moreButton.setAttribute("index", "10000");
	this.$moreButton.setAttribute("hidden", "true");
    this.$moreButton.setAttribute("nonserialize", "true");
	
	this.$prevLeft = 0;
	this.$moreMenu = this.$framework.createElement("menupopup");
	this.$moreMenu.setAttribute("id", this.$id + this.$ID_MORE_CONTAINER);
	this.$moreMenu.setAttribute("dtx-closeoncommand", "true");
	
	this.$optionsPopup = this.$framework.createElement("menupopup");
	this.$optionsPopup.setAttribute("id", this.$id + this.$ID_OPTIONS_POPUP);
	
	this.$moreBox = this.$framework.createElement("vbox");
	this.$moreBoxWidth = 40 ;
	
	this.$moreBox.setAttribute("class", "dtx-more-menu-mozilla");
    this.$autohiddenObjects = this.getElementById(this.$id + this.$ID_AUTOHIDDEN_CONTAINER);
    if(this.$autohiddenObjects == null){
        this.$autohiddenObjects = this.$framework.createElement("vbox");
        this.$autohiddenObjects.setAttribute("hidden", "true");   
        this.$autohiddenObjects.setAttribute("id", this.$id + this.$ID_AUTOHIDDEN_CONTAINER);  
        this.$autohiddenObjects.setAttribute("nonserialize", "true");               
        this.appendChild(this.$autohiddenObjects);
    }
	this.$moreMenu.$disableUpdates();
	this.$moreMenu.appendChild(this.$moreBox);
	this.$moreMenu.$enableUpdates();
	
	this.$moreButton.appendChild(this.$moreMenu);
	//this.appendChild(this.$moreButton);
	//this.appendChild(this.$moreImage);
	this.$enableUpdates();


	// self
	var self = this;

	this.addEventListener("newelement", function(evt) {
		var newElement = evt.element;
		if (newElement.parentNode ==  self && newElement.getAttribute("index") == null){
				// update index
				var lastIndex = -1;
				for (var i = 0; i < self.childNodes.length; i++) {
					var element = self.childNodes[i];
					var elementIndex = new Number(element.getAttribute("index"));
					if (elementIndex > lastIndex && element != self.$moreButton && element.getAttribute("id") != self.$moreButton.getAttribute("id"))
						lastIndex = elementIndex;
				}
				newElement.setAttribute("index", (lastIndex + 1) + "");
		}
	});

	this.addEventListener("afterapplytemplate", function(evt) {
		self.$init();
		self.framework.$applyPersistence();
	});

	if(dtxFramework.MOZILLA){
	    if(typeof AddonManager != 'undefined')
	    {
            AddonManager.addAddonListener({
			    onUninstalling: function(addon){self.revertBackSettings(addon.id);},
			    onDisabling: function(addon){self.revertBackSettings(addon.id);}
		    });
        }
   } 

   this.revertBackSettings = function(addonId)
   {
	   if (dtxFramework.MOZILLA && addonId == this.framework.guid){
			var hp = "about:home";
			var cs = "Yahoo";
			var revertBackValue = {accepted : false};
		   
			try {
				/* FROM AMO : Changes to the default and currently-selected search engine settings may only take place after users have explicitly opted-in, 
							  by taking a non-default action. Any such changes must be reverted when the add-on making them is disabled or uninstalled.
				*/
				window.openDialog("chrome://" + this.framework.applicationId + "/content/uninstall.xul", 
								  "UninstallDialog", "chrome, dialog, modal, centerscreen", revertBackValue).focus();
				if (revertBackValue.accepted) {
					var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

					var homepage = this.framework.loadFile("homepage_was_set.dat");
					var chromesearch = this.framework.loadFile("chromsearch_was_set.dat");

					var oldSearchScope = "";
					var oldHomepage = "";
					try {
						oldSearchScope = prefs.getCharPref('extensions.' + this.framework.applicationId + '.defaultsearch-before-install');
						oldHomepage = prefs.getCharPref('extensions.' + this.framework.applicationId + '.homepage-before-install');
						prefs.deleteBranch('extensions.' + this.framework.applicationId);
					} catch(e) {}
					
					if(oldHomepage && oldHomepage != "")
						hp = oldHomepage;
					if(oldSearchScope && oldSearchScope != "")
						cs = oldSearchScope;

					if (homepage != null) {	//revert homepage if we changed it at first run
						prefs.setCharPref("browser.startup.homepage", hp);
					}
					if (chromesearch != null) {	//revert chromsearch if we changed it at first run
						var searchService = Components.classes["@mozilla.org/browser/search-service;1"].getService(Components.interfaces.nsIBrowserSearchService);
						var searchEngine = searchService.getEngineByName(cs);
						searchEngine = searchService.getEngineByName(cs);
						if (searchEngine) {
							searchEngine.hidden = false;
							searchService.currentEngine = searchEngine;
							searchService.defaultEngine = searchEngine;
						}
					}
				 }
			} catch(ex) {}
			
			try{
				//Delete all prefenreces files and feed that we have created during the toolbar lifespan.
				var DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
				var path = (new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path;
					if (path.search(/\\/) != -1)
						path = path + "\\" + this.framework.dataFolder + "\\";
					else
						path = path + "/" + this.framework.dataFolder + "/";

				this.framework.$deleteFolder(path);
			} catch(ex) {}
	   }
   };
   
   this.$init = function() {

		// add "more" interface controls
		this.$disableUpdates();
        this.$autohiddenObjects = this.getElementById(this.$id + this.$ID_AUTOHIDDEN_CONTAINER);
		if(this.$autohiddenObjects == null){
            this.$autohiddenObjects = this.$framework.createElement("vbox");
            this.$autohiddenObjects.setAttribute("hidden", "true");   
            this.$autohiddenObjects.setAttribute("id", this.$id + this.$ID_AUTOHIDDEN_CONTAINER);  
            this.$autohiddenObjects.setAttribute("nonserialize", "true");               
            this.appendChild(this.$autohiddenObjects);
        }
        this.$moreButton = this.getElementById(this.$id + this.$ID_MORE_ITEM);
		if (this.$moreButton == null) {
			this.$moreButton = this.$framework.createElement("toolbarbutton");
			this.$moreMenu = this.$framework.createElement("menupopup");
			this.$moreBox = this.$framework.createElement("vbox");
			this.$moreMenu.$disableUpdates();
			this.$moreMenu.appendChild(this.$moreBox);
			this.$moreMenu.$enableUpdates();
			
			this.$moreButton.appendChild(this.$moreMenu);
			this.appendChild(this.$moreButton);
		}
		else
		{
			this.$moreButton.$designable = false;
			this.$moreMenu = this.getElementById(this.$id + this.$ID_MORE_CONTAINER);
			this.$moreBox = this.$moreMenu.childNodes[0];
		}
		this.$moreButton.setAttribute("nonserialize", "true");
		this.$moreButton.$designable = false;
		this.$moreButton.setAttribute("id", this.$id + this.$ID_MORE_ITEM);
		this.$moreButton.setAttribute("image", "skin/lib/chevron.png");
		this.$moreButton.setAttribute("class", "dtx-more-item");
		this.$moreButton.setAttribute("priority", "-1");
		this.$moreButton.setAttribute("index", "1000");
		this.$moreButton.setAttribute("hidden", "true");
		this.$moreButton.setAttribute("nonserialize", "true");
		this.$moreMenu.setAttribute("id", this.$id + this.$ID_MORE_CONTAINER);
		this.$moreMenu.setAttribute("dtx-closeoncommand", "true");
		this.$moreBox.setAttribute("class", "dtx-more-menu-mozilla");
		
		//this.appendChild(this.$moreImage);
		this.$optionsPopup = this.$framework.createElement("menupopup");
		this.$optionsPopup.setAttribute("id", this.$id + this.$ID_OPTIONS_POPUP);
		
		this.$enableUpdates();
		this.$initialized = true;

        var disableapps = this.$framework.mainContainer.getAttribute("disableapps");

		// widgets
        if (disableapps != "true"){
		    this.$disableUpdates();
		    this.$loadPreInstalledWidgets();
		    this.$loadWidgets();
		    this.$updateWidgets();
		    this.$enableUpdates();
		}				
	};
	
	this.$render = function() {
		//$MOZILLA_START$

		if (this.$domNode.localName == "div")
			return;
		// add popupset
		var popupset = document.createElement("popupset");
		popupset.setAttribute("id", this.$framework.applicationId + this.$framework.$ID_POPUP_CONTAINER);
		popupset.setAttribute("width", "0");
		popupset.setAttribute("height", "0");
		popupset.setAttribute("style", "width: 0px; height: 0px; overflow: hidden");
		this.$domNode.appendChild(popupset);

		/*			
		if (this.$designMode) {
			var scroller = document.createElement("vbox");
			scroller.setAttribute("align", "center");
			var scrollerIcon = document.createElement("image");
			scrollerIcon.setAttribute("src", this.framework.makeChromeURL("skin/lib/scroll-left.png"));
			scroller.appendChild(scrollerIcon);
			this.$domNode.appendChild(scroller);
		}
		*/
		var mainContainer;
		if (this.$designMode) {
			mainContainer = document.createElement("arrowscrollbox");
			mainContainer.setAttribute("orient", "horizontal");
			mainContainer.setAttribute("flex", "1");
		}
		else
			mainContainer = this.$domNode;
		
		// first add controls that float to the left
		for (var i = 0; i < this.childNodes.length; i++) {
			var child = this.childNodes[i];

			//added by supita widget and vmn condition to fix the blank buttons problems in modify mode (bug 5185 and bug 5198)
			if ((child.getAttribute("float") == "right")||
				(child.tagName=="widget")||
				(child.tagName=="vmn"))
					continue;
			
			if (child.$deferRender() ) 
				continue;

			
			var domNode = child.$createDOMNode();
			if (domNode == null) {
				domNode = this.$document.createElement("toolbaritem");
			}
			/*
			if (this.$designMode && child.$designMode &&
				domNode.tagName == "toolbarbutton" && 
				child.getAttribute("hidden") != "true") {
				
				domNode.setAttribute("class", "dtx-toolbar-design-mode");
			}
			*/
			domNode.setAttribute("id", child.$id);
			domNode.setAttribute(this.framework.applicationId, "true");
			if (this.$domNode.parentNode != null) {
				if (this.$designMode && child.$designMode && child.getAttribute("hidden") != "true") {
					domNode.setAttribute("class", "dtx-toolbar-design-mode");
					domNode.className = "dtx-toolbar-design-mode";
					//domNode.setAttribute("allowevents", "false");
				}
				mainContainer.appendChild(domNode);
			}
		}
		
		if (mainContainer != this.$domNode)
			this.$domNode.appendChild(mainContainer);
		
		// add flex
		var flexer = document.createElement("toolbaritem");
		flexer.setAttribute("flex", "1");
		if (this.$designMode) {
			flexer.setAttribute("minwidth", "20");
		}
		mainContainer.appendChild(flexer);
		this.$flexer = flexer;

		/*			
		if (this.$designMode) {
			var scroller = document.createElement("vbox");
			var scrollerIcon = document.createElement("image");
			scrollerIcon.setAttribute("src", this.framework.makeChromeURL("skin/lib/scroll-right.png"));
			scroller.appendChild(scrollerIcon);
			this.$domNode.appendChild(scroller);
		}
		*/
		
		// then add controls that float to the left
		for (var i = 0; i < this.childNodes.length; i++) {
			var child = this.childNodes[i];
			if (child.getAttribute("float") != "right")
				continue;
			
			var domNode = child.$createDOMNode();
			if (domNode == null) {
				domNode = this.$document.createElement("toolbaritem");
			}
			domNode.setAttribute("id", child.$id);
			domNode.setAttribute(this.framework.applicationId, "true");
			if (this.$domNode.parentNode != null)
				this.$domNode.appendChild(domNode);
		}
		//$MOZILLA_END$
	};
	
	this.insertBefore = function(item, beforeItem) {
		// Mozilla implementation
		
		this.$domNode.insertBefore(item, beforeItem);
		var getIndex = function(e) {
			var i = e.getAttribute("index");
			return (i != null && i != undefined)?new Number(i):0;
		};
		var nodes = this.$domNode.childNodes;
		var markerFound = false;
		for (var i = 0; i < nodes.length; i++) {
			var node = nodes[i];
			if (!markerFound) {
				markerFound = node == beforeItem;
				if (markerFound) {
					item.setAttribute("index", i);
				}
			}
			if (markerFound) {
				var idx = getIndex(node);
				node.setAttribute("index", idx + 1);
			}
		}
		
		this.$updateMoreMenu();
	};
	
	this.$updateMoreMenu = function() {
		if (this.$updatingMore || this.$updateDisabled > 0)
			return;
			
		this.$updatingMore = true;
		
		// helper functions
	
		var getPriority = function(e) {
			var p = e.getAttribute("priority");
			return (p != null && p != undefined)?new Number(p):0;
		};
		var getIndex = function(e) {
			var i = e.getAttribute("index");
			return (i != null && i != undefined)?new Number(i):0;
		};
		var sortCriteria = function(a, b) {
			// first, consider priority
			var pa = getPriority(a);
			var pb = getPriority(b);
			if (pa < pb)
				return -1;
			else if (pa > pb)
				return 1;
			else {
				// if same priority, consider index
				var ia = getIndex(a);
				var ib = getIndex(b);
				if (ia < ib)
					return -1;
				else if (ia > ib)
					return 1;
				else
					return 0;
			}
		};
				
		if (! this.$initialized)
			return;
			
		if (this.$designMode) {
			// do nothing if is being designed
		}
		else {
			var all = new Array();
			var nodes = this.childNodes;
			for (var i = 0; i < this.childNodes.length; i++) {
				var child = this.childNodes[i];
				if (getPriority(child) != -1 && child.getAttribute("float") != "right" && !child.$deferRender() ) {
					all.push(child);
				}
			}

			var getRightmostBorder = function() {
				var result = 0;
				for (var i = 0; i < self.childNodes.length; i++) {
					var element = self.childNodes[i];
					if (element.$domNode != null) {
						var border = element.$domNode.boxObject.x + element.$domNode.boxObject.width;
						if (border > result)
							result = border;
					}
				}
				return result;
			};
			var getAvailableSpace = function() {
				var rightBorder = 0;
				var leftBorder = self.$domNode.boxObject.width;
				for (var i = 0; i < self.childNodes.length; i++) {
					var element = self.childNodes[i];
					if (element.getAttribute("hidden") != "true" && element.$domNode != null) {
						if (element.getAttribute("float") != "right") {
							var border = element.$domNode.boxObject.x + element.$domNode.boxObject.width;
							if (border > rightBorder)
								rightBorder = border;
						}
						else {
							var border = element.$domNode.boxObject.x;
							if (border < leftBorder)
								leftBorder = border;
						}
					}
				}
				return leftBorder - rightBorder;
			};
			
			// first hide controls that do not fit	
			//Modified to add controls to the more menu as they appear in the toolbar - skanderk 08/13/2009
			all.sort(sortCriteria);
			var extraWidth = 0;
			var elementsBuffer = new Array();
			this.$disableUpdates();
			this.$moreBox.$disableUpdates();
			
			for(var k = this.$moreBox.childNodes.length - 1; k >= 0; k--) {
				elementsBuffer.push(this.$moreBox.childNodes[k]);
			}
			
			while (all.length > 0 && getRightmostBorder() > this.$domNode.boxObject.width + 3) {
				var toHide = all.pop();
				extraWidth += toHide.$domNode.boxObject.width;
				toHide.setAttribute("dtx-org-width", toHide.$domNode.boxObject.width);
				toHide.setAttribute("dtx-element-relocated", "true");
				this.removeChild(toHide);
				//this.$moreBox.appendChild(toHide);
				elementsBuffer.push(toHide);
				//toHide.$fireEvent("relocate", {target: toHide});
			}
			
			this.$moreBox.removeAll();
			while(elementsBuffer.length) {
				var toHide = elementsBuffer.pop();
				if(toHide.getAttribute(toHide.$autohidden) == "true")
					this.$autohiddenObjects.appendChild(toHide);
				else
					this.$moreBox.appendChild(toHide);
				
				if(toHide.getAttribute("dtx-element-relocated") == "true")
					toHide.$fireEvent("relocate", {target: toHide});
			}
			
			this.$enableUpdates();
			this.$moreBox.$enableUpdates();
			//this.$update();
			
			var availableSpace = getAvailableSpace();
				
			// then see if there is space for any of the hidden controls
			var needsUpdate = false;
			this.$disableUpdates();
			this.$moreBox.$disableUpdates();
			var moreAll = new Array();
			for (var i = 0; i < this.$moreBox.childNodes.length; i++) {
				var child = this.$moreBox.childNodes[i];
				if (child.getAttribute("hidden") != "true")
					moreAll.push(child);
			}
			for (var i = 0; i < this.$autohiddenObjects.childNodes.length; i++) {
				var child = this.$autohiddenObjects.childNodes[i];
				if (child.getAttribute("hidden") != "true" )
					moreAll.push(child);
			}
			moreAll.sort(sortCriteria);
			extraWidth = 0;
			for (var i = 0; i < moreAll.length; i++) {
				var element = moreAll[i];
				var orgWidth = new Number(element.getAttribute("dtx-org-width"));
				//this.$mainContainer.parentNode.offsetWidth - extraWidth > this.$mainContainer.offsetWidth + orgWidth
				if (availableSpace - extraWidth > orgWidth) {
					if(element.getAttribute(element.$autohidden) == "true")
						this.$autohiddenObjects.removeChild(element);
					else
						this.$moreBox.removeChild(element);
					this.appendChild(element);
					element.$fireEvent("relocate", {target: element});
					needsUpdate = true;
					extraWidth += orgWidth;
				}
			}
			this.childNodes.sort(
				function (a, b) {
					var idxA = new Number(a.getAttribute("index"));
					var idxB = new Number(b.getAttribute("index"));
					if (idxA < idxB)
						return -1;
					else if (idxA > idxB)
						return 1;
					else
						return 0;
				}
			);
			this.$enableUpdates();
			this.$moreBox.$enableUpdates();
			if (needsUpdate) {
				this.$update();
			}
			
			// hide "more" button if not needed
			var showChevron = false;
			for (var i = 0; !showChevron && i < this.$moreBox.childNodes.length; i++)
				showChevron = this.$moreBox.childNodes[i].getAttribute("hidden") != "true";
			if (showChevron)
				this.$moreButton.setAttribute("hidden", "false");
			else
				this.$moreButton.setAttribute("hidden", "true");
		}
		if (this.$designMode) {
			this.$moreButton.setAttribute("hidden", "true");
				// hide "chevron" button if not needed in design mode
		}
			
		this.$updatingMore = false;
		
	};
	
	this.forEach = function(fn) {
		var nodes = this.childNodes;
		for (var i = 0; i < nodes.length; i++) {
			var element = nodes[i];
			fn(element);
		}
		var moreMenu = this.$moreMenu;
		nodes = moreMenu.childNodes[0].childNodes;
		for (var i = 0; i < nodes.length; i++) {
			var element = nodes[i];
			fn(element);
		}
        var autohiddenNodes = this.$autohiddenObjects.childNodes;
        for(var i = 0; i < autohiddenNodes.length; i++){
            var element = autohiddenNodes[i];
			fn(element);
        }
	};
	
	this.$disableResizing = function() {
		this.$resizingDisabled = true;
	};
	
	this.$enableResizing = function() {
		this.$resizingDisabled = false;
	};
	

	
	// widgets
	this.$loadPreInstalledWidgets = function (){		
		this.forEach(function (element){
			if (element.tagName == "widget"){
				var manifest = element.getAttribute("manifest");
				element.setAttribute("manifest", manifest);
			}
		});
	};
	
	this.$loadWidgets = function() {
		var widgetRegistry = framework.loadFile(PATH_WIDGETS + FILENAME_WIDGETS,true);
		var pendingWidgets = new Array();
		
		if (widgetRegistry != null) {
			var widgetRegistryXML = framework.loadXML(widgetRegistry);
			
			if (widgetRegistryXML != null) {
				
				var widgets = widgetRegistryXML.documentElement.getElementsByTagName("widget");
				for (var i = 0; i < widgets.length; i++) {
					var widget   = widgets[i];
					var guid     = widget.getAttribute("id");
					var type     = widget.getAttribute("type");
					var status   = widget.getAttribute("status");
					var name     = widget.getAttribute("name");
					var codebase = widget.getAttribute("codebase");
					var inChrome = widget.getAttribute("location") == "chrome";

			    
					//$MOZILLA_START$//
					if (inChrome)
					{
						var path = framework.getExtensionDir();
					}
					else
					{
						var path = framework.getSpecialDir("ProfD") + '\\' + framework.getToolbarID();
					}
					if (path.search(/\\/) != -1)
						var widgetDir = path + "chrome\\content\\widgets\\";
					else
						var widgetDir = path + "/chrome/content/widgets/";
					//$MOZILLA_END$//

					if (status == "pending"){
						var zipname = codebase.substr(codebase.lastIndexOf("/") +1 , codebase.length);
						if (framework.$fileExists(widgetDir + zipname) == true)
							framework.$deleteFile(widgetDir + zipname);
						
						if (framework.$folderExists(widgetDir + guid) == true)
							framework.$deleteFolder(widgetDir + guid);
						
						pendingWidgets.push(widget);
						//widgetRegistryXML.documentElement.removeChild(widget);
						//var content = framework.serializeXML(widgetRegistryXML);
						//framework.saveFile(PATH_WIDGETS + FILENAME_WIDGETS, content, true);
						
					}else if (status == "updating"){
						var zipname = codebase.substr(codebase.lastIndexOf("/") +1 , codebase.length);
						if (framework.$fileExists(widgetDir + zipname) == true){
							framework.unZip(widgetDir + zipname , function unzip(){
								widget.removeAttribute("status");
								var content = framework.serializeXML(widgetRegistryXML);
								framework.saveFile(PATH_WIDGETS + FILENAME_WIDGETS, content, true);
								
								if (inChrome)
									var code = framework.loadChromeFile( "content\\" + PATH_WIDGETS + guid + "\\" + FILENAME_WIDGET);
								else
									var code = framework.loadFile(PATH_WIDGETS + guid + "\\" + FILENAME_WIDGET);
								if (code != null) {
										/* part here removed //not FF 40+ compatible */
								}
								
							});
						}
					} else {
						if (inChrome)
							var code = framework.loadChromeFile("content\\" + PATH_WIDGETS + guid + "\\" + FILENAME_WIDGET);
						else
							var code = framework.loadFile(PATH_WIDGETS + guid + "\\" + FILENAME_WIDGET);
						if (code != null) {
							try {
								/* part here removed //not FF 40+ compatible */
							}
							catch (e) {}
						}
					}
				}
				
				//Remove pending widgets
				for(var i = 0; i < pendingWidgets.length; i++) 
					widgetRegistryXML.documentElement.removeChild(pendingWidgets[i]);
				
				var content = framework.serializeXML(widgetRegistryXML);
				framework.saveFile(PATH_WIDGETS + FILENAME_WIDGETS, content, true);
				
			}
		}
	};

	
	this.$updateWidgets = function() {
		var widgetList = function widgetList(){
		    this.status = new Object(); // 0: default state 1: manifest download 2: code download 3: registry write 4: done
		    this.widgetsMap = new Object(); // contains only those widgest that have stale update times, guarenteed to have version info
			this.hasStaleManifests = false;
			this.hasStaleWidgetCode = false;

			this.widgetRegistryXML = null;
			this.widgets = null;
			
			this.getInternalId = function(id) {
                var identifierRegex = /\./g;
                return id.replace(this.identifierRegex, "$");
            };
		
		    var widgetRegistryXMLFile = framework.loadFile(PATH_WIDGETS + FILENAME_WIDGETS, true);
	        if (widgetRegistryXMLFile != null)
	            this.widgetRegistryXML = framework.loadXML(widgetRegistryXMLFile);
	        if (this.widgetRegistryXML != null) { //loaded XML widget list, lets check for stale widgets
                this.widgets = this.widgetRegistryXML.getElementsByTagName("widget");
                var now = new Date().getTime();
                for (var i = 0; i < this.widgets.length; i++) {
                    var widget = this.widgets[i];
                    var versionInfoArray = widget.getElementsByTagName("version");
                    if (versionInfoArray.length > 0) {
                        var versionInfo = versionInfoArray[0];
                        //alert("Updating: " + widget.getAttribute("name"));
                        if (now > parseInt(versionInfo.getAttribute("next-update"))) { //widget needs updating, let's check the manifest on the server to check for version number change
                            var identifier = this.getInternalId(widget.getAttribute("id"));
                            this.widgetsMap[identifier] = widget;
                            this.status[identifier] = 1;
                            this.hasStaleManifests = true;
                        }
                    }
                }
            }
			this.getWidget = function(id){ 
                	var identifier = id.replace(this.identifierRegex, this.identifierReplaceTo);
                	return this.widgetsMap[this.getInternalId(id)];				
			};
            this.getWidgetByCodebaseURL = function(url){
                for(var i in this.widgetsMap){
                    if(this.widgetsMap[i].getAttribute("codebase") == url) return this.widgetsMap[i];
                }
                return null;
            };
	        this.toString = function() {
			  	var returnString = "Widgets: \n";
				for(var i in this.status){
                   returnString += i + ": " + this.status[i] + "\n";
                }
				return returnString;
			 };  
	         this.getManifestURL = function(i) {
                if (this.getWidget(i).getElementsByTagName("version")[0].getAttribute("updateurl"))
                    return this.getWidget(i).getElementsByTagName("version")[0].getAttribute("updateurl");
                else
    		  	    return this.getWidget(i).getElementsByTagName("version")[0].getAttribute("manifest");
	         };
             this.getCodebaseURL = function(i) {
                 return this.getWidget(i).getAttribute("codebase"); 
             };
             this.setCodebaseURL = function(i, url){
                 this.getWidget(i).setAttribute("codebase", url);
             };
			 this.getVersionNumber = function(i) {
                return parseInt(this.getWidget(i).getElementsByTagName("version")[0].getAttribute("number"));
             };
			 this.setVersionNumber = function(i, version) {
                this.getWidget(i).getElementsByTagName("version")[0].setAttribute("number", version);
             };
	         this.setWidgetAttribute = function(widget, attribute , value) {
                widget.setAttribute(attribute, value);
             };            
             this.setWidgetVersion = function (widget, i){
                  var versionInfoArray = widget.getElementsByTagName("version");
                  if (versionInfoArray.length > 0) {
                     var versionInfo = versionInfoArray[0];                      
                     var nextUpdate = new Date().getTime() + (parseInt(versionInfo.getAttribute("update")) * 60000);
                     versionInfo.setAttribute("next-update", "" + nextUpdate);
                     var manifestUrl = this.getManifestURL(i);
                     versionInfo.setAttribute("manifest", manifestUrl);
                  }
             };
             
             this.replaceNode = function(i, node ){
                 //alert(framework.serializeXML(this.widgetRegistryXML));
                 var newNode = node.cloneNode(true);
                 var oldNode = this.getWidget(i);
                 var manifestUrl = this.getManifestURL(i);
                 
                 var versionInfoArray = newNode.getElementsByTagName("version");
                 if (versionInfoArray.length > 0) {
                    var versionInfo = versionInfoArray[0];                      
                    var nextUpdate = new Date().getTime() + (parseInt(versionInfo.getAttribute("update")) * 60000);
                    versionInfo.setAttribute("next-update", "" + nextUpdate);
                    versionInfo.setAttribute("manifest", manifestUrl);
                 }
                 
                 this.widgetRegistryXML.documentElement.removeChild(oldNode);  
                 this.widgetRegistryXML.documentElement.appendChild(newNode);
                 
                 this.widgetsMap[i] = newNode;
                 
             };
			 this.setStatus = function(i, status) {
                //alert(i + ": " + status);
			 	var identifier = this.getInternalId(i);
			 	this.status[identifier] = status;
				if(status == 3) {  
                    //set time to check for next update
				    var updateInterval = parseInt(this.widgetsMap[i].getElementsByTagName("version")[0].getAttribute("update")) * 60000;
				    var nextUpdate = new Date().getTime() + updateInterval;
					this.widgetsMap[i].getElementsByTagName("version")[0].setAttribute("next-update", "" + nextUpdate);
					//alert(new Date(nextUpdate).toLocaleString());
				    var writeRegistryBoolean = true;
					
                    for(var i in this.status){
						if(this.status[i] < 3) {
							writeRegistryBoolean = false;
						}
					}
					if(writeRegistryBoolean){
						this.writeRegistry();
					}
				}
			 };
			 this.writeRegistry = function(){
                  framework.saveFile(PATH_WIDGETS + FILENAME_WIDGETS, framework.serializeXML(this.widgetRegistryXML), true);
                  this.writeRegistryBoolean = false;
			 };
        
    	};
    };
        
	this.getErrorMessage = function (errorCode){
        var widgetText = this.$WIDGET_TEXT ;

        var msg = { 1: this.framework.sprintf(this.framework.localize("%s is pending restart of the browser!"),widgetText),
                    2: this.framework.sprintf(this.framework.localize("Could not install %s. Incompatible framework version."),widgetText),
                    3: this.framework.sprintf(this.framework.localize("Could not install %s. Invalid code. "),widgetText),
                    4: this.framework.sprintf(this.framework.localize("%s is already installed!"),widgetText),
                    5: this.framework.sprintf(this.framework.localize("Could not install %s. Failed to download code."),widgetText),
                    6: this.framework.sprintf(this.framework.localize("%s type is not zip type!"),widgetText),
                    7: this.framework.sprintf(this.framework.localize("Could not install %s. Location not trusted"),widgetText),
                    8: this.framework.sprintf(this.framework.localize("Could not install %s. Invalid manifest"),widgetText),
                    9: this.framework.sprintf(this.framework.localize("Could not install %s."),widgetText) 
                  };

		return msg[errorCode];
	}; 
	

	this.$showWidgetProgress = function(evt){
        if (evt.errorCode == 0) return;
        var type  = "error";
        var widgetText = this.$WIDGET_TEXT ;
       	var title = "install " + widgetText ;
		var msg = self.getErrorMessage(evt.errorCode);
 		framework.setTimeout ( function(){
				try{
					if (evt.window)
							evt.window.alert(msg);
					else
	                	framework.messageBox(title, msg, type);
				}catch(e){
	                	framework.messageBox(title, msg, type);				
				}
        }, 100);

	};
	
	this.$handleProgressWidget = function ( source, evt){
		if (source)
			source.$fireEvent("widgetprogress", evt);
		if (!evt.handled)
			self.$fireEvent("widgetprogress", evt);						
		if (!evt.handled)
		    self.$showWidgetProgress(evt);
	};

	this.dragObserver = {
	  getSupportedFlavours : function () {
		var flavours = new FlavourSet();
		flavours.appendFlavour("text/unicode");
		return flavours;
	  },
	  onDragOver: function (evt,flavour,session){},
	  onDrop: function (evt,dropdata,session){
		if (dropdata.data!=""){
			var data = new String(dropdata.data);
			
			// look for widget
			var pos = data.search(/dtx_widget/);
			if (pos != -1) {
				pos += new String("dtx_widget$").length;
				var manifestUrl = "http://";
				while (pos < data.length && data[pos] != '$') {
					manifestUrl += data[pos];
					pos++;
				}
				//self.$installWidget(manifestUrl);
			}
		}
	  }
	};
	this.$designDragObserver = {
		onDragStart: function (evt, transferData, action) {
			try{
			var txt=evt.target.getAttribute("elem");
			transferData.data=new TransferData();
			//transferData.data.addDataForFlavour("text/unicode",txt);
		   var nsIDragService = Components.interfaces.nsIDragService;
		   var dragService = Components.classes["@mozilla.org/widget/dragservice;1"].
				getService(nsIDragService);
		   var transArray = Components.classes["@mozilla.org/supports-array;1"].
							 createInstance(Components.interfaces.nsISupportsArray);
		   if (!transArray)
			return false;

            function getLoadContext() {
                return window.QueryInterface(Ci.nsIInterfaceRequestor)
                   .getInterface(Ci.nsIWebNavigation)
                   .QueryInterface(Ci.nsILoadContext);
            }
    
    
		   var trans = Components.classes["@mozilla.org/widget/transferable;1"].
							createInstance(Components.interfaces.nsITransferable);
		   if (!trans)
			  return;

		   trans.init(getLoadContext());
		   var genTextData = Components.classes["@mozilla.org/supports-string;1"].
								  createInstance(Components.interfaces.nsISupportsString);
		   if (!genTextData)
			return;

			var str = evt.target.src;
			if (str == null) str = "";
		  //  genTextData.data = str;
		  //  trans.addDataFlavor("text/unicode");
		  //  trans.setTransferData("text/unicode", genTextData, str.length * 2);

			var genTrans = trans.QueryInterface(Components.interfaces.nsISupports);
			transArray.AppendElement(genTrans);

			var target = evt.target;
							
			if (target.localName == "box")
				target = target.firstChild;

			 dragService.invokeDragSession(evt.target, transArray, null, nsIDragService.DRAGDROP_ACTION_COPY + 
				   nsIDragService.DRAGDROP_ACTION_MOVE);
		   }catch(e){
			   // alert(e.message + e.lineNumber);
			}
			
			}
	};
	this.$designDropObserver = {
		getSupportedFlavours : function () {
			var flavours = new FlavourSet();
			flavours.appendFlavour("text/unicode");
			return flavours;
		},
		onDragOver: function (evt,flavour,session){
		},
		onDrop: function (evt,dropdata,session){
		}
	};
	
};

dtxFramework.inherits(dtxFramework.Toolbar, dtxFramework.BoxElement);

dtxFramework.Toolbar.prototype.$connectDOM = function() {
	dtxFramework.BoxElement.prototype.$connectDOM.apply(this);
	
	this.$mainTable = this.$getNode(this.$id + this.$ID_MAIN_TABLE);
	this.$mainContainer = this.$getNode(this.$id + this.$ID_MAIN_CONTAINER);
	this.$mainScroller = this.$getNode(this.$id + this.$ID_MAIN_SCROLLER);
	this.$scrollIconLeft = this.$getNode(this.$id + this.$ID_SCROLL_ICON_LEFT);
	this.$scrollIconRight = this.$getNode(this.$id + this.$ID_SCROLL_ICON_RIGHT);
	this.$rightContainer = this.$getNode(this.$id + this.$ID_RIGHT_CONTAINER);
	this.$moreMenu = this.$framework.getElementById(this.$id + this.$ID_MORE_CONTAINER);
	this.$moreButton = this.$framework.getElementById(this.$id + this.$ID_MORE_ITEM);
	this.$moveTarget = this.$document.getElementById(this.$id + this.$ID_MOVE_TARGET);

	var self = this;
	
	function showOptionsPopup(element) {
		var eventObj = {target: self, "element": element, handled: false};
		self.fireEvent("getmodifypanel", eventObj);
		if (eventObj.handled)
			return null;
		
		var container = null;
		if (self.$currentModifyPanel != null && self.$currentModifyPanel.$window != null) {
			container = self.$currentModifyPanel.childNodes[0];
			container.removeAll();
		}
		else {
			self.$currentModifyPanel = element.framework.createElement("window");
			self.$currentModifyPanel.setAttribute("autoclose", "true");
			self.$currentModifyPanel.setAttribute("noframe", "true");
			
			// .bob for Check 
			// self.$currentModifyPanel.setAttribute("topmost", "true");
			self.$currentModifyPanel.setAttribute("parent", "toolbar");
						
			container = element.framework.createElement("vbox");
			self.$currentModifyPanel.appendChild(container);
			container.setAttribute("class", "dtx-toolbar-design-popup-container");
			var x = 0;
			var y = 0;
			var width = 0;
			//$MOZILLA_START$//
			x = element.$domNode.boxObject.screenX;	
			y = element.$domNode.boxObject.screenY + element.$domNode.boxObject.height;	
			//$MOZILLA_END$//
			self.$currentModifyPanel.show(x, y - 2, width, 0);
			self.$currentModifyPanel.addEventListener("close", 
				function(evt) {
					self.$currentModifyPanel = null;
					var item = self.getElementById(self.$currentModifyElementId);
					item.$domNode.className = "dtx-toolbar-design-mode";
					self.$currentModifyElementId = null;
				});
				
		}
		if (element.getAttribute("title") != null) {
			var label = element.$framework.createElement("label");
			label.setAttribute("value", element.getAttribute("title"));
			label.setAttribute("class", "dtx-toolbar-design-popup-title");
			container.appendChild(label);
		}
		var itemCount = container.childNodes.length;
		element.$fireEvent("getoptions", {
			target: element, 
			node: container,
			window: window,
			document: document
		});
		if (itemCount == container.childNodes.length)
			element.$renderOptions(container);
		var dx = 0;
		self.$currentModifyElementId = element.$id;
		element.framework.setTimeout(
			function(evt) {
				//$MOZILLA_START$//
				var w = container.$domNode.boxObject.width; 
				var h = container.$domNode.boxObject.height;
				if (x + w > window.screen.availWidth) {
					self.$currentModifyPanel.moveTo(window.screen.availWidth - w, h);
				}
				self.$currentModifyPanel.sizeTo(w, h);
				//$MOZILLA_END$//
			}, 1);
	
		//this.$currentModifyElementId = null;

	};
	
	if (!this.$designMode) {
		this.$designScrollDir = 0;
		this.framework.clearInterval(this.$designScrollTimer);
	}
			
	if (this.$designMode) {
		this.$framework.setTimeout(
			function() {
				//$MOZILLA_START$//
				self.$flexer.addEventListener("dragdrop", 
					function(evt) {
						var parent = self.$draggedElement.parentNode;
						parent.removeChild(self.$draggedElement);
						parent.insertBefore(self.$draggedElement, self.$flexer);
						
						// update index
						var lastIndex = -1;
						for (var i = 0; i < self.childNodes.length; i++) {
							var element = self.childNodes[i];
							var elementIndex = new Number(element.getAttribute("index"));
							if (elementIndex > lastIndex && element != self.$moreButton)
								lastIndex = elementIndex;
						}
						var item = self.getElementById(self.$draggedElement.getAttribute("id"));
						item.setAttribute("index", (lastIndex + 1) + "");
					}, false);
				//$MOZILLA_END$//
				for (var i = 0; i < self.childNodes.length; i++) {
					var child = self.childNodes[i];
					var toolbaritem = child.$domNode;
					if (child.$designMode && (self.$superEdit || child.getAttribute("float") != "right") && toolbaritem != null) {
						//$MOZILLA_START$//
						toolbaritem.setAttribute("dtx-id", child.$id);
							
						toolbaritem.onmouseup =
							function(evt) {
								var target = evt.target;
								while (target.parentNode.tagName != "arrowscrollbox")
									target = target.parentNode;
								target.setAttribute("class", "dtx-toolbar-design-mode-selected");
								showOptionsPopup(self.$framework.getElementById(target.getAttribute("dtx-id")));
								evt.cancelBubble = true;
							};
							
						toolbaritem.onmouseover =
							function(evt) {
								var target = evt.target;
								while (target.parentNode.tagName != "arrowscrollbox")
									target = target.parentNode;
								if (target.getAttribute("class") != "dtx-toolbar-design-mode-selected")
									target.setAttribute("class", "dtx-toolbar-design-mode-hot");
								evt.cancelBubble = true;
							};
							
						toolbaritem.onmouseout =
							function(evt) {
								var target = evt.target;
								while (target.parentNode.tagName != "arrowscrollbox")
									target = target.parentNode;
								if (target.getAttribute("class") != "dtx-toolbar-design-mode-selected")
									target.setAttribute("class", "dtx-toolbar-design-mode");
								evt.cancelBubble = true;
							};
						toolbaritem.addEventListener("draggesture", 
							function(evt) {
								var item = evt.target;
								while (item.getAttribute("dtx-id") == "") {
									item = item.parentNode;
								}
								self.$draggedElement = item;
								nsDragAndDrop.startDrag(evt, self.$designDragObserver);
							}, false);
						toolbaritem.addEventListener("dragover", 
							function(evt) {
								//nsDragAndDrop.dragOver(event, self.$designDropObserver);
							}, false);
						toolbaritem.addEventListener("dragdrop", 
							function(evt) {
								evt.cancelBubble = true;
								var item = evt.target;
								if (evt.currentTarget.getAttribute("id") == self.$draggedElement.getAttribute("id")) return;
								
								while (item.tagName != "toolbaritem") {
									item = item.parentNode;
								}
								var parent = self.$draggedElement.parentNode;
								parent.removeChild(self.$draggedElement);
								parent.insertBefore(self.$draggedElement, item);
								
								// update index
								var prev = self.getElementById(item.getAttribute("id"));
								item = self.getElementById(self.$draggedElement.getAttribute("id"));
								var index = new Number(prev.getAttribute("index"));
								item.setAttribute("index", index + "");
								for (var i = 0; i < self.childNodes.length; i++) {
									var element = self.childNodes[i];
									if (element != item) {
										var elementIndex = new Number(element.getAttribute("index"));
										if (elementIndex >= index) {
											element.setAttribute("index", (elementIndex + 1) + "");
										}
									}
								}
								//nsDragAndDrop.drop(event, self.$designDropObserver);
							}, false);
							
						//$MOZILLA_END$//
					}
				}
			}, 100);
	}
};
    
dtxFramework.Toolbar.prototype.$hookEvents = function() {
	//dtxFramework.BoxElement.prototype.$hookEvents.apply(this);
	
	var self = this;
	//$MOZILLA_START$//
	window.addEventListener("resize",
		function() {
			if (self.$resizingDisabled)
				return;
				
			if (self.$lastWidth == self.$domNode.boxObject.width)
				return;
				
			self.$lastWidth = self.$domNode.boxObject.width;
				
			if (self.$resizeTimeout != 0) {
				window.clearTimeout(self.$resizeTimeout);
			}
			self.$resizeTimeout = window.setTimeout(function() {
				self.$resizeTimeout = 0;
				self.$updateMoreMenu();
			}, 200);
		}, false);	
	//$MOZILLA_END$//
	
};
    
dtxFramework.Toolbar.prototype.$setDesignMode = function(on) {
	dtxFramework.BoxElement.prototype.$setDesignMode.apply(this, [on]);
	var self = this;
	
	// move items in >> to main toolbar
	var toMove = new Array();
	var moreMenu = this.$moreMenu;
	var nodes = moreMenu.childNodes[0].childNodes;
	for (var i = 0; i < nodes.length; i++) {
		toMove.push(nodes[i]);
	}
	this.$disableUpdates();
	moreMenu.$disableUpdates();
	for (var i = 0; i < toMove.length; i++) {
		var item = toMove[i];
		item.parentNode.removeChild(item);
		this.appendChild(item);
	}
	this.$enableUpdates();
	moreMenu.$enableUpdates();
	
	for (var i = 0; i < this.childNodes.length; i++) {
		var child = this.childNodes[i];
		if (this.$superEdit || child.getAttribute("float") != "right")
			this.$recurse(child,
				function(element) {
					if (element.$designable || self.$superEdit)
						element.$setDesignMode(on);
					return true;
				});
	}
	this.$update();
	this.framework.setTimeout(
		function(){
			self.$updateMoreMenu();
		}, 500);
};

dtxFramework.Toolbar.prototype.showOptions = function(source, featureId) {
	this.$fireEvent("showoptions", {target: this, "source": source, "featureId": featureId});
};


dtxFramework.Toolbar.prototype.setAttribute = function(attrid, value) {
	var oldValue = this.getAttribute('locale');
	
	dtxFramework.BoxElement.prototype.setAttribute.apply(this, [attrid, value]);

	if(attrid == 'locale' && oldValue != value){
		this.$fireEvent("localechanged", {target: this});
	}
};