//$MOZILLA_START$//

this.$mouseoverself = false;
this.$clickedoutside = true;
	

dtxFramework.ToolbarButton = function(framework, id) {
    // inheritance
    dtxFramework.XULWrapper.apply(this, [framework, id]);
    
    this.tagName = "toolbarbutton";
    //additional attributes to localize
    this.$localeAttributes = this.$localeAttributes.concat(["label","title","tooltiptext"]);
    
	this.$resizeTimeout = 0;
	var self = this;
	   
	this.addEventListener("command",
		function() {
			var url = self.getAttribute("href"); 
			if (typeof url == "string" && url != "") {
				self.framework.loadURI(url);
			}
		});

		this.addEventListener("mouseover",
		function() {
			self.$mouseoverself = true;
			
			if (self.$domNode){
				var ano = document.getAnonymousNodes(self.$domNode);
				for(var x=0; x<ano.length; x++){
					if(ano[x].tagName == "xul:toolbarbutton"){ //for toolbarbutton wich ARE type="menu-button"
						var ano = document.getAnonymousNodes(ano[x]);
						for(var x=0; x<ano.length; x++){
							if(ano[x].tagName == "xul:label"){
								ano[x].style.color = "#FFF";
							}
						}
					}
					else if(ano[x].tagName == "xul:label"){ //for toolbarbutton wich are NOT type="menu-button"
						ano[x].style.color = "#FFF";
					}
				}
			}
			
			var downarrow = (typeof self.getAttribute("downarrow") == "string" && self.getAttribute("downarrow") == "true");
			if (downarrow && self.parentNode.tagName == 'toolbar'){
				var downarrow = self.framework.getElementById(self.$id + "-downarrow-image");
				if(downarrow)
					downarrow.setAttribute("src", self.$framework.makeChromeURL('skin/lib/arrow-dn-small-over.png'));
			}
		});

		this.addEventListener("mouseout",
		function() {
			self.$mouseoverself = false;
			
			if (self.$domNode){
				var ano = document.getAnonymousNodes(self.$domNode);
				for(var x=0; x<ano.length; x++){
					if(ano[x].tagName == "xul:toolbarbutton"){	//for toolbarbutton wich ARE type="menu-button"
						var ano = document.getAnonymousNodes(ano[x]);
						for(var x=0; x<ano.length; x++){
							if(ano[x].tagName == "xul:label"){
								ano[x].style.color = "#58595B";
							}
						}
					}
					else if(ano[x].tagName == "xul:label"){	//for toolbarbutton wich are NOT type="menu-button"
						ano[x].style.color = "#58595B";
					}
				}
			}
			
			var downarrow = (typeof self.getAttribute("downarrow") == "string" && self.getAttribute("downarrow") == "true");
			if (downarrow && self.parentNode.tagName == 'toolbar'){
				var downarrow = self.framework.getElementById(self.$id + "-downarrow-image");
				if(downarrow)
					downarrow.setAttribute("src", self.$framework.makeChromeURL('skin/lib/arrow-dn-small.png'));
			}
		});
		
    this.$render = function() {
		var separator = (typeof this.getAttribute("separator") == "string" && this.getAttribute("separator") == "true");
		var downarrow = (typeof this.getAttribute("downarrow") == "string" && this.getAttribute("downarrow") == "true");
		
		if (!this.$designMode) {
			// toolbarbutton needs its own render only because Mozilla's implementation of XUL
			//	will not show child elements of the button if they are inserted after the button
			//	is inserted. This happens in Firefox 2 and 3.
			
			var hbox = (this.$domNode.childNodes.length > 0 && this.$domNode.childNodes[0].tagName == "hbox")?this.$domNode.childNodes[0]:null;
			
			//add overlay if any [[[
			if(typeof this.getAttribute("overlay") == "string" && this.getAttribute("overlay") != "")
				this.setOverlay();
			//]]]
			
			for (var i = 0; i < this.childNodes.length; i++) {
				var child = this.childNodes[i];
				if (child.$deferRender())
					continue;
					
				var domNode = child.$createDOMNode();
				if (domNode != null) {
					domNode.setAttribute("id", child.$id);
					if (domNode.parentNode == null) {
						if (hbox == null || child.$isPopup)	
							this.$domNode.appendChild(domNode);
						else
							hbox.appendChild(domNode);
					}
				}
			}

			//For Toolbar Buttons that have just one action : to open a menupopup. PM wanted to have an downarrow to the right of those buttons; but with a different look than normal toolbarbutton type="menu-button".
			if (downarrow && this.parentNode.tagName == 'toolbar'){
				var downarrow = this.framework.getElementById(this.$id + "-downarrow-image");
				if(!downarrow){
					downarrow = document.createElement("image");
					downarrow.setAttribute("id", this.$id + "-downarrow-image");
					downarrow.setAttribute("persist", "hidden");
					downarrow.setAttribute("class", this.$id + "-dtx-button-downarrow-container");
					downarrow.setAttribute("src", this.$framework.makeChromeURL('skin/lib/arrow-dn-small.png'));
					this.$domNode.appendChild(downarrow);
				}
			}
				
			if (separator && this.$domNode.parentNode.tagName == 'toolbar'){
				var separator = this.framework.getElementById(this.$id + "-separator");
				if(!separator){
					separator = document.createElement("toolbarseparator");
					separator.setAttribute("id", this.$id  + "-separator");
					separator.setAttribute("persist", "hidden");
					separator.setAttribute("class", "dtx-toolbarseparator");
					separator.setAttribute("hidden", (this.getAttribute("hidden") == "true"));
					this.$domNode.parentNode.insertBefore(separator, this.$domNode.nextSibling);
				}
			}
			
			
			if (this.$domContent != null)
				if (hbox == null)	
					this.$domNode.appendChild(this.$domContent);
				else
					hbox.appendChild(this.$domContent);
		}
		else {
			var image = this.getAttribute("image");
			this.$domNode.style.paddingTop = "4px";
			if (typeof image == "string" && image != "") {
				var vbox = document.createElement("vbox");
				var img = document.createElement("image");
				img.setAttribute("src", image);
				img.setAttribute("flex", "0");

				//added by supita - BEGIN: fixing bug 5186> In Modify mode, if the image width of a button is not 
				//16x16, the toolbar get distorted because of not using the attributes imageheight and imagewidth
				if(this.getAttribute("imageheight")!=null)
					img.setAttribute("height",this.getAttribute("imageheight"));
				if(this.getAttribute("imagewidth")!=null)
					img.setAttribute("width",this.getAttribute("imagewidth"));
				//added by supita - END: fixing bug 5186

				vbox.appendChild(img);
				this.$domNode.appendChild(vbox);
			}
			var label = this.getAttribute("label");
			if (typeof label == "string" && label != "") {
				var text = document.createElement("label");
				text.setAttribute("value", label);
				this.$domNode.appendChild(text);
			}
			var vbox = document.createElement("vbox");
			var img = document.createElement("image");
			img.setAttribute("src", this.framework.makeChromeURL("skin/lib/move.gif"));
			img.setAttribute("flex", "0");
			img.setAttribute("style", "margin-top: 3px;");
			vbox.appendChild(img);
			this.$domNode.appendChild(vbox);
		}

        if(dtxFramework.MOZILLA && navigator.platform.indexOf('Mac') != -1){
            window.setTimeout(function(){
                if (self.$domNode){
                    var ano = document.getAnonymousNodes(self.$domNode);
                    for(var x=0; x<ano.length; x++){
                        if(ano[x].tagName == "xul:toolbarbutton"){ //for toolbarbutton wich ARE type="menu-button"
                            var ano = document.getAnonymousNodes(ano[x]);
                            for(var x=0; x<ano.length; x++)
                                if(ano[x].tagName == "xul:label" && ano[x].getAttribute("value").trim() != "")
                                    ano[x].setAttribute("value", " " + ano[x].getAttribute("value").trim());
                        }
                        else if(ano[x].tagName == "xul:label") //for toolbarbutton wich are NOT type="menu-button"
                            ano[x].setAttribute("value", " " + ano[x].getAttribute("value"));
                    }
                }
            }, 250);
        }
		
		//get the tag name of the first child node:
		var mcollkids = this.childNodes;
		var mPanelNode = null;
		var mFirstKid = null;
		var mTagName = "";
		if(mcollkids.length > 0) {
			mFirstKid = mcollkids[0];
			if(mFirstKid) {
				mTagName = mFirstKid.tagName;
			}
		}
		//if there is a panel to be shown:
		if(mTagName == "panel") {
		//build a dummy popup menu
			var dummyMPU = document.createElement("menupopup");
			dummyMPU.setAttribute("height", 0);
			dummyMPU.setAttribute("width", 0);

			dummyMPU.addEventListener("popupshowing", function(evt) {
				try{
					if(self.$panel) {
						//panel was already visible (it's the second click on the toolbar button) -> hide thepanel
						self.$panel.hidePanel();
						self.$panelShown = false;
						self.$panel = null;
						//hide the dummy popup after a while...
						var delayed = function() { 
							dummyMPU.hidePopup(); 
						};
						setTimeout(delayed, 10);
					}
					else { //set up and show the panel:
						mPanelNode = mFirstKid;
						
//						self.$panel = framework.createElement("panel");
						self.$panel = mPanelNode;
						self.$panel.setTransparentColor(mPanelNode.getAttribute("transparencycolor"));
						self.$panel.showRelative(self, 0, 25);

						self.$panel.addEventListener("close", function(evt) {
							if(self.$mouseoverself == false)
								self.$clickedoutside = true;
							else
								self.$clickedoutside = false;
							if(self.$clickedoutside == true)
								self.$panel = null;
						}, false);

						this.addEventListener("hide", function(evt) {
							if(self.$mouseoverself == false)
								self.$clickedoutside = true;
							else
								self.$clickedoutside = false;
							if(self.$clickedoutside == true)
								self.$panel = null;
						}, false);
					}
					return false;
				}catch(e)	{
				}
			}, false);

			// attach the dummy menupopup to the button:
			if (this.$domNode != null)
				this.$domNode.appendChild(dummyMPU);
		}
	};

	this.setOverlay = function(){
		try{
			var value = this.getAttribute("overlay");
			var MainBox = this.framework.getElementById(this.$id + '-overlay-container');
			if(!MainBox){
				var MainBox = document.createElement("div");
				MainBox.setAttribute("id", this.$id + '-overlay-container');
				MainBox.setAttribute("class", 'dtx-notify-label-container-ff');
				
				var LabelBox = document.createElement("hbox");
				LabelBox.setAttribute("id", this.$id + '-overlay-vbox');
				LabelBox.setAttribute("class", "dtx-notify-label-vbox-ff");

				var	buttonLeft   = this.$domNode.boxObject.x;
				var	buttonTop    = this.$domNode.boxObject.y;

				if(buttonLeft > 0 && buttonTop >0){
					var label = document.createElement("label");
					label.setAttribute("id", this.$id + '-overlay-label');
					label.setAttribute("class", "dtx-notify-label-ff");
					label.setAttribute("value", value);			
					LabelBox.appendChild(label);
					MainBox.appendChild(LabelBox);
					this.$domNode.parentNode.insertBefore(MainBox, this.$domNode);
				}
			}else{
				var label = this.framework.getElementById(this.$id + '-overlay-label');
				label.setAttribute("value", value);
			}
		}catch(e){this.$framework.getLogger().info("Error in setOverlay: " + e.message);}
	};
};

dtxFramework.inherits(dtxFramework.ToolbarButton, dtxFramework.XULWrapper);

dtxFramework.ToolbarButton.prototype.getAttribute = function(attrid) {
	var inherited = dtxFramework.XULWrapper.prototype.getAttribute.apply(this, [attrid]);
	if (attrid == "checked" && this.$domNode != null)
		return this.$domNode.getAttribute("checked");
	else
		return inherited;
};

dtxFramework.ToolbarButton.prototype.setAttribute = function(attrid, value) {
	var lastValue = (attrid == "label")?this.$attributes[attrid]:"";
	dtxFramework.XULWrapper.prototype.setAttribute.apply(this, [attrid, value]);
	/*
	if (attrid == "hidden") {
		if (this.parentNode != null && this.parentNode.tagName == "toolbar") {
			this.parentNode.$updateMoreMenu();
		}
	}
	*/
	self = this;

	if (attrid == "ondropdownclick"){
		var menupopup = document.createElement("menupopup");
		if (this.$domNode != null)
			this.$domNode.appendChild(menupopup);
	}
	

	if (attrid == "label" && 
		this.parentNode != null && 
		this.parentNode.tagName == "toolbar" && 
		this.$domNode != null &&
		value != lastValue) {
		
		this.framework.setTimeout(
			function () {
				if (self.parentNode != null)
					self.parentNode.$updateMoreMenu();
			}, 250);
	}
	
	if (attrid == "imageheight"){
		if (this.$domNode){
			if (this.$domNode.boxObject.firstChild && this.$domNode.boxObject.firstChild.tagName == "xul:image")
				this.$domNode.boxObject.firstChild.height = value ;
			else if (this.$domNode.boxObject.firstChild && this.$domNode.boxObject.firstChild.boxObject.firstChild && this.$domNode.boxObject.firstChild.boxObject.firstChild.tagName == "xul:image")
				this.$domNode.boxObject.firstChild.boxObject.firstChild.height = value ;
		}
	}
	
	if (attrid == "imagewidth"){
		if (this.$domNode){
			if (this.$domNode.boxObject.firstChild && this.$domNode.boxObject.firstChild.tagName == "xul:image")
				this.$domNode.boxObject.firstChild.width = value ;
			else if (this.$domNode.boxObject.firstChild && this.$domNode.boxObject.firstChild.boxObject.firstChild && this.$domNode.boxObject.firstChild.boxObject.firstChild.tagName == "xul:image")
				this.$domNode.boxObject.firstChild.boxObject.firstChild.width = value ;
		}
	}
	if (attrid == "overlay")
		this.$update();
};


dtxFramework.ToolbarButton.prototype.$applyStyle = function() {
	dtxFramework.XULWrapper.prototype.$applyStyle.apply(this);
};

dtxFramework.ToolbarButton.prototype.$applyAttributes = function() {
	dtxFramework.XULWrapper.prototype.$applyAttributes.apply(this);
	
	// find a nested popup
	var type = this.getAttribute("type");
	if (type != "menu" && type != "menu-button") {
		var i = 0;
		for (; i < this.childNodes.length && !this.childNodes[i].$isPopup; i++);
		if (i < this.childNodes.length) {
			this.$popup = this.childNodes[i];
			this.setAttribute("popup", this.$popup.$id);
		}
	}
	if (this.$designMode) {
		this.setAttribute("disabled", "true");
		if (this.$domNode != null) {
			this.$domNode.setAttribute("class", "dtx-toolbar-design-mode");
		}
	}
	else
		this.setAttribute("disabled", "false");
		
	if (!(this.getAttribute("orient") == "vertical" || this.parentNode != null && this.parentNode.getAttribute("orient") == "vertical")) 	
		this.setAttribute("orient", "horizontal");
		
	this.$domNode.ondraggesture = function(evt) {};	
	//this.$domNode.setAttribute("style", "-moz-appearance: none; -moz-border-radius: 5px;");
};

dtxFramework.ToolbarButton.prototype.$createDOMNode = function() {
	// toolbarbutton needs an "hbox" inside because mozilla's implementation of XUL
	//	will not show child elements of the button if they are inserted after the button
	//	is inserted. If the hbox is appended to the button and then the button is appended
	//	to the toolbar, elements appended to the hbox will show. This happens in Firefox 2 and 3.
	if (!this.$designMode) {
		var btn = document.createElement("toolbarbutton");
		var useHBox = this.$domContent != null;
		for (var i = 0; i < this.childNodes.length && !useHBox; i++) {
			useHBox = !this.childNodes[i].$isPopup && !this.childNodes[i].$deferRender();
		}
		if (useHBox) {
			var hbox = document.createElement("hbox");
			btn.appendChild(hbox);
		}
		return btn;
	}
	else {
		var item = document.createElement("hbox");
	}
};

//$MOZILLA_END$//

dtxFramework.ToolbarButton.prototype.$renderOptions = function(node) {
    var self = this;
    if(self.getAttribute("optional") == "true"){
        var checkbox = this.$framework.createElement("checkbox");
        checkbox.setAttribute("label", "Show button");
        if (self.getAttribute("hidden") != "true") 
            checkbox.setAttribute("checked", "true");
        checkbox.addEventListener("command",
            function() {
                if (self.getAttribute("hidden") != "true") {
                    self.setAttribute("hidden", "true");
                }
                else {
                    self.setAttribute("hidden", "false");
                }
            }, false);
        node.appendChild(checkbox);  
    } else {
       var label = this.$framework.createElement("label");
       label.setAttribute("value", "No options for this item");
       node.appendChild(label);
    }
};

dtxFramework.ToolbarButton.prototype.getPopup = function() {
	return this.$popup;
};

