//$MOZILLA_START$//

dtxFramework.ToolbarSplitter = function(framework, id) {
    // inheritance
    dtxFramework.XULWrapper.apply(this, [framework, id]);
    
    this.tagName = "toolbarsplitter";
    //additional attributes to localize
    this.$localeAttributes = this.$localeAttributes.concat(["tooltiptext"]);
    
	this.$designable = true;

	//set default splitter image
    this.$icon = null;
    this.$ID_ICON =  '-icon';
    
	this.setAttribute('image','skin/lib/toolbarsplitter.gif');
    
    this.$render = function() {
		var gripper = document.createElement("vbox");		
		var gripperImg = document.createElement("image");
        gripperImg.setAttribute("id",this.$id + this.$ID_ICON);
		gripperImg.setAttribute("src", self.$framework.makeChromeURL(this.getAttribute('image')));
		gripperImg.setAttribute("style","padding-left: 2px;");
		gripper.appendChild(gripperImg);
		this.$domNode.appendChild(gripper);
		
		this.$domNode.setAttribute("collapse", "none");
		this.$domNode.setAttribute("resizebefore", "grow");
		this.$domNode.setAttribute("resizeafter", "flex");
		
		if (this.$designMode)
			this.$domNode.setAttribute("class", "dtx-toolbar-design-mode");
		else
			this.$domNode.setAttribute("class", "dtx-resize-splitter");
    };
    
    var self = this;
    
    this.$onclick = function(evt) {
	    if (self.parentNode != null && self.parentNode.tagName == "toolbar") {
			if (self.$target != null) {
				self.$target.setAttribute("width", self.$target.$domNode.boxObject.width);
				//fire event everytime a click on splitter has been made - stat purpose
				self.$fireEvent("ToolbarSplitterClick", {target:self});
			}
	        self.parentNode.$updateMoreMenu();
	    }
		evt.stopPropagation();
    };
};

dtxFramework.inherits(dtxFramework.ToolbarSplitter, dtxFramework.XULWrapper);

dtxFramework.ToolbarSplitter.prototype.getAttribute = function(attrid, value) {
	var inherited = dtxFramework.XULWrapper.prototype.getAttribute.apply(this, [attrid]);
	if (attrid == "priority")
		return "-1";
	else
		return inherited;
};
dtxFramework.ToolbarSplitter.prototype.setAttribute = function(attrid, value) {
    if (attrid == "image" && value !=''){
        value = this.$framework.makeChromeURL(value);
        if (this.$icon != null && this.$icon.getAttribute("src") != value)
            this.$icon.setAttribute("src", value);
    }
    dtxFramework.XULWrapper.prototype.setAttribute.apply(this, [attrid, value]);
};
dtxFramework.ToolbarSplitter.prototype.$hookEvents = function() {
	dtxFramework.XULWrapper.prototype.$hookEvents.apply(this);
		
	this.$domNode.removeEventListener("mouseup", this.$onclick, false);
	this.$domNode.addEventListener("mouseup", this.$onclick, false);
};

dtxFramework.ToolbarSplitter.prototype.$connectDOM = function() {
	dtxFramework.XULWrapper.prototype.$connectDOM.apply(this);
	this.$icon = this.$getNode(this.$id + this.$ID_ICON);	
	this.$findTarget();
};

dtxFramework.ToolbarSplitter.prototype.$createDOMNode = function() {
	var splitter = document.createElement("splitter");
	splitter.setAttribute("class", "plain");
	return splitter;
};

//$MOZILLA_END$//

dtxFramework.ToolbarSplitter.prototype.$findTarget = function() {
	var index = new Number(this.getAttribute("index"));
	var closestIdx = -1;
	var closestElement = null;
	for (var i = 0; i < this.parentNode.childNodes.length; i++) {
		var element = this.parentNode.childNodes[i];
		if (element.$resizeable) {
			var idx = new Number(element.getAttribute("index"));
			if (index - idx >= 0) {
				if (idx > closestIdx) {
					closestIdx = idx;
					closestElement = element;
				}
			}
		}
	}
	if (closestElement != null)
		this.$target = closestElement;
	else
		this.$target = null;
};
    
