dtxFramework.Vmn = function(framework, id) {
	//Inheritence
	dtxFramework.Template.apply(this, [framework, id]);
	
	this.tagName = 'vmn';
	var self = this;
	
	this.locationService = framework.getLocationService();
	
	this.$ID_SEARCH_OPTION_BUTTON = "search-options";
	this.$ID_SEARCH_OPTION_POPUP = "search-options-popup";
	this.$ID_SEARCH_OPTION_HBOX	= "search-options-hbox";
	this.$ID_SEARCH_OPTION_ITEM	= "search-options-item";
	
	this.about = null;							//About dialog
	this.$prefDialog = null;					//Preferences dialog
	this.searchbar = null;
	this.stats = null;
	
	//About dialog properties
	this.aboutWindow = null;
	
	//Preferences dialog properties
	this.$prefDialogWidth = 510;
	this.$prefDialogHeight = 520;
	this.$prefDialogX = 300;
	this.$prefDialogY = 200;
	this.$useLocationData = true;
	
	//Stats related properties
	this.applicationID = null;
	this.campaignID = null;
	
	this.$homepage = null;
	
	this.$multipleWebSearch = null;		
	this.$webSearchEngines = new Array();
	
	
	//Template attributes	
	this.$useDefaultSkin = null;
	this.$useSkins = null;
	this.$excludedFeatures = null;
    this.$numberOfColumns = 3;
    this.$deferRender = function() {return true;};

	this.HBOX_INVISIBLE_ID = framework.applicationId + "invisible_misc_box";
	this.MISC_PANE_ID = framework.applicationId + '-preferences-misc';
	
	this.$init = function() {
		self.$firstRun = self.framework.mainContainer.getAttribute('firstrun') == 'true';
		self.$getAttributes();		//Read template's attributes

		self.framework.mainContainer.forEach(function(element) {self.$processElement(element);});
		self.framework.addEventListener(this, "beforenavigate",	function(src, url) {
			try{
				url = url.toLowerCase();
				if (url.indexOf("alexa") != -1) {
					return;
				}else if (url.indexOf("___campaignid___") != -1) {
					src.cancel = true;
					url = url.replace("___campaignid___", self.stats.getAttribute("campaignIDIE"));
					src.newUrl = url;
				}
			}catch(e){}
		});
		self.framework.mainContainer.addEventListener("newelement", function(evt){
	        var element = evt.element;
		   	if (element){
		   		if (	element.tagName == "toolbarbutton"){
		            self.$setButtonClass(element);
		        }else if (  element.tagName == "rssbutton" || 
		        			element.tagName == "weatherbutton" ||
		        			element.tagName == "appbutton" ||
		        			element.tagName == "htmlpanelbutton"	){
			   	   
		        	
					self.$setElementClass(element);
		        }
            }
		});
		
		self.framework.mainContainer.addEventListener('localechanged', function(evt){
			self.$processSettingsMenu();
		});		

		self.framework.mainContainer.addEventListener("attributechange", function(evt) {
			if (evt.id == "toolbarname"){
				self.$replaceToolbarName();
			}
		});
		
		self.framework.mainContainer.addEventListener("generatemiscpane", function(proxy) {
			var hiddenElement = framework.mainContainer.getElementById(self.HBOX_INVISIBLE_ID),
				paneObj = framework.mainContainer.getElementById(self.MISC_PANE_ID),
				paneTitle = proxy.paneTitle || "Miscellaneous";
					
			if (!paneObj) {
				paneObj = framework.createElement('prefpane');
				paneObj.setAttribute('id', self.MISC_PANE_ID);
				paneObj.setAttribute('label', paneTitle);
				paneObj.setAttribute('image', framework.makeChromeURL('skin/lib/misc-panel-config-tab-icon.png'));
				paneObj.setAttribute('for', self.HBOX_INVISIBLE_ID);
			}
			
			if (!hiddenElement) {
				hiddenElement = framework.createElement("hbox");
				hiddenElement.setAttribute("id", self.HBOX_INVISIBLE_ID);
				hiddenElement.setAttribute("persist", "toolbarhidden");
				hiddenElement.setAttribute("hidden", "true");
				
				hiddenElement.addEventListener('getprefpane', function(evt) {
					evt.result = paneObj;
				});
				
				framework.mainContainer.appendChild(hiddenElement);
				self.framework.$applyPersistenceToElement(hiddenElement);
			}
			
			proxy.hiddenElement = hiddenElement;
		});

		self.$addToolbarEventHandlers();
		self.$processSettingsMenu();
		self.$processControls();
		self.$exportToNamespace();
				
		self.$onfirstrun();
	};
	
	//Get template's attributes
	this.$getAttributes = function() {
		var attributeValue;
		
		attributeValue = this.getAttribute('usedefaultskin');
		if(typeof attributeValue == 'string' && attributeValue == 'true') {
			this.$useDefaultSkin = true;
		}
		else {
			this.$useDefaultSkin = false;
		}
		
		attributeValue = this.getAttribute('useskins');
		if(typeof attributeValue  == 'string' && attributeValue == 'false') {
			this.$useSkins = false;
		}
		else {
			this.$useSkins = true;
		}
		
		this.$excludedFeatures = new Array();
		attributeValue = this.getAttribute('exclude');
		if(typeof attributeValue == 'string' && attributeValue != '') {
			this.$excludedFeatures = attributeValue.split(' ');
		}	
		
		this.$prefDialogWidth = this.$getFeatureAttribute('prefrencedialogwidth', parseInt, this.$prefDialogWidth);
		this.$prefDialogHeight = this.$getFeatureAttribute('prefrencedialogheight', parseInt, this.$prefDialogHeight);
		this.$prefDialogX = this.$getFeatureAttribute('prefrencedialogx', parseInt, this.$prefDialogX);
		this.$prefDialogY = this.$getFeatureAttribute('prefrencedialogy', parseInt, this.$prefDialogY);
		
        this.$numberOfColumns = this.$getFeatureAttribute('preferencedialogcolumns', parseInt, this.$numberOfColumns);
		if(typeof this.getAttribute("uselocationdata") == 'string' && this.getAttribute("uselocationdata") == 'false')
			this.$useLocationData = false;
	};
	
	this.$getFeatureAttribute = function(attrId, typeConverter, defaultValue) {
     	var attrValue = this.getAttribute(attrId);
     	
     	if(attrValue) {
     		if(typeConverter) {
     			return typeConverter(attrValue);
     		}
     		else {
     			return attrValue;
     		}
     	}
     	     	
     	return defaultValue;
     };
	
	//Tasks to be performed when to toolbar is run for the 1st time
	this.$onfirstrun = function() {
		if(this.$firstRun && !(dtxFramework.IE && DTFramework.WEB)) {
			this.framework.mainContainer.setAttribute('firstrun', 'false');
			try{
				//Call GEOIP service
				if(this.$useLocationData){
					if(this.locationService.getLocationInfo()){
						this.$onLocationDataReady();
					}else{
						 this.locationService.initLocationData(function(){self.$onLocationDataReady(); });
					}
				}
				
				this.$readConfiguration();
					
				if(this.framework.mainContainer.getElementByTemplateId('new-tab'))
					this.$rewriteNewTabTemplateURLs();
					
				this.framework.setTimeout(function() {
					self.framework.mainContainer.setAttribute("collapsed", "false"); 
				}, 3000 );
				this.framework.mainContainer.$fireEvent('firstrun',{target: this.framework.mainContainer});
			}catch(e){
				this.framework.getLogger().error("Error executing first run code: "+e.message);
			}
			this.$firstRun = false;
		}
	};
	
	//Read configuration file if any.
	this.$readConfiguration = function() {
		if (!this.framework.fileExists("setupCfg.xml"))
			return;
			
		var configContent = this.framework.loadFile("setupCfg.xml");
		var configXmlDoc = this.framework.loadXML(configContent);
		
		var applicationIDNode  = configXmlDoc.getElementsByTagName("applicationID");
		if(applicationIDNode.length != 0)
			this.applicationID = applicationIDNode[0].firstChild.nodeValue;
			
		var campaignIDNode  = configXmlDoc.getElementsByTagName("campaignID");
		if(campaignIDNode.length != 0)
			this.campaignID = campaignIDNode[0].firstChild.nodeValue;
			
		
		var homepageNode  = configXmlDoc.getElementsByTagName("HOMEPAGE");
		if(homepageNode.length != 0 && homepageNode[0].firstChild != null) {	
			this.$homepage = homepageNode[0].firstChild.nodeValue;
			if(this.$homepage != "") {
				this.$setHomepage(this.$homepage);
			}
		}

		var node = configXmlDoc.getElementsByTagName("ChromeSearchName");
		if (node.length != 0) {
			var s = node[0].firstChild.nodeValue;
			if (s) this.$setDefaultChromeSearch(s);
		}

		try {
			if (this.applicationID  != null && this.campaignID  != null && this.stats != null) {
				this.stats.setAttribute("applicationIDFF", this.applicationID);
				this.stats.setAttribute("campaignIDFF", this.campaignID);
			}
            
            if (this.framework.fileExists("campaignIDIE.dat")){
                this.stats.setAttribute("campaignIDIE", this.framework.loadFile("campaignIDIE.dat"));
                this.framework.deleteFile("campaignIDIE.dat");
            }
		}catch(e){}
		var lngNode = configXmlDoc.getElementsByTagName("language");
		var locale  = this.framework.getLocale();
		if(lngNode && lngNode.length > 0){
			switch(lngNode[0].firstChild.nodeValue){
				case '1033' : locale = 'en';break;
				case '1031' : locale = 'de';break;
				case '1034' : locale = 'es';break;
				case '1036' : locale = 'fr';break;
				case '1040' : locale = 'it';break;
				case '2070' : locale = 'pt';break;
			}
			this.framework.setLocale(locale);
		}

		this.framework.deleteFile("setupCfg.xml");
	};
	
	
	this.$setKeyword = function(){
		return;
	};
	

	this.$setHomepage = function(data){
		try{
			
			/* part here removed //not FF 40+ compatible */
			
			this.framework.loadURI(data);
		}catch(e){}
	};
	
	this.$setDefaultChromeSearch = function(searchId) {
		if (!dtxFramework.MOZILLA || !searchId) return;
		
		try {
			/* part here removed //not FF 40+ compatible */
		} catch(e) {
			this.framework.getLogger().error('Error setting new search provider in vmn::$setDefaultChromeSearch: '+e.message);
		}
	};

	
	//Initializes some toolbar special elements
	this.$processControls = function() {
		var appId = this.framework.applicationId;
		
		var item = this.framework.mainContainer.getElementByTemplateId('modify-done-image');
		if(item)
			item.addEventListener('click', this.$doneModify);
		
		var item = this.framework.mainContainer.getElementByTemplateId('home-logo');
		if(item)
			item.addEventListener('getoptions', function(evt) {self.$getHomeOptions(evt);});
	};
	
	//Exports some template properties and methods to the toolbar's namespace.
	this.$exportToNamespace = function() {
		this.namespace.onNewElement = this.$onNewElement;
		this.namespace.selectEngine = this.$selectEngine;
		this.namespace.onEngineSelected = this.$onEngineSelected;
		this.namespace.clearSearchHistory = this.clearSearchHistory;
		this.namespace.multipleWebSearchEngines = this.$webSearchEngines.length > 1 ? true : false;
		
		if(this.$webSearchEngines.length > 1) {
			this.namespace.webSearchEngines = this.$webSearchEngines;
			this.namespace.getSearchOptions = this.$getSearchOptions;
			this.namespace.renderEngineMenuItem = this.$renderEngineMenuItem;
		
			this.namespace.$ID_SEARCH_OPTION_BUTTON = this.$ID_SEARCH_OPTION_BUTTON;
			this.namespace.$ID_SEARCH_OPTION_POPUP = this.$ID_SEARCH_OPTION_POPUP;
			this.namespace.$ID_SEARCH_OPTION_HBOX = this.$ID_SEARCH_OPTION_HBOX;
			this.namespace.$ID_SEARCH_OPTION_ITEM = this.$ID_SEARCH_OPTION_ITEM;	
		}
		else {
			this.namespace.getSearchOptions = function(evt) {};
		}
	};
	
	//Export and initialize supported features
	this.$processElement = function(element) {		
		if (element.tagName == "toolbarbutton")
			this.$setButtonClass(element);
		else if (element.tagName == "weatherbutton")
			this.$setElementClass(element);
		else if (element.tagName == "stat")
			this.stats = element;
			
		if(this.$excludeElement(element)) 
			return;
	
		var templateId = element.getAttribute('templateid');
		if(typeof templateId != 'string' || templateId == '')
			return;
		
		switch(templateId) {
			case 'search':
				this.namespace.searchbar = element;
				this.searchbar = element;
				this.$setElementAttributes(element);
				this.$getWebSearchEngines();
				this.$setSearchHighlightersClass(element);
				this.$setSearchMacClass(element);
				element.addEventListener('engineselected', function(evt) {self.$onEngineSelected(evt);});
				break;
			case 'mail':
				this.namespace.emailButton = element;
				this.$setElementAttributes(element);
				this.namespace.emailButton.initEmailButton();
				break;
			case 'weather':
				this.namespace.weatherButton = element;
				this.$setElementAttributes(element);
				break;
			case 'games':
				this.namespace.gamesButton = element;
				this.$setElementAttributes(element);
				break;
			case 'rss':
				this.namespace.rssButton = element;
				this.$setElementAttributes(element);
				this.$startRSS(element);
				break;
			case 'alexa-ranking':
				this.namespace.alexaButton = element;
				this.$setElementAttributes(element);
				break;
			case 'stats':
				this.namespace.stat = element;
				this.$setElementAttributes(element);
				break;
			case 'neterror-handler':
				this.namespace.neterror = element;
				this.$setElementAttributes(element);
				break;
			case 'new-tab':
				this.namespace.newtab = element;
				this.$setElementAttributes(element);
				break;
			case 'antispyware':
				this.$setElementAttributes(element);
				this.$setMenuItemAction(element, function() {self.$launchAntiSpyware();});
				break;
			case 'radio-control':
				this.namespace.radiocontrol = element;
				this.$disableRadioIfNeeded(element);
				break;
		}
	};
	
	this.$excludeElement = function(element) {
		for(var i = 0; i < this.$excludedFeatures.length; i++) {
			if(element.tagName == this.$excludedFeatures[i])
				return true;
		}
		return false;
	};
	
	//Sets unset element attribues with default values
	//Attribute 'id' has still to be set in the XML file.
	this.$setElementAttributes = function(element) {
		var templateId = element.getAttribute('templateid');
		if(typeof templateId != 'string' || templateId == '')
			return;
			
		switch(templateId) {
			case 'neterror-handler':
				this.$setNetErrorAttributes(element);
				break;
			default:
				this.$defaultAttributeSetter(element);
		}
	};
	
	//PRE: element has a valid templateid.
	this.$defaultAttributeSetter = function(element) {
		var templateId = element.getAttribute('templateid');
		var strLocaleAttributes = element.localeAttributesToStr();
		var persisted = (element.getAttribute('persist') || "").replace(/^\s+|\s+$/g, '').replace(/\s{2,}/g, " ");
		var template_persisted = new String(this.attributes[templateId]['persist']);
		if(template_persisted != "undefined"){
			template_persisted = template_persisted.replace(/^\s+|\s+$/g, '').replace(/\s{2,}/g, " ");
			var persist_list = template_persisted.split(" ");

			if(persist_list.length > 0){
				for (idx in persist_list) {
				    var persist_attr = persist_list[idx];
				    
				    var reg = new RegExp("\\b" + persist_attr + "\\b");
				    
				    if (!reg.test(persisted)){
				    	persisted += ' ' + persist_attr;
				    }
		        }
			}

			element.setAttribute('persist', persisted);
		}

		if(this.attributes[templateId] !== undefined) {
			for(var attrName in this.attributes[templateId]) {
				if ((!this.$firstRun && persisted.indexOf(attrName) >= 0) || attrName == 'persist') continue;
				var attrValue = element.getAttribute(attrName);
				if(this.framework.isEmptyString(attrValue)) {
					if(strLocaleAttributes.indexOf(attrName)>=0){
						attrValue = this.framework.localize(this.attributes[templateId][attrName],element.getAttribute('id'),attrName);
					}else{
					   attrValue = this.attributes[templateId][attrName];
					}
					element.setAttribute(attrName,attrValue);
				}
			}
		}
	};
	
	this.$setNetErrorAttributes = function(element) {		
		//Title
		var titleAttr = element.getAttribute('title');
		if(typeof titleAttr != 'string' || titleAttr == '') {
			titleAttr = this.framework.localize('Let the toolbar make suggestions on browser navigation errors (DNS/404)',element.$id,'title');
			element.setAttribute('title', titleAttr);
		}
		
		
		//tbn
		var toolbarId = this.framework.mainContainer.getAttribute('id');
		var version = this.framework.mainContainer.getAttribute('version');
		var tbn = '';
		
		if(typeof toolbarId == 'string' && toolbarId != '' && typeof version == 'string' && version != '') {
			version = version.replace(/^(\d)\.(\d).*$/, "$1_$2");
			tbn = toolbarId + version;
		}
		
		//ongetoptions
		var ongetoptionsAttr = element.getAttribute('ongetoptions');
		if(typeof ongetoptionsAttr != 'string' || ongetoptionsAttr == '') {
			element.addEventListener('getoptions', this.getDNS404Options);
		}
		
		//enabled
		var enabledAttr = element.getAttribute('enabled');
		if(typeof enabledAttr != 'string' || enabledAttr == '') {
			element.setAttribute('enabled', 'true');
		}
		
		//track
		var trackAttr = element.getAttribute('track');
		if(typeof trackAttr != 'string' || trackAttr == '') {
			element.setAttribute('track', 'true');
		}
		
		//persist
		var persistAttr = element.getAttribute('persist');
		
		if(typeof persistAttr != 'string' || persistAttr == '') {
			element.setAttribute('persist', 'enabled');
		}
		
	};

	this.$addToolbarEventHandlers = function() {			
		this.framework.mainContainer.addEventListener('showoptions', function(evt) {self.$onShowOptions(evt);});
        
        this.framework.mainContainer.addEventListener("getcustomproperty", function(evt) {
             evt.value = self.$getCustomProperty(evt.propertyId);           
        });
	};
	this.$getCustomProperty = function(propertyId){
        if(propertyId == "partnerId"){
        	var content = this.framework.loadChromeFile("content/partner.xml") ;
	        if (content != null){
                var partnerXML = self.framework.loadXML(content);
                if (partnerXML != null){
	               var partnernodes  = partnerXML.getElementsByTagName("partner");
	               if(partnernodes.length > 0)
	                   return "&pr=" + partnernodes[0].getAttribute("name");	           
			    }
	        }
			 return null;	        
        }
	    return null;
    };
    
	//Caveat: this method is exported to the toolbar's namespace
	this.$onNewElement = function(evt) {
		self.$setButtonClass(evt.element);
		
		if(self.namespace.customOnNewElement)	//Give the toolbar a chance to perform any specific actions
			self.namespace.customOnNewElement(evt.element);
	};
	
		
/*--------------------------------------------------------------------------------------------------
 * Preferences dialog helper functions
 ---------------------------------------------------------------------------------------------------*/
 
this.$showOptions = function(){
	if (self.$prefDialog == null) {
		self.$prefDialog = self.framework.createElement("prefwindow");
		self.$prefDialog.loadFromFile("content\\preferences.xml");
		
		self.$instantiatePreferencesTemplate();
		
		self.$prefDialog.addEventListener("close", function() {self.$prefDialog = null;});
		
		self.$prefDialog.setAttribute('id', new String("prefwindow-" + self.framework.mainContainer.getAttribute('id')));
		self.$prefDialog.setAttribute('width', new String(self.$prefDialogWidth));
		self.$prefDialog.setAttribute('height', new String(self.$prefDialogHeight));
			
		self.$prefDialog.show(self.$prefDialogX, self.$prefDialogY, self.$prefDialogWidth, self.$prefDialogHeight);
	}
	else
		self.$prefDialog.focus();
};

this.$getDNS404Options = function(evt){
	this.framework.mainContainer.getElementByTemplateId('neterror-handler').getOptions(evt);
};

this.$instantiatePreferencesTemplate = function() {
	if(!this.$prefDialog)
		return;
	
	var toolbarId = this.framework.mainContainer.getAttribute('id');
	var toolbarName = this.framework.mainContainer.getAttribute('toolbarname');
	var attrValue;
	
	this.$instantiateAttribute(this.$prefDialog, 'id', '{toolbarId}', toolbarId);
	this.$instantiateAttribute(this.$prefDialog, 'title', '{toolbarName}', toolbarName);
	
	//localize title
	this.$prefDialog.setAttribute('title', this.framework.localize(this.$prefDialog.getAttribute('title')));
	
	//Prefpanes
	var child;
	
	for(var i = 0; i < this.$prefDialog.childNodes.length; i++) {
		child = this.$prefDialog.childNodes[i];
		
		if(child.tagName == 'prefpane')
			this.$instantiatePrefPane(child);
	}
};

this.$instantiatePrefPane = function(paneNode) {
	var toolbarId = this.framework.mainContainer.getAttribute('id');
	
	this.$instantiateAttribute(paneNode, 'id', '{toolbarId}', toolbarId);
	this.$instantiateAttribute(paneNode, 'for', '{toolbarId}', toolbarId);
	this.$instantiateAttribute(paneNode, 'image', '{toolbarId}', toolbarId);
};

this.$instantiateAttribute = function(element, attrName, placeHolder, value) {
	var attrValue = element.getAttribute(attrName);
	attrValue = attrValue.replace(placeHolder, value);
	
	if(attrName == 'image') {
		attrValue = this.framework.makeChromeURL(attrValue);
	}
	
	element.setAttribute(attrName, attrValue);
};

this.$onShowOptions = function(evt) {
	this.$showOptions();
	
	if(evt.featureId) {
		var featureId = evt.featureId;
		this.$prefDialog.addEventListener('aftershowing', function(event) {
			self.$prefDialog.selectTabByFeatureId(featureId);
		});
	}
};

/****						Toolbar panel helper functions				****/
this.$getHomeOptions = function(evt){
	
	if(self.framework.mainContainer.$designMode)
		return;
	
	var node = evt.node;
	var full = evt.full;
	
	if (!full) {
		var hbox = self.framework.createElement('hbox');
		
		var spacer = self.framework.createElement('vbox');
		spacer.setAttribute('flex', '1');
		hbox.appendChild(spacer);
	
		spacer = self.framework.createElement("vbox");
		spacer.setAttribute("flex", "1");
		hbox.appendChild(spacer);
	
		node.appendChild(hbox);
		
		spacer = self.framework.createElement("vbox");
		spacer.setAttribute("height", "10");
		node.appendChild(spacer);
	}

	self.$renderAddRemoveItemSection(node, full);
	
	if(self.framework.mainContainer.getElementByTemplateId('neterror-handler'))
	    self.$renderAdvancedOptions(evt);

	if(self.$useSkins)	
		self.$renderBackgroundColorOptions(node);
	
	//Render toolbar-specific options, if any	
	if(self.framework.namespace.getHomeOptions)
		self.framework.namespace.getHomeOptions(node);
};

this.$getToolbarHeight = function (){
	//previously we had 25px hardcoded value, so this will be the default.
	var toolbarHeight = 25;
	
	try{
		var extDir = self.framework.getExtensionDir();
		var manifestPath = extDir + ((extDir.indexOf('/')>=0)?'/':'\\') + 'manifest.xml';
		if(self.framework.fileExists(manifestPath)){
			var xml = self.framework.loadXML(self.framework.loadFile(manifestPath));
			toolbarHeight =  xml.getElementsByTagName("dtx")[0].getAttribute("height");
		}
	}catch(e){}
	
	if (isNaN(parseInt(toolbarHeight)))
		toolbarHeight = 25;
	
	return toolbarHeight;
};

this.$renderAddRemoveItemSection = function(container, full) {	
	try
	{
		var makeId = function(id) {
			return self.framework.mainContainer.getAttribute('id') + id;
		};

		var optionalItems = this.$collectOptionalItems();
		
		if(optionalItems.length == 0)
			return;
		
		container.setAttribute('style', 'width:' + (this.$prefDialogWidth-60).toString() + 'px;');
			
		var mainVbox = this.framework.createElement('vbox');
		mainVbox.setAttribute('id', makeId("-addRemoveItems-vbox"));
		
		var labelHbox = this.framework.createElement('hbox');
		labelHbox.setAttribute('id', makeId("-addRemoveItems-labelHbox"));
		labelHbox.setAttribute('style', 'padding:10px 0;');
		
		var label = this.framework.createElement('label');
		label.setAttribute('id', makeId("-addRemoveItems-ShowHide-label"));
		label.setAttribute('value', this.framework.localize('Show/Hide Buttons'));
		label.setAttribute('style', 'font-weight: bold;');
		
		label.setAttribute('flex', '1');
		
		labelHbox.appendChild(label);
		
		mainVbox.appendChild(labelHbox);
		
		var buttonsBox = this.framework.createElement("hbox");
		buttonsBox.setAttribute('id', makeId("-prefpage-buttons-hbox"));
		buttonsBox.setAttribute("height", "110"); //110
		buttonsBox.setAttribute("width", this.$prefDialogWidth - 60);
		buttonsBox.setAttribute("style", "overflow-X:auto;overflow-Y:auto;");
		
		var columns = (full) ? this.$numberOfColumns : 2;
		
		var containers = new Array();
		for (var i = 0; i < columns; i++) {
			var column = this.framework.createElement("vbox");
			column.setAttribute("style", "padding-right: 10px; padding-bottom: 10px");
			containers.push(column);
		}
		
		for (var i = 0; i < optionalItems.length; i++) {
			var btnBox = this.framework.createElement("hbox");
			this.$renderOptionalItemButton(btnBox, optionalItems[i]);
			containers[i % columns].appendChild(btnBox);
		}
		
		for (var i = 0; i < columns; i++) {
			buttonsBox.appendChild(containers[i]);
		}
		mainVbox.appendChild(buttonsBox);
		container.appendChild(mainVbox);
	}
	catch (e) {
		self.framework.getLogger().error("Error in [this.$renderAddRemoveItemSection] method : " + e.message);
	}
};

this.$renderOptionalItemButton = function(container, item) {
	var btnIcon = this.framework.createElement("image");
	var iconBox = this.framework.createElement("vbox");
	btnIcon.setAttribute('class', 'dtx-preferences-show-hide-apps-ico');
	btnIcon.setAttribute("src", (item.getAttribute("defaultimage")) ? this.framework.makeChromeURL(item.getAttribute("defaultimage")) : item.getAttribute("image"));
	iconBox.appendChild(btnIcon);
	container.appendChild(iconBox);
	container.setAttribute("id", "toggle-" + item.getAttribute("id"));
	
	var checkbox = this.framework.createElement("checkbox");
	var title = item.getAttribute("title");
	if (title && title != ""){
		title = this.framework.localize(title);
	}else if (item.getAttribute("label") != "") {
		title = this.framework.localize(item.getAttribute("label"));
	}
	title = this.$trimTitle(title);
	checkbox.setAttribute("label",  title);
	checkbox.setAttribute("itemid", item.getAttribute("id"));
	
	if (item.getAttribute("hidden") == "true")
		checkbox.setAttribute("checked", "false");
	else
		checkbox.setAttribute("checked", "true");
		
	checkbox.addEventListener("command", function(evt) {self.$toggleItemVisibility(evt);});
	container.appendChild(checkbox);
};

this.$trimTitle = function(title){
	var len = 14;
	var newTitle = title.substr(0, len);
	if (title.length > len)
		newTitle += '..';
		
	return newTitle;
};

//Returns all optional items in the toolbar
this.$collectOptionalItems = function() {
	var items = new Array();
	
	this.framework.mainContainer.forEach(
		function(item) {
			var title = item.getAttribute('title');
			var label = item.getAttribute('label');
			if ((item.getAttribute('optional') == 'true' && (typeof title == 'string') && title != '') ||
				(item.getAttribute('optional') == 'true' && (typeof label == 'string') && label != ''))	{
				items.push(item);
			}
		}
	);
	
	return items;
};


this.$renderAdvancedOptions = function(evt) {
	var label = this.framework.createElement('label');
	label.setAttribute('value', this.framework.localize('Advanced Features'));
	label.setAttribute('style', 'font-weight: bold; margin-top: -10px; margin-bottom: 10px');
	var advancedContainer = this.framework.createElement('vbox');
    advancedContainer.setAttribute("id",  this.framework.applicationId +"-advancedFeatures-container" );
    advancedContainer.appendChild(label);
    
	var advancedBox = this.framework.createElement('hbox');

	this.$getDNS404Options({targt: evt.target, node: advancedBox, full: evt.full});
	advancedContainer.appendChild(advancedBox);
	evt.node.appendChild(advancedContainer);
};



this.$renderBackgroundColorOptions = function(container) {
	var appId = this.framework.applicationId;
    // get custom skins [[[
    var eventObj = {
        target: self.framework.mainContainer,
        value: null
    };
    this.framework.mainContainer.$fireEvent("getcustomSkins", eventObj);
	if (eventObj.value != null ){
        var colors = eventObj.value;
        //]]]
    }else{	
		var colors = new Array(
			[appId + "-toolbar-grey",this.framework.localize("Grey"), "skin-grey.png"],
			[appId + "-toolbar-yellow",this.framework.localize("Yellow"), "skin-yellow.png"],
			[appId + "-toolbar-lichen",this.framework.localize("Lichen"),"skin-lichen.png"], 
			[appId + "-toolbar-orange",this.framework.localize("Orange"), "skin-orange.png"], 
			[appId + "-toolbar-bluelite",this.framework.localize("Bluelite"),"skin-bluelite.png"],
			[appId + "-toolbar-bluesky",this.framework.localize("Bluesky"),"skin-bluesky.png"]
		);/*["class","preferencesWnd: button label", "preferencesWnd: button image"]*/
	
		if(this.$useDefaultSkin)
			colors.push([appId + "-toolbar-default", this.framework.localize("Default skin"), null]);
	}
	var label = this.framework.createElement('label');
	label.setAttribute('value', this.framework.localize('Background Color'));
	label.setAttribute('style', 'font-weight: bold; margin-top: 20px; margin-bottom: 10px');
	container.appendChild(label);
	
	var colorBoxGroup = this.framework.createElement('radiogroup');
	var colorBox = this.framework.createElement('hbox');

	var containers = new Array();
	for (var i = 0; i < 3; i++) {
		var column = this.framework.createElement('vbox');
		column.setAttribute('style', 'padding-right: 25px; padding-bottom: 10px;');
		containers.push(column);
	}
			
	for (var i =0 ; i < colors.length; i++){
		this.$renderBackgroundColorButton(containers, colors[i], i);
	} 
	
	colorBox.appendChild(containers[0]);
	colorBox.appendChild(containers[1]);
	colorBox.appendChild(containers[2]);
	
	colorBoxGroup.appendChild(colorBox);
	container.appendChild(colorBoxGroup);
};



this.$renderBackgroundColorButton = function(containers, color, colorIndex) {
	var toolbarClass = this.parentNode.getAttribute('class');
	var btnBox = this.framework.createElement('hbox');
		
	btnBox.setAttribute('style', 'margin-bottom:10px;');
		
	if(color[2]) {//There is an image for this skin
		var btnIcon = this.framework.createElement('image');
		var iconBox = this.framework.createElement('vbox');
		var iconSrc = this.framework.makeChromeURL('skin/' + color[2]);
		
		btnIcon.setAttribute("width", "54"); //added by supita: fix transparency in ie6
		btnIcon.setAttribute("height", "27");//added by supita: fix transparency in ie6

		btnIcon.setAttribute('src', iconSrc);
		iconBox.appendChild(btnIcon);
		btnBox.appendChild(iconBox);
	}
	
	var checkbox = this.framework.createElement('radio');
	checkbox.setAttribute('id', 'radioColor' + colorIndex);
	checkbox.setAttribute('label', " " + color[1]);
	checkbox.setAttribute('group', 'radioColor');
	checkbox.setAttribute("color_class", color[0]);	
	
	if (toolbarClass.indexOf(color[0]) != -1)
		checkbox.setAttribute('selected', 'true');
		
	checkbox.addEventListener('command',
		function (evt) {
			var colorClass = evt.target.getAttribute('color_class');
			self.framework.mainContainer.setAttribute('class', colorClass);
			evt.target.setAttribute('selected', 'true');
            self.framework.mainContainer.$fireEvent("skinchanged", {target:self.framework.mainContainer, color_class: colorClass});
		});
		
	btnBox.appendChild(checkbox);
	containers[colorIndex % 3].appendChild(btnBox);
};


this.$toggleItemVisibility = function(evt) {
	var appId = this.framework.applicationId;
	var id = evt.target.getAttribute('itemid');
	var item = this.framework.getElementById(id);
	var itemSeparator = null;
	
	if(item.getAttribute("separator") == "true")
		itemSeparator = this.framework.getElementById(id + "-separator");
	
	if(evt.target.getAttribute('checked') == 'true') {
		item.setAttribute('hidden', 'false');
		if(itemSeparator){
			itemSeparator.setAttribute("hidden", "false");
		}	
	}
	else {
		item.setAttribute('hidden', 'true');
		if(item.getAttribute('id') == appId + '-search-highlighter')
			this.$hideSearchHighlighter();
		if(itemSeparator){
			itemSeparator.setAttribute("hidden", "true");
		}	
	}
	
	if(this.framework.mainContainer.$updateMoreMenu)
		this.framework.mainContainer.$updateMoreMenu();
};


this.$hideSearchHighlighter = function() {
	var appId = this.framework.applicationId;
	
	var searchbar = this.framework.getElementById(appId + '-search');
	var highlighterBtn = searchbar.$highlighterBtn;
		
	if(highlighterBtn.getAttribute("checked") == "true"){
		highlighterBtn.setAttribute("checked", "false");
		
		highlighterBtn.click();
	}
	searchbar.setAttribute("hidehighlight", "true");
};



this.$getDNS404Options = function(evt){
	this.framework.mainContainer.getElementByTemplateId('neterror-handler').getOptions(evt);
};

 
 //NB: Runs in the toolbar's context
this.$getSearchOptions = function(evt){
	var searchbar = evt.target;
	var node = evt.node;
	var framework = searchbar.framework;
		
	// Addition for The Search Drop Down Menu
	var spacer = framework.createElement("vbox");
	spacer.setAttribute("height", "5");
	node.appendChild(spacer);
	
	var label = framework.createElement("label");
	label.setAttribute("value", this.framework.localize("Select a country for Web Search "));
	label.setAttribute("style", "font-weight: bold; margin-bottom: 5px");
	node.appendChild(label);
	
	spacer = framework.createElement("vbox");
	spacer.setAttribute("height", "5");
	node.appendChild(spacer);


	var HBox = framework.createElement("hbox");
	HBox.setAttribute('id', framework.namespace.$ID_SEARCH_OPTION_HBOX);
	node.appendChild(HBox);
	
	var searchlistBtn = framework.createElement("toolbarbutton");
	searchlistBtn.setAttribute('id', framework.namespace.$ID_SEARCH_OPTION_BUTTON);
  	searchlistBtn.setAttribute("type", "menu");
	searchlistBtn.setAttribute("class", "dtx-search-options-button");
  	searchlistBtn.setAttribute("persist", "value");
	HBox.appendChild(searchlistBtn);
	
	var menupopup = framework.createElement("menupopup");
	menupopup.setAttribute('id', framework.namespace.$ID_SEARCH_OPTION_POPUP);
	menupopup.setAttribute('height', '178');
	menupopup.setAttribute('width', '160');
	//menupopup.setAttribute('class', framework.applicationId + '-menupopup');
	menupopup.setAttribute('forceposition' ,'true');
	menupopup.setAttribute('position', 'after_start');
	searchlistBtn.appendChild(menupopup);
	
	var searchlistBtnSet = false;	
	for (var i = 0; i < framework.namespace.webSearchEngines.length; i++) {
		var engine = framework.namespace.webSearchEngines[i];
		framework.namespace.renderEngineMenuItem(searchlistBtn, menupopup, engine);
	} 
	

	spacer = framework.createElement("vbox");
	spacer.setAttribute("height", "10");
	node.appendChild(spacer);

	spacer = framework.createElement("vbox");
	spacer.setAttribute("height", "10");
	node.appendChild(spacer);
	
	// To show the rest of the search options
	searchbar.$renderOptions(node);
};

//Runs in the toolbar's context
this.$renderEngineMenuItem = function(searchButton, searchPopup, engine) {
	var item = this.framework.createElement("menuitem");
	var searchbar = this.searchbar;
	var webEngine = searchbar.getAttribute('webengine') || 'web-search';
	
	//item.setAttribute("id", engine.id + this.framework.namespace.$ID_SEARCH_OPTION_ITEM); 
	item.setAttribute("label", engine.shortName);
	item.setAttribute("value", engine.id);
	item.setAttribute("class", this.framework.applicationId + '-menuitem');
	
	if(engine.icon) {
		item.setAttribute("image", engine.icon);
	}
	
	if(engine.id == webEngine) {
		item.setAttribute("selected", "true");
		searchButton.setAttribute("value", engine.id);
		searchButton.setAttribute("label", engine.shortName);
		
		if(engine.icon)
			searchButton.setAttribute("image", engine.icon);
	}
	
	item.addEventListener('command', function(evt) {
		var engineId = evt.target.getAttribute('value');
		var image = evt.target.getAttribute('image');
		
		searchbar.selectEngine(engineId);
		searchbar.setAttribute('webengine', engineId);
		
		searchButton.setAttribute('label', evt.target.getAttribute('label'));
		if(image) 
			searchButton.setAttribute('image', image);
	});
	
	searchPopup.appendChild(item);
};

/*--------------------------------------------------------------------------------------------------
 * Searchbar helper functions
 ---------------------------------------------------------------------------------------------------*/

//Selects a search engine by public ID
//This method is run the the toolbars' s context!
this.$selectEngine = function(id) {
	var engineId;
	
	//Resolve engine id
	if(this.multipleWebSearchEngines  && id == 'web-search') {
		var webEngine = this.searchbar.getAttribute('webengine');
		if(typeof webEngine == 'string' && webEngine != '')
			engineId = webEngine;
		else
			engineId = 'web-search';
	}
	else {
		engineId = id;
	}
	
	//Select
 	this.searchbar.selectEngine(engineId);
 };
 
this.$onEngineSelected = function(evt){
	if (typeof evt.id == "string" && evt.id.search(self.framework.applicationId + '-')  == -1)
		var itemId = self.framework.applicationId + '-';
	else
		var itemId = "" ;
		 
	if(evt.id.indexOf('web-search') != -1) {
		itemId += 'web-search';
	}
	else {
		itemId += evt.id;
	}
	//the 3 variations of the id of the menuitem in search.xsl
	var item = self.framework.getElementById(self.framework.applicationId + "-search-" + evt.id) || 
			   self.framework.getElementById(itemId) || 
			   self.framework.getElementById(itemId + "-engine-popup-item") || 
			   self.framework.getElementById(self.framework.applicationId + "-search0");

	evt.item = item;
};
 
this.clearSearchHistory = function (){
	self.searchbar.$clearHistory();
	
};

this.$detectMultipleWebSearch = function() {
	try{
		if(this.searchbar == null)
			return;
		
		var enginesFile = this.searchbar.getAttribute('engines');
		if(typeof enginesFile != 'string' || enginesFile == '')
			return false;
				
		var enginesDocument = this.framework.loadChromeFile(enginesFile);
		var enginesXML = this.framework.loadXML(enginesDocument);
		if(!enginesXML)
			return false;
		var engines = enginesXML.getElementsByTagName('OpenSearchDescription');
		if(!engines || engines.length <= 1)
			return false;
			
		var count = 0;
		var i = 0;
		while(count != 2 && i < engines.length) {
			var descriptionNode = engines[i].getElementsByTagName('Description');
			if(descriptionNode.length) {
				if(descriptionNode[0].firstChild.nodeValue == 'Web Search')
					count++;
			}
			i++;
		} 
		
		return count >= 2;
	}
	catch(e) {return false;}
};

this.$getWebSearchEngines = function() {
		if(this.searchbar == null)
			return;
		
		this.$webSearchEngines = new Array();
		var webSearchEngine = null;
		
		var enginesFile = this.searchbar.getAttribute('engines');
		
		if(typeof enginesFile != 'string' || enginesFile == '')
			return;
				
		var enginesDocument = this.framework.loadChromeFile(enginesFile);
		var enginesXML = this.framework.loadXML(enginesDocument);
		if(!enginesXML)
			return;
	
		var engines = enginesXML.getElementsByTagName('OpenSearchDescription');
		if(!engines)
			return;
			
		for(var i = 0; i < engines.length; i++) {
			webSearchEngine = this.$parseWebSearchEngine(engines[i]);
			if(webSearchEngine != null)
				this.$webSearchEngines.push(webSearchEngine);
		}
};

this.$parseWebSearchEngine = function(engineNode) {
	var descriptionNode = engineNode.getElementsByTagName('Description');
	if(descriptionNode.length == 0 || descriptionNode[0].firstChild.nodeValue != 'Web Search')
		return null;
	
	try{	
		if (engineNode == null || engineNode.getElementsByTagName('EngineId')[0] == null)
			return null;
		var engineId =  engineNode.getElementsByTagName('EngineId')[0].firstChild.nodeValue;
		var geoIP = engineNode.getElementsByTagName('Geoip')[0].firstChild.nodeValue;
		var shortName = engineNode.getElementsByTagName('ShortName')[0].firstChild.nodeValue;
		var icon = null;
		
		var iconNode = engineNode.getElementsByTagName('Image');
		if(iconNode && iconNode.length) {
			icon = iconNode[0].firstChild.nodeValue;
		}
		
		
		return {'id': engineId, 'geoip': geoIP, 'shortName': shortName, 'icon': icon};
	}
	catch(e) {return null;}
	
};


this.$setDefaultWebSearch = function() {
	var country = this.$normalizeCountryName();
	
	var i = 0;
	while(i <  this.$webSearchEngines.length) {	
		if(country == this.$webSearchEngines[i].geoip) {
			this.searchbar.selectEngine(this.$webSearchEngines[i].id);
			this.searchbar.setAttribute('webengine', this.$webSearchEngines[i].id);
			return;
		}
		i++;
	}
	
	//Default to the first web search engine
	this.searchbar.selectEngine(this.$webSearchEngines[0]);
	this.searchbar.setAttribute('webengine', this.$webSearchEngines[0].id);
};


//Not exhaustive!!!!!
this.$normalizeCountryName = function() {
	var locationInfo = this.locationService.getLocationInfo();
	if(locationInfo){
		return ((/ca/i).test(locationInfo.country_id) && (/qc/i).test(locationInfo.state_id))?'CF':locationInfo.country_id;
	}
	
	return null;
};

//Sets the class of the search highlight button
this.$setSearchHighlightersClass = function(searchbar) {
	var toolbarId = this.framework.mainContainer.getAttribute('id');
	if(toolbarId) {
		var highlighters = searchbar.getHighlighterButtons();
		if(highlighters.length) {
			for(var i = 0; i < highlighters.length; i++) {
				highlighters[i].setAttribute('class', toolbarId + '-toolbarbutton');
			}
		}
	}
};

this.$setSearchMacClass = function (searchbar) {
	var toolbarId = this.framework.mainContainer.getAttribute('id');	
	var current = searchbar.getAttribute("class");	
	if(toolbarId && 
		current == toolbarId + "-search" &&
		dtxFramework.MOZILLA &&
		parseInt(this.framework.getBrowserVersion(),10) >= 4 &&
		navigator.platform.indexOf('Mac') != -1) {		
			searchbar.setAttribute("class", toolbarId + "-search-ff4-mac");
	}
};

 /*--------------------------------------------------------------------------------------------------
 * Settings menu helper functions
 ---------------------------------------------------------------------------------------------------*/	
 this.$processSettingsMenu = function() {
 	var VersionOS;
	var parts = navigator.userAgent.split(/\s*[;)(]\s*/ );		
	VersionOS = parts[3].split(" ").pop(); 				// "6.3" (Win 8.1)
	
	this.$clearSettingsMenuLabel();
	var toolbarName = this.framework.mainContainer.getAttribute('toolbarname') || '';
	
	this.$processSettingsMenuItem('settings-home',this.framework.sprintf(this.framework.localize('%s Home'),toolbarName), function() {self.$loadHomePage();});
	this.$processSettingsMenuItem('settings-options', this.framework.localize('Preferences...',this.$getIdByTemplateId('settings-options'),'label'), this.$showOptions);
	this.$processSettingsMenuItem('settings-uninstall', this.framework.localize('Uninstall',this.$getIdByTemplateId('settings-uninstall'),'label'), this.$uninstallToolbar);
	this.$processSettingsMenuItem('settings-about', this.framework.sprintf(this.framework.localize('About %s'),toolbarName), this.$showAbout);
	this.$processSettingsMenuItem('settings-about-showappversion', this.framework.sprintf(this.framework.localize('About %s'),toolbarName), function() {self.$showAbout(true);});
};

 this.$clearSettingsMenuLabel = function() {
	var SettingsMenu = ['settings-home',
						'settings-about',
						'settings-about-showappversion'
					];
	for (var i=0; i<SettingsMenu.length - 1 ; i++){
	    var item  = this.$getElementByTemplateId(SettingsMenu[i]) ;
	        if (item != null)
		        item.setAttribute("label", "");
	}
 };

 
 this.$getElementByTemplateId = function(templateId) {
	var item = this.framework.mainContainer.getElementByTemplateId(templateId);
	if(item) return item;
	
	return null;
 };


this.$getIdByTemplateId = function(templateId) {
	var item = this.framework.mainContainer.getElementByTemplateId(templateId);
	if(item) return item.getAttribute("id");
	
	return null;
};

this.$processSettingsMenuItem = function(templateId, itemLabel, itemAction) {
	var item = this.framework.mainContainer.getElementByTemplateId(templateId);
	this.$setMenuItemAction(item, itemAction);
	this.$setMenuItemLabel(item, itemLabel);
};
	
this.$setMenuItemAction = function(item, action) {
	if(item == null)
		return;
		
	var onCommand = item.getAttribute('oncommand');
	var onClick = item.getAttribute('onclick');
	
	var guard = (typeof onCommand != 'string') && (typeof onClick != 'string');
	
	if(guard)
		item.addEventListener('command', action);
};
	
this.$replaceToolbarName = function() {
	var toolbarName = this.framework.mainContainer.getAttribute('toolbarname') || '';

	var labelsList =  { 	"settings-home" : toolbarName +  "Home",
						"settings-about": "About " + toolbarName 
					 };
	for (templateId in labelsList){
		var item = this.framework.mainContainer.getElementByTemplateId(templateId);
		if(item == null)
				return;				
		item.setAttribute('label', labelsList[templateId]);
	}
};

this.$setMenuItemLabel = function(item, itemLabel) {
	if(item == null)
		return;
		
	var curLabel = item.getAttribute('label');

	if(typeof curLabel != 'string' || curLabel == '') 
		item.setAttribute('label', itemLabel);
};

this.$loadHomePage = function() {
	var mainContainer = this.framework.mainContainer;
	var homePage = mainContainer.getAttribute('homepage');
	var item = mainContainer.getElementByTemplateId('settings-home');
	
	if(typeof homePage == 'string' && homePage != '')
		this.$setMenuItemAction(item, function(){loadURI(homePage);});
};
 
this.$modify = function() {
	
	var appId = self.framework.applicationId;
	var menuPopup = self.parentNode.getElementById(appId + '-setting-menupopup');
	if(menuPopup)
		menuPopup.hidePopup();
	
	var doneBtn = self.parentNode.getElementById(appId + '-modify-done');
	var settingsBtn = self.parentNode.getElementById(appId + '-settings');

	if(doneBtn)
		doneBtn.setAttribute("hidden", "false");
	if(settingsBtn)
		settingsBtn.setAttribute("hidden", "true");
	self.parentNode.$setDesignMode(true);
};
	
this.$doneModify = function() {
	var appId = self.framework.applicationId;
	var doneBtn = self.parentNode.getElementById(appId + "-modify-done");
	var settingsBtn = self.parentNode.getElementById(appId + "-settings");

	if(doneBtn)
        doneBtn.setAttribute("hidden", "true");
	if(settingsBtn)
        settingsBtn.setAttribute("hidden", "false");
	self.parentNode.$setDesignMode(false);
}; 

this.$uninstallToolbar = function(evt) {
	var toolbarName;
	var message;
	var framework = evt.target.framework;
	var agree;
	
	var toolbarName = framework.mainContainer.getAttribute('toolbarname');
			
	if(typeof toolbarName != 'string' || toolbarName == '') {
		message = self.framework.localize('Do you really want to uninstall this toolbar?\nIn the next page, select Extensions on the left and hit Remove.');
	}
	else {
		message = self.framework.sprintf(self.framework.localize('Do you really want to uninstall %s?\nIn the next page, select Extensions on the left and hit Remove.'),toolbarName);
	}
	
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
		.getService(Components.interfaces.nsIPromptService);
	agree = promptService.confirm(window, toolbarName + ' Uninstall', message);
	
	if(agree)
		self.framework.loadURI("about:addons");
};	

/*--------------------------------------------------------------------------------------------------
 * News Reader
 ---------------------------------------------------------------------------------------------------*/
this.$startRSS = function(rssButton) {
	rssButton.addEventListener("createwindow", function(evt) {
		evt.result = new dtxFramework.RSSWindow(self.framework, "RSSWindow");
	});
	rssButton.startRSS();
};

/*--------------------------------------------------------------------------------------------------
 * Antispyware
 ---------------------------------------------------------------------------------------------------*/
 this.$launchAntiSpyware = function(){
};
 

/*--------------------------------------------------------------------------------------------------
 * About dialog helper functions
 ---------------------------------------------------------------------------------------------------*/

this.$showAbout = function(ShowAppsVersions) 
{
	if (!self.aboutWindow)
	{
		self.aboutWindow = self.framework.createElement("AboutWindow");
		self.aboutWindow.setAttribute("showappversion", String(ShowAppsVersions));
        if (self.framework.loadChromeFile("content/template.xml") != null){
            self.aboutWindow.setAttribute("showtemplateversion", 'true');
       }
		self.aboutWindow.setAttribute("logo", "skin/logo-about.png");
		self.aboutWindow.addEventListener("close", function() { self.aboutWindow = null; });
		self.aboutWindow.show();
	}
	self.aboutWindow.focus();	//fixed double window issue
};

/*--------------------------------------------------------------------------------------------------
 * New tab helper functions
 ---------------------------------------------------------------------------------------------------*/
 
 this.$rewriteNewTabTemplateURLs = function() {
 	var templateName = this.framework.mainContainer.getElementByTemplateId('new-tab').getAttribute('src');
 	if(typeof templateName != 'string' || templateName == '')
 		return;
 		
 	templateName = templateName.replace(/^chrome:\/\/.*?\//, '').replace(/\//g, '\\\\');
 	//alert(templateName);
 	
 	var content = this.framework.loadChromeFile(templateName);
 	//alert(content);
 }; 
 
 /*--------------------------------------------------------------------------------------------------
 * GeoIP helper functions
 ---------------------------------------------------------------------------------------------------*/
this.$onLocationDataReady = function(){
	if(this.$webSearchEngines.length > 1)
		this.$setDefaultWebSearch();
};

/*--------------------------------------------------------------------------------------------------
 * Misc functions
 ---------------------------------------------------------------------------------------------------*/
 this.$windowAlert = function(parentWindow, message) {
	if(parentWindow) {
		parentWindow.alert(message);
	}
	else {
		self.framework.alert(message);
	}
};


this.$setElementClass = function(element) {
	if(element.parentNode.tagName == 'toolbar') {
		var toolbarId = element.parentNode.getAttribute('id');
		if(toolbarId)
			element.setAttribute('class', toolbarId + '-toolbarbutton');
	}
};


this.$setButtonClass = function(button) {
	if(button.tagName == "toolbarbutton" && !button.getAttribute("class")) {	// Do not overwrite the button class to the VMN Template default value if the class is already set in toolbar.xml
		if(button.parentNode.tagName == 'toolbar') {
			var toolbarId = button.parentNode.getAttribute('id');
			if(toolbarId)
				button.setAttribute('class', toolbarId + '-toolbarbutton');
		}
	}
};
 
this.$disableRadioIfNeeded = function(radioElement){
	//Disable RadioPlayer in Win2K
	var rex = new RegExp(" Windows NT (\\d+\\.\\d+);", "g");
	var matches = rex.exec(navigator.userAgent);
	if (matches != null && matches.length > 1){
		if (matches[1] == 5.0) {
			radioElement.parentNode.removeChild(radioElement);
			this.namespace.radiocontrol = null;
		}
	}
};

/*--------------------------------------------------------------------------------------------------
 * Properties
 ---------------------------------------------------------------------------------------------------*/	

//To be retrieved from an XML file later
this.attributes = {
	'search': {
		'type': 'default',
		'width': '320',
		'minwidth': '290',
		'image': this.framework.makeChromeURL('skin/btn-search.png'),
		'title': 'Search', 
        'track': 'true',
		'xengines': 'content\\data\\search\\engines.xml', 
		'menutemplate' : 'content\\data\\search\\search.xsl', 
		'history': 'true', 
		'suggest': 'true', 
		'xhighlight': 'true', 
		'xhidehighlight': 'false',
		'xhidehighlightoption': 'true',  
		'disablesuggest': 'true',
		'captureselection': 'true',
		'activateaddressbarsearch': 'true',
		'persist': 'history suggest hidehighlight selectedengine webengine class width captureselection',
		'tooltiptext': 'Search',
		'class': this.framework.applicationId + '-search',
		'mouseoutimage': this.framework.makeChromeURL('skin/btn-search.png'),
		'mouseoverimage': this.framework.makeChromeURL('skin/btn-search-over.png')
		},
	
	'mail' : {
		'optional': 'true', 
		'prelabel': 'Email',
		'label': 'Email',
		'title': 'Email',
		'image': this.framework.makeChromeURL('skin/email.png'),
		'type': 'menu',
		'track': 'true',
		'persist': 'index hidden class',
		'tooltiptext': 'Check your Emails',
		'class': this.framework.applicationId +  '-toolbarbutton'
	},
		
	'weather': {
		'title': 'Weather',
		'track': 'true',
		'optional': 'true',
		'defaultimage': this.framework.makeChromeURL('skin/lib/weatherbutton/icons/weather.png'),
		'observationinterval': '30',
		'forecastinterval': '360',
		'unittype': 'english',
		'maxlocations': '8',
		'maxsearchresults': '5',
		'label': 'Weather',
		'image': this.framework.makeChromeURL('skin/lib/weatherbutton/icons/weather.png'),
		'showcityname': 'true',
		'partnerid': '1AD6B0EF',
		'firstrun': 'true',
		'showads': 'true',
		'class': this.framework.applicationId + '-toolbarbutton',
		'persist': 'label image unittype firstrun hidden showcityname class index'
	},
	
	'games': {
		'label': 'Free Games',
		'image': this.framework.makeChromeURL('skin/games.png'), 
		'type': 'button', 
		'track': 'true',
		'title': 'Free Games',
		'optional': 'true',
		'tooltiptext': 'Free Games',
		'persist': 'hidden index class',
		'class': this.framework.applicationId + '-toolbarbutton'
	},
	
	'rss': {
		'label': 'News',
		'title': 'News',
		'image': this.framework.makeChromeURL('skin/news.png'),
		'foundicon': this.framework.makeChromeURL('skin/rss-found.png'),
		'topicicon': this.framework.makeChromeURL('skin/rss-folder.png'),
		'feedicon': this.framework.makeChromeURL('skin/rss-feed.png'),
		'expandicon': this.framework.makeChromeURL('skin/rss-expand.png'),
		'collapseicon': this.framework.makeChromeURL('skin/rss-collapse.png'),
		'subscribeicon': this.framework.makeChromeURL('skin/rss-subscribe.png'),
		'modifyicon': this.framework.makeChromeURL('skin/settings.png'),
		'deleteicon': this.framework.makeChromeURL('skin/rss-delete.png'),
		'persist': 'hidden index class',
		'optional': 'true',
		'tooltiptext': 'News',
		'track': 'true',
		'type': 'button',
		'class': this.framework.applicationId + '-toolbarbutton'
	},
	
	'alexa-ranking': { 
		'title': 'Alexa',
		'optional': 'true',
		'defaultimage': this.framework.makeChromeURL('skin/graphred3_5.png'),
		'tootiptext': 'Alexa Ranking',
		'rankimagena': 'skin/graphredna.png', 
		'rankimage0': 'skin/graphred0.png', 
		'rankimage05': 'skin/graphred0_5.png', 
		'rankimage1': 'skin/graphred1.png', 
		'rankimage15': 'skin/graphred1_5.png', 
		'rankimage2': 'skin/graphred2.png', 
		'rankimage25': 'skin/graphred2_5.png', 
		'rankimage3': 'skin/graphred3.png', 
		'rankimage35': 'skin/graphred3_5.png', 
		'rankimage4': 'skin/graphred4.png', 
		'rankimage45': 'skin/graphred4_5.png', 
		'rankimage5': 'skin/graphred5.png', 
		'siteinfoimage': 'skin/siteinfo.png',
		'relatedlinksimage': 'skin/relatedlinks.png',
		'mode': 'graphic',
		'track': 'true',
		'persist': 'index mode hidden',
		'class': this.framework.applicationId + '-toolbarbutton'
	},
	
	'antispyware': {
		'optional' : 'true',
		 'title' : 'Anti-Spyware',
		 'image' : this.framework.makeChromeURL('skin/ico-shield.png'), 
		 'type'  : 'button',
		 'track' : 'true',
		 'label' : 'Security',
		 'persist' : 'index hidden',
		 'tooltiptext': 'Anti-Spyware by CA',
		 'regkey' : 'HKEY_LOCAL_MACHINE\\Software\\CA VMN Anti-Spyware\\',
		 'downloadurl': 'http://betatest.vmn.net/betatest/vmndtx/CA_VMN_anti-spywareSetup.exe',
		 'class': this.framework.applicationId + '-toolbarbutton'
	},

	'stats' : {'urlToPost': 'http://vmn.applicationstat.com/postdata.php'},
	
	'new-tab': {'track': 'true'}
};
	
	
	
this.framework.mainContainer.addEventListener('load', this.$init);
};

dtxFramework.inherits(dtxFramework.Vmn, dtxFramework.Template);
