//$MOZILLA_START$//

dtxFramework.Window = function(framework, id) {
    // inheritance
    dtxFramework.XULWrapper.apply(this, [framework, id]);

	var self = this;
    
    this.tagName = "window";
    //additional attributes to localize
    this.$localeAttributes = this.$localeAttributes.concat(["title"]);
    this.$window = null;
	this.$updateWhenChanged = false;
	this.$isTopElement = true;
	this.$baseWindow = "content/lib/dtxwin.xul";
	this.$panelWindow = "content/lib/dtxpanelwin.xul";
	this.$transparentWindow = "content/lib/dtxtransparentwin.xul";
	this.$transparentPanelWindow = "content/lib/dtxpaneltransparent.xul";
	// By default, Window does not call custom render methods when it has its "url" attribute specified.
	// Window descendants, such as Panels, need their own render while using the "url" attribute.
	// Those descendants will set $EnableRenderUrl to true.
	this.$EnableRenderUrl = false;
	
	this.$cachedWindow = null;
	this.$domWindow = null;
	this.$transparentColor = "#FF00FF";
	this.$hidden = false;
	this.$isPanel = true;
	this.$deferBlur = false;
    this.$enableAutoClose = false;
    this.$enableAutoHide  = false;
	
	//---------------------------
	try{
		var windowmediator = Components.classes['@vmn.net/DTX/windowmediator;1'].getService(Components.interfaces.nsISupports).wrappedJSObject;
		var comp_load = true;
	}catch(e){
		var comp_load = false;
	}

	var windowObserver = {
	   observe : function(aSubject, aTopic, aData) {
			try{if (typeof windowmediator == 'undefined' || !windowmediator) return;}catch(e){return;}
			if (windowmediator.opened   == true) return;
			if (windowmediator.modal    == false) return;
			
			var domWindow = aSubject.QueryInterface(Components.interfaces.nsIDOMWindow);
			var url = String(domWindow.location);

				var self = windowmediator.$window ;
				if (self){
					self.$window = aSubject;
					self.$window.addEventListener("load", function(){
						windowmediator.opened   = true;
						self.$document = self.$window.document;
						self.$domWindow = self.$window;
						self.$fireEvent("beforeshowing", {target: self});
						if (typeof self.getAttribute("title") == "string") {
							self.$window.document.title = self.getAttribute("title");
						}
						self.$update();
						self.$fireEvent("aftershowing", {target:self});
					}, false);
					self.$window.addEventListener("close", function(){
							windowmediator.opened   = false;
							windowmediator.modal    = false;
							self.$fireEvent("close", {target:self});
					}, false);
					self.$window.addEventListener("blur", function(evt){
						var autoclose = self.getAttribute("autoclose");
						if (autoclose == "true") {
							windowmediator.opened   = false;
							windowmediator.modal    = false;
							if (evt.target.nodeName == null){
								self.close(self);
							}
						}
					}, false);
				}
			}
	  };

	if (comp_load && windowmediator.register == false){
		Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher).registerNotification(windowObserver);
		windowmediator.register = true;
	}

	top.window.addEventListener("close",function(evt){
		var windowsList = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var browserWindow =windowsList.getMostRecentWindow("navigator:browser");
		var enumerator = windowsList.getEnumerator(null);
		while(enumerator.hasMoreElements()) {
		  var win = enumerator.getNext().QueryInterface(Components.interfaces.nsIDOMWindow);
		  if (String(win.location.href).indexOf("dtxwin.xul") != -1 || String(win.location.href).indexOf("dtxpanelwin.xul") != -1){
			  if(win.opener == browserWindow){ 
					win.close(this);
			  }
			  windowmediator.$window = null;
		  }
		}		
	}, false);
	//---------------------------
	

	this.addEventListener('documentready',function(evt){
		self.$localizeDocument(evt.doc);
	});
		
	this.$deferRender = function() {
		return true;
	};
	
	this.prompt = function(caption, value) {
		return this.$window.prompt(caption, value);
	};
	
	this.alert = function(caption) {
		return this.$window.alert(caption);
	};

	
	this.setTransparent = function() {	
	};
	

	this.setTransparentColor = function(color){
		this.$transparentColor = color;
	};



	this.$openWindow = function(url, x, y, width, height) {
		if (this.getAttribute("nochrome") == "true")
			var features = "";
		else
			var features = "chrome,";
		
		if (this.getAttribute("center") == "true")
			features += "centerscreen,";
		else 
			features += "top="+y+",left="+x+",";
		features += "outerWidth="+width+",outerHeight="+height+",";
		if (this.getAttribute("resize") == "true")
			features += "resizable,";
		if (this.getAttribute("dialog") == "true")
			features += "dialog,";
		if (this.getAttribute("noframe") == "true")
			features += "titlebar=false,";
		if (this.getAttribute("autoclose") == "true")
		    this.$enableAutoClose = true;
		if (this.getAttribute("autohide") == "true")
		    this.$enableAutoHide = true;
		if (this.getAttribute("ontop") == "true" || 
			this.getAttribute("topmost") == "true" || 
			this.getAttribute("autoclose") == "true" ||
			this.getAttribute("autohide") == "true"){
			features += "alwaysRaised,";
			features += 'dependent=yes';		
		}else if (this.getAttribute("dependent") == "true"){
			features += 'dependent=yes';
		}

		if (this.getAttribute("modal") == "true"){
			features += "modal=yes";
			windowmediator.modal    = true;
			if (comp_load)
				windowmediator.$window  = self;
		}
		var id = "window" + Math.floor(Math.random() * 100);
		
		if (this.$cachedWindow == null || this.$window == null){
			this.$cachedWindow =  window.open(url, id , features);
		}else{
			try{
				this.$window = this.$cachedWindow;
				if (this.getAttribute("center") != "true")
					this.$window.moveTo(x, y);
				this.sizeTo(width, height) ;
				this.$window.focus();
			}catch(e){
				this.$cachedWindow =  window.open(url, id , features);
				this.$window = null ;
//			alert(e.message + e.lineNumber);
			}
		}		
		return this.$cachedWindow;
	};
	
	
	
	this.sizeTo = function(width, height) {
		if (this.$window != null){	
			if (!this.$hidden){
				if(this.$window.outerHeight != 1)
					this.$window.outerHeight = height;
				if(this.$window.outerWidth != 1)
					this.$window.outerWidth  = width;
			}
		}
	};
	
	this.$localizeDocument = function (doc){
		/*****************************/
		/* i18n $START$ */
		/*****************************/
		if (self.$localized)
		    return;
		/***************************/
		/* i18n $END$ */
		/***************************/
	};
	
	
	this.$windowHideListener = function(){
	    self.$enableAutoHide=false;
		self.hide();
	};
	
	
	this.$windowCloseListener = function(){
	    self.$enableAutoClose=true;
		self.close(this);
	};


	this.show = function(x, y, width, height) {
		var url 			= this.getAttribute("url");
		var autoclose 		= this.getAttribute("autoclose");
		var autohide		= this.getAttribute("autohide");
		var isDependantWin 	= this.getAttribute('dependent');
		var isTransparent 	= this.getAttribute('transparent');
		this.$hidden = false;

        var oldFFVersion = false;
        var FFVersion = this.framework.getBrowserVersion().replace(/\./g ,"");
        var FFMajor  = parseInt(FFVersion.split(".")[0]);
        var FFMinor = parseInt(FFVersion.split(".")[1]);
        if(FFMajor <= 3 && FFMinor <= 1){
            oldFFVersion = true;
	    }
		
		if (!this.$EnableRenderUrl && typeof url == "string" && url != "") {
		//case1
			self.$fireEvent("showing", {target:self});
            
	        
            if (isTransparent == "true" && oldFFVersion == false) {
			    var fileUrl = url;
 			    url = this.framework.makeChromeURL(this.$transparentWindow) ;
	        }

			this.$window = this.$openWindow(url, x, y, width, height);
			
            if (isTransparent == "true" && oldFFVersion == true) {
			    //this.setTransparentColor("#FF00FF");
                this.setTransparent();
            }
			
			this.$window.addEventListener("load", function(){
				if (isTransparent == "true" && oldFFVersion == false) {
					var iframe = self.$window.document.getElementById("container");
					iframe.setAttribute("src", fileUrl);
					iframe.setAttribute("style", "width: " + width + "; height:" + height + "px");
					iframe.setAttribute("frameborder", "0");
					iframe.setAttribute("scrolling", "no");
					iframe.addEventListener("DOMContentLoaded", function(aEvent){
						var doc = aEvent.originalTarget;
						var url = doc.location.href;
						if (url != 'about:blank') {
							self.$fireEvent('documentready', {target: self, window: iframe.contentWindow, doc: iframe.contentDocument});
						}
					}, true); 
				}else{
					self.$fireEvent('documentready', {target: self, window: self.$window, doc: self.$window.document});
				} 
				self.$window.addEventListener("unload", function(evt){
						self.$fireEvent("close", {target:self});
				}, false);
			},false);

			self.$fireEvent("aftershowing", {target:self});
			if (typeof this.getAttribute("title") == "string")
				this.$window.document.title = this.getAttribute("title");
        }
		else {
		//case2				
			if (typeof x == "undefined")
				x = this.getAttribute("left");
			if (typeof y == "undefined")
				y = this.getAttribute("top");

			if (typeof width == "undefined")
				width = this.getAttribute("width");
			if (typeof height == "undefined")
				height = this.getAttribute("height");

			this.setAttribute("left", x);
			this.setAttribute("top", y);
			this.setAttribute("width", width);
			this.setAttribute("height", height);

            if (self.getAttribute("transparent") == "true"  && oldFFVersion == false)
				this.$window = this.$openWindow(this.framework.makeChromeURL(this.$transparentPanelWindow), x, y, width, height);
			else if (this.getAttribute("noframe") == "true")
				this.$window = this.$openWindow(this.framework.makeChromeURL(this.$panelWindow), x, y, width, height);
			else
				this.$window = this.$openWindow(this.framework.makeChromeURL(this.$baseWindow), x, y, width, height);
			
			if (!comp_load || !windowmediator.modal || windowmediator.modal == false){
				if (this.getAttribute("transparent") == "true" && oldFFVersion == true){
                    //this.setTransparentColor("#FF00FF");
					this.setTransparent();
				}
				
				this.$window.addEventListener("load", function(){

					self.$document = self.$window.document;
					self.$domWindow = self.$window;
					self.$fireEvent("beforeshowing", {target: self});
					if (typeof self.getAttribute("title") == "string") {
						self.$window.document.title = self.getAttribute("title");
					}
					self.$update();
					self.$fireEvent("aftershowing", {target:self});
					
					self.$window.addEventListener("unload", function(evt){
							self.$fireEvent("close", {target:self});
					}, false);
				}, false);

				this.$window.addEventListener("mouseover", function(evt){
					if ((evt.target.nodeName != 'window') && (self.tagName != 'panel'))
					self.$isPanel = false;
				}, false);
			}
		}
		

		if (autoclose == "true" && self.$deferBlur == false) {
			this.$window.addEventListener("mousedown", function(evt){
			    self.$enableAutoClose=false;
			}, false);
			
			window.addEventListener("mousedown", this.$windowCloseListener , false);
			
			this.$window.addEventListener("blur", function(evt){
			    if (self.$enableAutoClose == true){
					if (self.$window != null)
						self.close(self);
				}

			}, false);
		}
		
		if (autohide == "true") {
			//non-dependant window (which are loaded separately) must be explicitely unloaded
		    this.$window.addEventListener("mousedown", function(evt){
			    self.$enableAutoHide=true;
		   }, false);
			
		    window.addEventListener("mousedown", this.$windowHideListener , false);
			
		    
		    this.$window.addEventListener("blur", function(evt){
		        if (self.$enableAutoHide == false){
			        if (self.$window != null)
					    self.hide();
			    }
		    }, false);
		}
	};
	
	this.showRelative = function(element, dx, dy) {
		var width = parseInt(this.getAttribute('width'));
		var height = parseInt(this.getAttribute('height'));
		
		var position;
		if(element.parentNode.tagName == 'toolbar') {
			position = this.$positionToButton(element, dx, dy);
		}
		else  { // Chevron case
			position = this.$positionToChevron();
		}
		this.show(position.x, position.y, width, height);
	};
	
	this.$positionToButton = function(button, dx, dy) {
	    //Addition for appstart FEA#98501437
		if (button.$domNode.tagName == "DIV"){
		    var buttonLeft = button.$domNode.offsetLeft;
		    var buttonTop = button.$domNode.offsetTop;
		    var buttonWidth = button.$domNode.width;
		    var buttonHeight = button.$domNode.height;
	     }else{
		    var buttonLeft = button.$domNode.boxObject.screenX;
		    var buttonTop = button.$domNode.boxObject.screenY;
		    var buttonWidth = button.$domNode.boxObject.width;
		    var buttonHeight = button.$domNode.boxObject.height;
		}
		dx -= 1;
		dy -= 5;
		return this.positionToButtonCommon({left: buttonLeft, top: buttonTop, width: buttonWidth, height: buttonHeight}, dx, dy, 22);
	};
	
	this.$positionToChevron = function(chevron, dx, dy) {
		var chevron = this.framework.mainContainer.childNodes[this.framework.mainContainer.childNodes.length - 1];
		var chevronLeft = chevron.$domNode.boxObject.screenX;
		var chevronTop = chevron.$domNode.boxObject.screenY;
		var chevronWidth = chevron.$domNode.boxObject.width;
		var chevronHeight = chevron.$domNode.boxObject.height;
		var chevronMenuWidth = chevron.childNodes[0].$domNode.boxObject.width;
		var chevronMenuHeight = chevron.childNodes[0].$domNode.boxObject.height;
		var chevronMenuTop = chevron.childNodes[0].$domNode.boxObject.screenY;	
		var chevronMenuLeft = chevron.childNodes[0].$domNode.boxObject.screenX;	
	
		return this.positionToChevronCommon({left: chevronLeft, top: chevronTop, width: chevronWidth, height: chevronHeight}, 
		{left: chevronMenuLeft, top: chevronMenuTop, width: chevronMenuWidth, height: chevronMenuHeight}, 2, 0, 20);
	};
	
	this.positionToButtonCommon = function(buttonBox, dx, dy, yAdjust) {
		var x, y;
		var width = parseInt(this.getAttribute('width'));		
		var height = parseInt(this.getAttribute('height'));
				
		var screenWidth = window.screen.availWidth;
		var screenHeight = window.screen.availHeight;
			
		if(buttonBox.left + dx + width <= screenWidth) {
			x = buttonBox.left + dx;
		}
		else {
			x = buttonBox.left - width - dx + buttonBox.width;
		}
				
		if(buttonBox.top + dy + height + 5<= screenHeight) {
			y = buttonBox.top + dy + 5;
		}
		else if (buttonBox.top + buttonBox.height - height - dy >= 0){
			y = buttonBox.top /*+ buttonBox.height*/ - height - dy + yAdjust;
		} else {
			var d1  = buttonBox.top + dy + height - screenHeight;
			var d2 = height - (buttonBox.top /*+ buttonBox.height*/ - dy);
				
			if(d1 < d2) {
	    		y = buttonBox.top + dy;
			} else {
	    		y = buttonBox.top /*+ buttonBox.height*/ - height - dy + yAdjust;
			}			
		}
		return {x: x, y: y};	
	};
	
	this.positionToChevronCommon = function(chevronBox, chevronMenu, xAdjust, yAdjust_1, yAdjust_2) 
	{
		var x, y;
		var width = parseInt(this.getAttribute('width'));
		var height = parseInt(this.getAttribute('height'));
					
		var screenWidth = window.screen.availWidth;
	    var screenHeight = window.screen.availHeight;
				
		x = chevronBox.left - width + xAdjust;
				
		if(chevronBox.left + chevronMenu.width > screenWidth) {
			x = x - chevronMenu.width + chevronBox.width;
		}
				
		if(x < 0) {
			x = chevronBox.left + chevronMenu.width;
		}
				
		if(chevronBox.top + chevronBox.height - yAdjust_1  + height < screenHeight) {
			y = chevronBox.top + chevronBox.height - yAdjust_1;
		}
		else if(chevronBox.top + chevronBox.height - height + yAdjust_2 >= 0) {
			y = chevronBox.top + chevronBox.height - height + yAdjust_2;
		}
		else {
			var d1 = chevronBox.top + chevronBox.height + height - yAdjust_2 - screenHeight;
	    	var d2 = height - chevronBox.top;
	    			
	    	if (d1 <= d2) {
	    			y = chevronBox.top + chevronBox.height - yAdjust_1;
	    	} else {
	    			y = chevronBox.top + chevronBox.height - height + yAdjust_2;
	    	}	
		}
		
		//return {x: x, y: y};
		return {x: isNaN(x)?0:x, y: isNaN(y)?0:y};	// BUG: Sometimes X equals to NaN
	};
	
	
	this.focus = function() {
		if (this.$window != null)
			this.$window.focus();
	};
    
	this.close = function(evt){
		try{		    
		//    alert("this.$enableAutoClose=" + this.$enableAutoClose);
			if (evt != null && this.$enableAutoClose == false)
			    return;
			    
			if (this.$window != null){
				var title = this.$window.document.title ;
				var name = this.$window.name;
				var id = this.$cachedWindow.name;
				this.$window.close();
				this.$window = null;
				this.$cachedWindow	= null ;

				var windowsList = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
				var browserWindow = windowsList.getMostRecentWindow("navigator:browser");
				var enumerator = windowsList.getEnumerator(null);
				while(enumerator.hasMoreElements()) {
					var win = enumerator.getNext().QueryInterface(Components.interfaces.nsIDOMWindow);
					if (win.name == id){
					    win.close();
					}
					
					if(win.opener == browserWindow && (String(win.location.href).indexOf("browser") == -1) && (String(win.document.title).indexOf("Radio") == -1) && (win.name != name) && (win.name !="")){
						win.focus();
						//break;  *** Hack for Bug#14146 :: Need to keep an eye as it might break somewhere else...
					}else{
						//win.blur();	// TO BE WATCHED: When enabled, then closing a panel while having two FF browsers opened makes these two FF windows flicker.
					}
				}
				window.removeEventListener("mousedown", this.$windowCloseListener , false);
				window.removeEventListener("mousedown", this.$windowHideListener , false);

			}
		}catch(e){
			//alert(e.message + e.lineNumber);
		}
	};

	this.hide = function() {
		try{
			if (this.$window != null){
				if (this["$attributes"].title == null){
					this.$window.outerHeight = 0;
					this.$window.outerWidth  = 0;
					this.$hidden = true;
				}else{
					this.close(self);
				}
			}
		}catch(e){
			this.$window = null;
			this.$cachedWindow = null;
		}		
	};
};

dtxFramework.inherits(dtxFramework.Window, dtxFramework.XULWrapper);

dtxFramework.Window.prototype.$createDOMNode = function() {
	var vbox = this.$window.document.getElementById("container");
	return vbox;
};

dtxFramework.Window.prototype.setAttribute = function(attrid, value) {
	dtxFramework.DTXElement.prototype.setAttribute.apply(this, [attrid, value]);
	if (attrid == "autoclose"){
	    if(value == "false"){
	        this.$enableAutoClose = false;
	    }else{
	        this.$enableAutoClose = true;
	    }
	}
};