
dtxFramework.XULWrapper = function(framework, id) {

    // inheritance
    dtxFramework.DTXElement.apply(this, [framework, id]);
    
    this.tagName = null;
    
    var self = this;
    
	this.$onCommand = function(evt) {
		if (!this.$designMode)
			self.$fireEvent("command", {target:self});
		evt.stopPropagation();
		if (self.getAttribute("disableautoclose") != "true") {
			var parentPopup = null;
			for (var element = self.$domNode; parentPopup == null && element != null; element = element.parentNode) {
				if (element.tagName == "menupopup")
					parentPopup = element;
			}
			if (parentPopup != null && parentPopup.getAttribute("dtx-closeoncommand") == "true") {
				parentPopup.hidePopup();
			}
		}
	};
	
	this.$onClick = function(evt) {
		if (!this.$designMode) {
			var eventObj = {target: self, cancelBubble: false};
			self.$fireEvent("click", eventObj);
			if (eventObj.cancelBubble)
				evt.cancelBubble = true;
		}
	};
	
	this.$onBlur = function(evt) {
		if (!this.$designMode)
			self.$fireEvent("blur", {target:self});
	};
	
	this.$onKeyDown = function(evt) {
		if (!this.$designMode) {
			var eventObj = {target: self, keyCode: evt.keyCode};
			self.$fireEvent("keydown", eventObj);
		}
	};
	
	this.$onMouseOver = function(evt) {
		var eventObj = {target: self};
		self.$fireEvent("mouseover", eventObj);
	};
	
	this.$onMouseOut = function(evt) {
		var eventObj = {target: self};
		self.$fireEvent("mouseout", eventObj);
	};
	
    this.$render = function() {
		if (this.$domContent != null) {
			this.$domNode.appendChild(this.$domContent);
		}
		for (var i = 0; i < this.childNodes.length; i++) {
			var child = this.childNodes[i];
			var domNode = child.$createDOMNode();
			
			if(child.tagName == "menuseparator"){
				var child_prev = this.childNodes[i-1];
				child_prev.setAttribute('class', this.framework.applicationId + '-menuitem-noseparator');
			}
			if (domNode != null) {
				domNode.setAttribute("id", child.$id);
				if (domNode.parentNode == null)
					this.$domNode.appendChild(domNode);
			}
		}
    };
    
	this.$onCancelEvent = function(evt) {
		evt.stopPropagation();
	};
	
};

dtxFramework.inherits(dtxFramework.XULWrapper, dtxFramework.DTXElement);

dtxFramework.XULWrapper.prototype.$createDOMNode = function() {
    if (this.tagName.toLowerCase() == "script" && 
        this.getAttribute("src") !=  null && 
        (this.getAttribute("src").indexOf("http") == 0 || 
         this.getAttribute("src").indexOf("https") == 0 ||
         this.getAttribute("src").indexOf("://")== 0)
        )
        return null;
	return document.createElement(this.tagName);
};

dtxFramework.XULWrapper.prototype.setAttribute = function(attrid, value) {
	if (attrid == "image")
		value = this.$framework.makeChromeURL(value);
	dtxFramework.DTXElement.prototype.setAttribute.apply(this, [attrid, value]);
};

dtxFramework.XULWrapper.prototype.$hookEvents = function() {
	dtxFramework.DTXElement.prototype.$hookEvents.apply(this);
	
	this.$domNode.removeEventListener("command", this.$onCommand, false);
	this.$domNode.addEventListener("command", this.$onCommand, false);
	
	this.$domNode.removeEventListener("click", this.$onClick, false);
	this.$domNode.addEventListener("click", this.$onClick, false);
	
	this.$domNode.removeEventListener("blur", this.$onBlur, false);
	this.$domNode.addEventListener("blur", this.$onBlur, false);
	
	this.$domNode.removeEventListener("keydown", this.$onKeyDown, false);
	this.$domNode.addEventListener("keydown", this.$onKeyDown, false);
	
	this.$domNode.removeEventListener("mouseover", this.$onMouseOver, false);
	this.$domNode.addEventListener("mouseover", this.$onMouseOver, false);
	
	this.$domNode.removeEventListener("mouseout", this.$onMouseOut, false);
	this.$domNode.addEventListener("mouseout", this.$onMouseOut, false);
	
};


