if (typeof xfin_portal == "object") {

	/******** Declarations ********/
	
	xfin_portal.wasLogged = false;
	xfin_portal.myportalCookieName = "MYPORTAL";
	xfin_portal.bunchballCookieName = "bunchball";
	xfin_portal.rememberCookieName = "remember@comcast.net";
	
	/******** End of Declarations ********/
	
	
	/******** Methods ********/
	
	// Is the user logged in
	xfin_portal.isLogged = function(){ 
		var myportalCookie = xfin_portal.framework.hasDomainCookie(xfin_portal.comcastURL, xfin_portal.myportalCookieName);
		var rememberCookie = xfin_portal.framework.hasDomainCookie(xfin_portal.comcastLogin , xfin_portal.rememberCookieName);
		
		return (myportalCookie != null || rememberCookie != null)
	};
	
	// Verifies if the user is logged in
	xfin_portal.checkForLogin = function(){
		var imageSrc = "";
		var loginTxt = "";
		
		var isLogged = xfin_portal.isLogged();

		if (xfin_portal.wasLogged != isLogged) {
			xfin_portal.wasLogged = isLogged;
			if (isLogged) {
				xfin_portal.checkForMail();
				imageSrc = "chrome://"+xfin_portal.framework.applicationId+"/skin/sign_off.gif";
				loginTxt = "Sign Out";
			}
			else {
				xfin_portal.updateUnreadCount(0);
				xfin_portal.framework.saveFile(xfin_portal.mailcheckDateFile, "0");
				imageSrc = "chrome://"+xfin_portal.framework.applicationId+"/skin/sign_in.gif";
				loginTxt = "Sign In";
			}
			
			//Update login button image and label, if it exists.
			var signInBtn = xfin_portal.toolbar.getElementById(xfin_portal.framework.applicationId+"-signin");
			if(signInBtn)
			{
				signInBtn.setAttribute("image", imageSrc);
				signInBtn.setAttribute("tooltiptext", loginTxt);
			}
			
			//Update home button Sign-In submenu image and label, if it exists.
			var homeSignInMenu = xfin_portal.toolbar.getElementById(xfin_portal.framework.applicationId+"-home-signin");
			if(homeSignInMenu)
				homeSignInMenu.setAttribute("label",loginTxt);
			var settingsSignInMenu = xfin_portal.toolbar.getElementById(xfin_portal.framework.applicationId+"-settings-signin");
			if(settingsSignInMenu)
				settingsSignInMenu.setAttribute("label",loginTxt);
		}
		if(xfin_portal.toolbar.getElementById(xfin_portal.framework.applicationId+"-myprofile")){
			xfin_portal.updateGameProfile();
			$myGameCache.get(xfin_portal.getMyGameURL()+'&nocache='+new Date().getTime());
		}
	};
	
	//Login timestamp
	xfin_portal.getEncodedTimestamp = function(){
		var buf = '';
		var TRANSPOSE_INDEX = new Array(6, 0, 2, 1, 4, 3, 7, 5);
		var currentTime = new Date();
		var now = new Number(currentTime.getTime() / 1000);
		var result = Math.floor(now);
		var hexVal = parseInt(result).toString(16);
		if (hexVal.length < TRANSPOSE_INDEX.length) {
			return buf;
		}
		for (i = 0; i < TRANSPOSE_INDEX.length; i++) {
			buf += hexVal.charAt(TRANSPOSE_INDEX[i]);
		}
		return buf;
	};
	
	xfin_portal.login = function() {
		var logged = xfin_portal.isLogged();
		if (logged) {
			loadURI("https://login.comcast.net/logout?cid=toolbar_button&amp;attr=comcast_signout");
		}
		else {
			//loadURI("https://login.comcast.net/login?cid=toolbar_button&amp;attr=comcast_signin");
			loadURI("https://login.comcast.net/login?s=portal&continue=http%3A%2F%2Fxfinity.comcast.net&ts=" + xfin_portal.getEncodedTimestamp());
		}
	}; 

	/******** End of methods ********/
}