var EXPORTED_SYMBOLS = [ "Welcome" ];

var Welcome = function (namespace) {
	this.framework = namespace.framework;
	this.namespace = namespace;
	this.options = {	eula: true,
						search: true,
						homepage: true,
						customcontent: false,
						update: false,
						partner: "",
						searchId: "Xfinity.com Search" };
						
	this.elementHeights = { eula: 160,
							search: 20,
							homepage: 20
							};
	var self = this;

	this.display = function () {
		try{
			var welcomeDialog = this.framework.createElement("window");
			welcomeDialog.loadFromFile("content\\welcome.xml");
			welcomeDialog.setAttribute('width', '625'); 
			welcomeDialog.setAttribute('noframe', 'true');
			welcomeDialog.setAttribute('dialog', 'false');
			welcomeDialog.setAttribute('autohide', 'false');
			welcomeDialog.setAttribute('dependent', 'true');
			welcomeDialog.setAttribute('doresize', 'false');
			welcomeDialog.setAttribute('keycolor', '#EFFBFB');
			welcomeDialog.setAttribute('transparent', 'true');
			var dialogHeight = 422;

			if(this.options.customcontent) {
				welcomeDialog.getElementById("customcontent").setAttribute("hidden", "false");
				welcomeDialog.getElementById("customcontent").appendChild(this.options.customcontent);
			}
			
			if(!this.options.restartMessage && welcomeDialog.getElementById("restart_message")) {
				welcomeDialog.getElementById("restart_message").setAttribute("hidden", "true");
			}
			
			var btnFinish = welcomeDialog.getElementById("btnFinish");
            var btnCancel = welcomeDialog.getElementById("btnCancel");
            
			// get toolbar name, avoid redundant 'toolbar' in the title.
			var TOOLBAR_NAME =  this.namespace.toolbar.getAttribute("toolbarname").replace(/toolbar/i, "");

			var titleText = welcomeDialog.getElementById("set_HomePageTitle");
			var title = "The " + TOOLBAR_NAME + " toolbar was " + (this.options.update ? "updated" : "installed") + " successfully";

            btnFinish.addEventListener("mouseover", function(evt){ btnFinish.setAttribute("src", "../../skin/welcomepanel/installer-btn-finish-over.png"); });
            btnFinish.addEventListener("mouseout", function(evt){ btnFinish.setAttribute("src", "../../skin/welcomepanel/installer-btn-finish.png"); });
            btnCancel.addEventListener("mouseover", function(evt){ btnCancel.setAttribute("src", "../../skin/welcomepanel/installer-btn-cancel-over.png"); });
            btnCancel.addEventListener("mouseout", function(evt){ btnCancel.setAttribute("src", "../../skin/welcomepanel/installer-btn-cancel.png"); });
            
			btnFinish.addEventListener("click", function(evt){
				//if the partner ID is not hardcoded, look for it in XML.
				if(self.options.partner === "") {
					var partner_xml = namespace.framework.loadFile("partner.xml");
					if(partner_xml){
						var match = /name="(.*?)"/ig.exec(partner_xml);
						if(match) {
							self.options.partner = match[1];
						}
					}
				}

				if(self.options.search){
					self.setDefaultChromeSearch(self.options.searchId);
				}

				if(self.options.homepage){
					self.setHomePage( "http://my.xfinity.com/tt2/?cid=tbid"+self.getTodayDate());
				}

				welcomeDialog.close();
				welcomeDialog = null;
			});
			
			btnCancel.addEventListener("click", function(evt){
				welcomeDialog.close();
				welcomeDialog = null;
			});
			
			var p = {X:"50", Y:"100"};
			var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			var browserWindow = wm.getMostRecentWindow("navigator:browser");
			var homeButton = self.namespace.toolbar.getElementById(self.namespace.framework.applicationId + "-home");
			if(homeButton != null){
				p = new Position(homeButton.$domNode.getBoundingClientRect());
				p.add(new Position(browserWindow)).add(new Position(10, 20));
			}
			welcomeDialog.setAttribute('height', dialogHeight + 20);
			welcomeDialog.show(p.X, p.Y+30);
			welcomeDialog.focus();
		}catch(e){}
	};
    
    this.getTodayDate = function(){
        var today = new Date();
        var dd = today.getDate();
        var mm = today.getMonth()+1;
        var yyyy = today.getFullYear();

        if(dd<10)
            dd='0'+dd;

        if(mm<10)
            mm='0'+mm;

        return (mm+dd+yyyy);
    };
    
	this.setDefaultChromeSearch = function(searchId){
		var url = "http://search.xfinity.com/?cat=subweb&con=mmchrome&cid=xfstart_tech_search&q={searchTerms}";
		
		var statsElement = this.framework.getStatElement();
		if(url != null)
			url = url.replace(/___campaignID___/g, statsElement.getAttribute("campaignIDIE"));	//using campaignIDIE here is not an error. We do use campaignIDIE inside search urls for Firefox since a long time now.
						
		if (searchId) {
			var searchService = Components.classes["@mozilla.org/browser/search-service;1"].getService(Components.interfaces.nsIBrowserSearchService);
			var searchEngine = searchService.getEngineByName(searchId);
			if(!searchEngine){
				searchService.addEngineWithDetails(searchId, self.options.search.icon || 'http://www.xfinity.com/favicon.ico', searchId, searchId, 'GET', url);
			}
			searchEngine = searchService.getEngineByName(searchId);

			if(searchEngine){
				searchEngine.hidden = false;
				
				// set the curent ds in a user setting to use when reverting on addon disable/uninstall
				var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
				prefs.setCharPref('extensions.' + self.namespace.framework.applicationId + '.defaultsearch-before-install', prefs.getCharPref("browser.search.defaultenginename"));
				
				searchService.currentEngine = searchEngine;
				searchService.defaultEngine = searchEngine;
				this.framework.saveFile("chromsearch_was_set.dat", "true");
			}
		}
	};
	this.setHomePage = function(url)
	{
		if(url !== "") {
			try{
				var statsElement = this.framework.getStatElement();
				if(statsElement != null)
					url = url.replace(/___campaignID___/g, statsElement.getAttribute("campaignIDIE"));	//using campaignIDIE here is not an error. We do use campaignIDIE inside search urls for Firefox since a long time now.
				
				var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
				// set the curent hp in a user setting to use when reverting on addon disable/uninstall
				prefs.setCharPref('extensions.' + self.namespace.framework.applicationId + '.homepage-before-install', prefs.getCharPref('browser.startup.homepage'));
				
				prefs.setCharPref("browser.startup.homepage", url);
				prefs.setIntPref("browser.startup.page", 1);
				this.framework.saveFile("homepage_was_set.dat", "true");
			}
			catch(e){}
		}
	};
};

var Position = function (domOrX, Y) {
	this.X = domOrX;
	this.Y = Y;
	if(domOrX.top) { //.left is likely to be 0 for homebuttons, so would return false.
		this.X = domOrX.left;
		this.Y = domOrX.top;
	}
	if(domOrX.screenX !== undefined) {
		this.X = domOrX.screenX;
		this.Y = domOrX.screenY;
	}
	this.add = function (other) {
		this.X += other.X;
		this.Y += other.Y;
		return this;
	};
};