if (typeof xfin_portal == "object") {
	xfin_portal.wea = {};
	xfin_portal.wea.CITY_MAX = 10;
	xfin_portal.wea.UPDATE_FREQ = 30*60*1000; // 30 minutes

	xfin_portal.wea.city_data = null;//new Array();
	xfin_portal.wea.selectedCity = 0;

	xfin_portal.wea.vbox_select_city = null;
	xfin_portal.wea.edit = null;
	xfin_portal.wea.hbox_edit = null;
	xfin_portal.wea.label_edit = null;
	xfin_portal.wea.label_edit2 = null;
	xfin_portal.wea.controlId = null;
	xfin_portal.wea.labelNoZip = "Weather";
	xfin_portal.wea.wizardZIPPath = "data\\weather\\weatherZip.xml"; 
	xfin_portal.wea.notAvailableIcon = "na";
	xfin_portal.wea.notAvailableText = "N/A"
	xfin_portal.wea.showBtnCheckboxId = null;
	xfin_portal.wea.updateIndex = -1;
	xfin_portal.wea.saveTimeout = 0;
	xfin_portal.wea.btn = null;
	xfin_portal.wea.btn_check = xfin_portal.framework.createElement("image");
	xfin_portal.wea.throbber  = xfin_portal.framework.createElement("image");
	

    function updateButton() {
		if(xfin_portal.wea.city_data == null)
			return;
		if (xfin_portal.wea.selectedCity >= xfin_portal.wea.city_data.length) {
			xfin_portal.wea.selectedCity = xfin_portal.wea.city_data.length -1;
		}
		if (xfin_portal.wea.selectedCity != -1 && xfin_portal.wea.city_data != null) {
			var cityInfo = xfin_portal.wea.city_data[xfin_portal.wea.selectedCity];
			var label = "";
			if (xfin_portal.wea.btn.getAttribute("showcity") == "true")
				label += cityInfo.name + " ";
			if(typeof cityInfo.name == "undefined") return;   
			if (xfin_portal.wea.btn.getAttribute("celcius") == "true")
				{if (cityInfo.icon != xfin_portal.wea.notAvailableIcon) label += cityInfo.tempC + "\u00B0C";}
			else
				{if (cityInfo.icon != xfin_portal.wea.notAvailableIcon) label += cityInfo.tempF + "\u00B0F";}
			xfin_portal.wea.btn.setAttribute("label", label);
			xfin_portal.wea.btn.setAttribute("tooltiptext", cityInfo.name + " (" + cityInfo.forecast + ")");
			xfin_portal.wea.btn.setAttribute("image", xfin_portal.framework.makeChromeURL("skin/weather/" + cityInfo.icon + ".png"));
		}
		else {
			xfin_portal.wea.btn.setAttribute("label", xfin_portal.wea.labelNoZip);
			xfin_portal.wea.btn.setAttribute("tooltiptext", "Weather");
			xfin_portal.wea.btn.setAttribute("image", xfin_portal.framework.makeChromeURL("skin/weather/weather.png"));
		}
	}

	function appendCityControls(city, index) {
		var hbox_defined = xfin_portal.framework.createElement("hbox");
		hbox_defined.setAttribute("id", "cityselect" + city.zip);
		var radio = xfin_portal.framework.createElement("radio");
		radio.setAttribute("width", "170");
		radio.setAttribute("group", "city");
		radio.setAttribute("label", city.name + ", " + city.state + " - " + city.zip);
		hbox_defined.appendChild(radio);
		if (index == xfin_portal.wea.selectedCity) {
			radio.setAttribute("selected", "true");
		}
		else
			radio.setAttribute("selected", "false");
		hbox_defined.setAttribute("cityIndex", index + "");
		radio.addEventListener("command", function(evt) {
			var target = evt.target.parentNode;
			var index = target.getAttribute("cityIndex");
			xfin_portal.wea.btn.setAttribute("city", index + "");
		});
		xfin_portal.wea.vbox_select_city.appendChild(hbox_defined);

		var btn_modify = xfin_portal.framework.createElement("image");
		btn_modify.setAttribute("src", xfin_portal.framework.makeChromeURL("skin/lib/remove.png"));
		btn_modify.addEventListener("mouseover", function(evt) {
			evt.target.setAttribute("src", xfin_portal.framework.makeChromeURL("skin/lib/remove-over.png"));
		});	
		btn_modify.addEventListener("mouseout", function(evt) {
			evt.target.setAttribute("src", xfin_portal.framework.makeChromeURL("skin/lib/remove.png"));
		});
		
		btn_modify.addEventListener("click", function(evt) {
			// delete city
			if (xfin_portal.wea.btn_check.getAttribute("hidden") == "true") { // its already busy adding a city
				return; 
			}
			var cityIndex = new Number(evt.target.parentNode.getAttribute("cityIndex"));
			var select = xfin_portal.wea.vbox_select_city.childNodes[cityIndex];
			xfin_portal.wea.city_data.splice(cityIndex, 1);
			select.parentNode.removeChild(select);
			detectDuplicates();
			
			saveData();
			for (var i = 0; i < xfin_portal.wea.vbox_select_city.childNodes.length; i++) {
				var definedBox = xfin_portal.wea.vbox_select_city.childNodes[i];
				definedBox.setAttribute("cityIndex", i + "");
			}
			xfin_portal.wea.hbox_edit.setAttribute("hidden", "false");
			xfin_portal.wea.label_edit.setAttribute("hidden", "false");
			xfin_portal.wea.label_edit2.setAttribute("hidden", "false");
			if (xfin_portal.wea.selectedCity >= xfin_portal.wea.city_data.length) {
				xfin_portal.wea.selectedCity = xfin_portal.wea.city_data.length -1;
				xfin_portal.wea.btn.setAttribute("city", xfin_portal.wea.selectedCity + "");
			}
			updateButton();
		});
		hbox_defined.appendChild(btn_modify);
		
		if (xfin_portal.wea.city_data.length == xfin_portal.wea.CITY_MAX && xfin_portal.wea.hbox_edit != null) {
			xfin_portal.wea.hbox_edit.setAttribute("hidden", "true");
			xfin_portal.wea.label_edit.setAttribute("hidden", "true");
			xfin_portal.wea.label_edit2.setAttribute("hidden", "true");
		}
	}
			
	function addCity(value, optionWin) {
		if (xfin_portal.wea.btn_check.getAttribute("hidden") == "true" || // its already busy adding a city
			(xfin_portal.wea.city_data !=  null && xfin_portal.wea.city_data.length >= xfin_portal.wea.CITY_MAX)) {
			return; 
		}
			
		xfin_portal.wea.btn_check.setAttribute("hidden", "true");
		xfin_portal.wea.throbber.setAttribute("hidden", "false");
		var url = "http://weathercomcast.vmn.net/weather.php?";
		if (isZIP(value)) {
			url += "zipcode=" + value;
		} else {
			var city = escape(value);
			var state = "";            
			var stateRegex = /([^,]+)[,]\s*(AK|AL|AR|AZ|CA|CO|CT|DC|DE|FL|GA|HI|IA|ID|IL|IN|KS|KY|LA|MA|MD|ME|MI|MN|MO|MS|MT|NC|ND|NE|NH|NJ|NM|NV|NY|OH|OK|OR|PA|RI|SC|SD|TN|TX|UT|VA|VT|WA|WI|WV|WY)$/i;
			var stateRegexResult = value.match(stateRegex);
			if (stateRegexResult != null && stateRegexResult.length == 3) {
				city = escape(stateRegexResult[1]);
				state = stateRegexResult[2];
			}
			url += "name_en=" + city + "&prov=" + state;
		}
		xfin_portal.framework.download(url,
			function(url, code, content) {
				if (code == 200) {
					var info = getInfoFromXML(content);
					if(xfin_portal.wea.city_data == null)
				        xfin_portal.wea.city_data = new Array();

					if (info != null && xfin_portal.wea.city_data.length < xfin_portal.wea.CITY_MAX) {
						var i = 0;
						for(; i < xfin_portal.wea.city_data.length && xfin_portal.wea.city_data[i].zip != info.zip; i++);
						if (i == xfin_portal.wea.city_data.length) {
							xfin_portal.wea.city_data.push(info);
							detectDuplicates();
							if (xfin_portal.wea.city_data.length == 1) {
								xfin_portal.wea.selectedCity = 0;
								updateButton();
							}
							if (optionWin)
							    appendCityControls(info, xfin_portal.wea.city_data.length - 1);
							saveData();
						}
						else {
							window.alert(info.name + " is already in your list.");
						}
					}
					else {
						window.alert("Can not find the city.");
					}
				}
				var btn_check = xfin_portal.framework.getElementById(xfin_portal.framework.applicationId  + "-weather-add");	
				btn_check.setAttribute("hidden", "false");
				xfin_portal.wea.throbber.setAttribute("hidden", "true");

				if (xfin_portal.wea.edit.getAttribute("hidden") != "true") {
					xfin_portal.wea.edit.focus();
					xfin_portal.wea.edit.select();
				}
			});
	}
	
	function getGEOIP() {
	    var url = "http://geoip.vmn.net/index.php?v=2&tb=xfin_portal";
		xfin_portal.framework.download(url,
		function(url, code, content) {
			if (code == 200) {
			    var xml = xfin_portal.framework.loadXML(content);
			    var location = xml.getElementsByTagName("location")[0];
			    var zip = location.getAttribute("zipcode");
			    if (zip != "" || zip != null)
			    {
			        if (isNaN(zip))
			            addCity(10001, false);
			        else
				        addCity(zip, false);
			    }
			}
	    });
	}
		
	function weatherInit(){
		xfin_portal.wea.controlId = xfin_portal.framework.applicationId + "-comcast-weather-widget";
		xfin_portal.wea.showBtnCheckboxId =  "weather-widget-checkbox" + xfin_portal.framework.guid;	
		xfin_portal.wea.btn = xfin_portal.framework.getElementById(xfin_portal.wea.controlId);
		xfin_portal.wea.city_data = (xfin_portal.wea.btn.getAttribute("cities") == null ? null : xfin_portal.framework.fromJSON(unescape(xfin_portal.wea.btn.getAttribute("cities"))));
		xfin_portal.wea.selectedCity = (xfin_portal.wea.btn.getAttribute("city") == null ? 0 : xfin_portal.wea.btn.getAttribute("city"));
		updateButton();
		if (xfin_portal.wea.btn.getAttribute('firstrun') == 'true')
 		{
 		    getGEOIP();
 		   	xfin_portal.wea.btn.setAttribute("firstrun", "false");
        }    
           
		xfin_portal.wea.btn.addEventListener("command", function() {
			if (xfin_portal.wea.selectedCity != -1 && xfin_portal.wea.city_data != null && xfin_portal.wea.selectedCity < xfin_portal.wea.city_data.length) {
				var city = xfin_portal.wea.city_data[xfin_portal.wea.selectedCity];
				var url = "http://xfinity.comcast.net/local/" + city.zip + "/?cid=toolbar_button&attr=weatherbutton";
				loadURI(url);
			}
			else {
				xfin_portal.wea.selectedCity = -1;
				//xfin_portal.showPreferences("weatherPrefPanel");
				xfin_portal.wea.btn.$fireEvent("launchweatherPrefPanel", {target:xfin_portal.wea.btn});
			}
		});
		 
		this.buttonId  = xfin_portal.wea.btn;

		var menu = xfin_portal.framework.getElementById(xfin_portal.framework.applicationId + "-comcast-weather-widget-menupopup");
		
		
		menu.addEventListener("popupshowing", function() {
			menu.removeAll();
			if (xfin_portal.wea.city_data != null && xfin_portal.wea.city_data.length > 0) {
				for (var i = 0; i < xfin_portal.wea.city_data.length; i++) {
					var item = xfin_portal.framework.createElement("menuitem");
					var cityInfo = xfin_portal.wea.city_data[i];
					//item.setAttribute("image", xfin_portal.framework.makeChromeURL("skin/weather/" + cityInfo.icon + ".png"));
					var label = cityInfo.name;
				  if (xfin_portal.wea.btn.getAttribute("celcius") == "true")
						{if (cityInfo.icon != xfin_portal.wea.notAvailableIcon) label += " - " + cityInfo.tempC + "\u00B0C";}  
					else
						{if (cityInfo.icon != xfin_portal.wea.notAvailableIcon) label += " - " + cityInfo.tempF + "\u00B0F";}
					item.setAttribute("label", label);
					item.setAttribute("class", xfin_portal.framework.applicationId+"-menuitem");
					item.setAttribute("itemIndex", i + "");
					item.addEventListener("command",
						function(evt) {
							var index = evt.target.getAttribute("itemIndex");
							xfin_portal.wea.btn.setAttribute("city", index);
						});
					if (i == xfin_portal.wea.selectedCity) {
						item.setAttribute("style", "font-weight: bold");
					}
					menu.appendChild(item);
				}
				var menusep = xfin_portal.framework.createElement("menuseparator");
				menusep.setAttribute("class", xfin_portal.framework.applicationId+"-menuseparator");
				menu.appendChild(menusep);
			}
			var item = xfin_portal.framework.createElement("menuitem");
			item.setAttribute("id", xfin_portal.framework.applicationId + "-weather-Add-Change-City");
			item.setAttribute("label", "Add/Change City");
			item.setAttribute("track", "true");
			item.addEventListener("command", function() {
				xfin_portal.wea.btn.$fireEvent("launchweatherPrefPanel", {target:xfin_portal.wea.btn});
				//xfin_portal.showPreferences("weatherPrefPanel");
			});
			menu.appendChild(item);
		});

		xfin_portal.wea.btn.addEventListener("attributechange", function(evt) {
			var attrid = evt.id;
			var value = evt.value;
			
			if (attrid == "cities") {
				if (xfin_portal.wea.city_data == null) {
					xfin_portal.wea.city_data = xfin_portal.framework.fromJSON(value);
					detectDuplicates();
					if (xfin_portal.wea.selectedCity >= xfin_portal.wea.city_data.length)
						xfin_portal.wea.selectedCity = xfin_portal.wea.city_data.length - 1;
					updateButton();
					startWeatherUpdate();
				}
			}
			else if (attrid == "city") {
				var city = value;
				if (city != -1) {
					xfin_portal.wea.selectedCity = city;
					if (xfin_portal.wea.city_data != null && xfin_portal.wea.selectedCity >= xfin_portal.wea.city_data.length)
						xfin_portal.wea.selectedCity = xfin_portal.wea.city_data.length - 1;
					/* Removing all cities and then adding cities creates a problem, even if apparently first city is selected, 
					when browser is opened the second time - no city will be selected */
					if(xfin_portal.wea.selectedCity == -1 && xfin_portal.wea.city_data != null && xfin_portal.wea.city_data.length > 0 )
						xfin_portal.wea.selectedCity = 0;
					
				}
				updateButton();
			}
		});
		
		xfin_portal.wea.btn.addEventListener("getprefpane", function(evt) {
			var result = xfin_portal.framework.createElement("prefpane");
			result.setAttribute("id", "weatherPrefPanel");
			result.setAttribute("label", "WEATHER");
			result.setAttribute("for", xfin_portal.wea.controlId);
			result.setAttribute("image", xfin_portal.framework.makeChromeURL("skin/options/options-weather.png"));
			result.addEventListener("select",function(evt){
				evt.target.getElementById(xfin_portal.framework.applicationId  + "-weather-textbox").focus();
			});
			
			
			evt.result = result;
		});

		xfin_portal.wea.btn.addEventListener("getoptions", function(evt) {
			var node = evt.node;
			xfin_portal.wea.btn_check = null;
			xfin_portal.wea.throbber = null;
			var prefDoc = evt.document;
			if (xfin_portal.wea.city_data == null)
				xfin_portal.wea.city_data = new Array();
			
			var hbox = xfin_portal.framework.createElement("hbox");
			hbox.setAttribute("style","width: 400px; height: 350px");
			
			//right
			var vboxRight = xfin_portal.framework.createElement("vbox");
			
			var label = xfin_portal.framework.createElement("label");
			label.setAttribute("value", "Your local weather at a glance");
			label.setAttribute("style","margin-top: 0; margin-bottom: 0; font-weight: bold; xpadding-right: 250px");
			vboxRight.appendChild(label);
			
			var spacer = xfin_portal.framework.createElement("vbox");
			spacer.setAttribute("height", "5");
			vboxRight.appendChild(spacer);
			
			var info = xfin_portal.framework.createElement("vbox");
			var infoDiv = xfin_portal.framework.createElement("label");
			infoDiv.setAttribute("value", "Track up to 10 U.S cities or zip codes easily via your toolbar.");
			infoDiv.setAttribute("style","font-size: 8pt; margin-left: 7px; margin-right: 10px;");
			info.appendChild(infoDiv);
			vboxRight.appendChild(info);
			
			var headerBox = xfin_portal.framework.createElement("hbox");
			var header = xfin_portal.framework.createElement("label");
			header.setAttribute("value", "");
			header.setAttribute("width", "200");
			header.setAttribute("height", "20");
			header.setAttribute("style","margin-top: 0; margin-bottom: 0;");
			headerBox.appendChild(header);
			vboxRight.appendChild(headerBox);
			
			//loop begin
			var radiogroup = xfin_portal.framework.createElement("radiogroup");
			xfin_portal.wea.vbox_select_city = xfin_portal.framework.createElement("vbox");
				
			for (var i = 0; i < xfin_portal.wea.city_data.length; i++) {
				var city = xfin_portal.wea.city_data[i];
				appendCityControls(city, i);
			}
			radiogroup.appendChild(xfin_portal.wea.vbox_select_city);
			vboxRight.appendChild(radiogroup);

			var vbox_space = xfin_portal.framework.createElement("vbox");
			vbox_space.setAttribute("height", "10");
			vboxRight.appendChild(vbox_space);
			xfin_portal.wea.label_edit = xfin_portal.framework.createElement("label");
			xfin_portal.wea.label_edit.setAttribute("value", "Enter your City Name and State or your Zip code.");
			vboxRight.appendChild(xfin_portal.wea.label_edit);
			
			xfin_portal.wea.hbox_edit = xfin_portal.framework.createElement("hbox");
			xfin_portal.wea.edit = xfin_portal.framework.createElement("textbox");
			xfin_portal.wea.edit.setAttribute("width", "170");
			xfin_portal.wea.edit.setAttribute("id", xfin_portal.framework.applicationId  + "-weather-textbox");
			xfin_portal.wea.edit.addEventListener("keydown", function(evt) {
				if (evt.keyCode == 13) {
					var value = xfin_portal.wea.edit.getAttribute("value");
					if (typeof value == "string" && value != "") {
						addCity(value, true);
					}
				}
			});
			xfin_portal.wea.hbox_edit.appendChild(xfin_portal.wea.edit);
			vboxRight.appendChild(xfin_portal.wea.hbox_edit);
			xfin_portal.wea.label_edit2 = xfin_portal.framework.createElement("label");
			xfin_portal.wea.label_edit2.setAttribute("value", "For Example: (Philadelphia, PA or 19102)");
			vboxRight.appendChild(xfin_portal.wea.label_edit2);
			
			xfin_portal.wea.btn_check = xfin_portal.framework.createElement("image");
			xfin_portal.wea.btn_check.setAttribute("src", xfin_portal.framework.makeChromeURL("skin/lib/add.png"));
			xfin_portal.wea.btn_check.setAttribute("id", xfin_portal.framework.applicationId  + "-weather-add");
			
			xfin_portal.wea.btn_check.addEventListener("mouseover", function(evt) {
				evt.target.setAttribute("src", xfin_portal.framework.makeChromeURL("skin/lib/add-over.png"));
			});	
			xfin_portal.wea.btn_check.addEventListener("mouseout", function(evt) {
				evt.target.setAttribute("src", xfin_portal.framework.makeChromeURL("skin/lib/add.png"));
			});
			xfin_portal.wea.btn_check.addEventListener("click", function() {
				var value = xfin_portal.wea.edit.getAttribute("value");
				if (typeof value == "string" && value != "") {
					addCity(value, true);
				}
			});
			xfin_portal.wea.hbox_edit.appendChild(xfin_portal.wea.btn_check);
			if (xfin_portal.wea.city_data.length >= xfin_portal.wea.CITY_MAX) {
				xfin_portal.wea.hbox_edit.setAttribute("hidden", "true");
				xfin_portal.wea.label_edit.setAttribute("hidden", "true");
				xfin_portal.wea.label_edit2.setAttribute("hidden", "true");
			}
			xfin_portal.wea.throbber = xfin_portal.framework.createElement("image");
			xfin_portal.wea.throbber.setAttribute("src", xfin_portal.framework.makeChromeURL("skin/weather/throbber.gif"));
			xfin_portal.wea.throbber.setAttribute("width", "16");
			xfin_portal.wea.throbber.setAttribute("height", "16");
			xfin_portal.wea.throbber.setAttribute("style", "margin-left: 5px; margin-bottom: 5px; margin-top: 5px");
			xfin_portal.wea.throbber.setAttribute("hidden", "true");
			xfin_portal.wea.hbox_edit.appendChild(xfin_portal.wea.throbber);
			
			
			var spacerA = xfin_portal.framework.createElement("vbox");
			spacerA.setAttribute("height", "5");
			vboxRight.appendChild(spacerA);
			
			var checkboxA = xfin_portal.framework.createElement("checkbox");
			checkboxA.setAttribute("id", xfin_portal.wea.showBtnCheckboxId);
			checkboxA.setAttribute("label", "Show button");
			checkboxA.setAttribute("checked", (xfin_portal.wea.btn.getAttribute("hidden")== "true") ? "false" : "true");
			checkboxA.addEventListener("command",
				function() {
					if (xfin_portal.wea.btn.getAttribute("hidden") != "true") {
						xfin_portal.wea.btn.setAttribute("hidden", "true");
					}
					else {
						xfin_portal.wea.btn.setAttribute("hidden", "false");
					}
				}, false);
				
			vboxRight.appendChild(checkboxA);
			
			hbox.appendChild(vboxRight);
			
			node.appendChild(hbox);
			
		});

		if (typeof xfin_portal.wea.btn.getAttribute("city") == "undefined" || (xfin_portal.wea.city_data && xfin_portal.wea.city_data.length == 0)) {
			var weatherInstallZIPContent = xfin_portal.framework.loadChromeFile(xfin_portal.wea.wizardZIPPath);
			if(!weatherInstallZIPContent) return;
			var weatherInstallZIPXML = xfin_portal.framework.loadXML(weatherInstallZIPContent);
			var weatherInstallZIPNode  = weatherInstallZIPXML.getElementsByTagName("zipcode");
			var weatherInstallZIP = weatherInstallZIPNode[0].firstChild.nodeValue;
			
			while (weatherInstallZIP.indexOf(" ") != -1)
				weatherInstallZIP = weatherInstallZIP.replace(" ", "");

			if (xfin_portal.wea.city_data == null)
			{
				xfin_portal.wea.city_data = new Array();
			}  		
			if (isZIP(weatherInstallZIP)) {
				xfin_portal.wea.city_data[0] =  { zip:weatherInstallZIP };
			} else {
				xfin_portal.wea.city_data[0] =  { zip:"10007"}; //default to New York
			}
			startWeatherUpdate();  
				
			xfin_portal.wea.selectedCity = 0;
			saveData();
		   
		}
	};

	function startWeatherUpdate() {
		xfin_portal.wea.updateIndex = 0;
		updateWeather();
	};

	function getInfoFromXML(content) {
		try {
			var cityInfo = {
				name: "",
				state: "",
				zip: "",
				icon: "",
				tempC: "",
				tempF: "",
				forecast: ""
			};
			var xml = xfin_portal.framework.loadXML(content);
			var site = xml.getElementsByTagName("SITE");
			site = site[0];
			
			if (site.getAttribute("LOCATIONID") == "Error")
				return null;
			
			cityInfo.name = site.getAttribute("NAME_EN");
			cityInfo.state = site.getAttribute("PROV");
			cityInfo.zip = site.getAttribute("ZIPCODE");
			var data = xml.getElementsByTagName("DATA");
			data = data[0];
			cityInfo.icon = data.getAttribute("ICON");
			if (cityInfo.icon == "*") cityInfo.icon = xfin_portal.wea.notAvailableIcon; 
			cityInfo.tempC = data.getAttribute("TEMPERATURE_C");
			cityInfo.tempF = data.getAttribute("TEMPERATURE_F");
			cityInfo.forecast = data.getAttribute("FORECAST_TEXT_EN");
			if (cityInfo.forecast == "*") cityInfo.forecast = xfin_portal.wea.notAvailableText;
			
			return cityInfo;
		}
		catch(e) {
			return null;
		}
	};

	function updateWeather() {
		if (xfin_portal.wea.city_data != null && xfin_portal.wea.updateIndex < xfin_portal.wea.city_data.length) {
			var cityInfo = xfin_portal.wea.city_data[xfin_portal.wea.updateIndex];
			xfin_portal.framework.download("http://weathercomcast.vmn.net/weather.php?zipcode=" + cityInfo.zip + "&nocache=" + Math.random(),
				function(url, code, content) {
					if (code == 200) {
						var newInfo = getInfoFromXML(content);
						if (newInfo != null) {
							xfin_portal.wea.city_data[xfin_portal.wea.updateIndex] = newInfo;
							if (xfin_portal.wea.updateIndex == xfin_portal.wea.selectedCity)
								updateButton();
						}
					}
					xfin_portal.wea.updateIndex++;
					updateWeather();
				});
		}
	}

	function detectDuplicates() {
		var data = new Array();
		for (var i = 0; i < xfin_portal.wea.city_data.length; i++) {
			var city = xfin_portal.wea.city_data[i];
			var j = 0;
			for (; j < data.length && city.zip != data[j].zip; j++);
			if (j == data.length)
				data.push(city)
			else {
				xfin_portal.framework.log("Duplicate detected!");
			}
		}
	};

	function saveData() {
		if (xfin_portal.wea.saveTimeout != 0)
			xfin_portal.framework.clearTimeout(xfin_portal.wea.saveTimeout);
			xfin_portal.wea.saveTimeout = xfin_portal.framework.setTimeout(
			function() {
				var json = escape(xfin_portal.framework.toJSON(xfin_portal.wea.city_data));
				xfin_portal.wea.btn.setAttribute("cities", json);
				xfin_portal.wea.btn.setAttribute("city", xfin_portal.wea.selectedCity);
				
				if (xfin_portal.wea.selectedCity == xfin_portal.wea.city_data.length)
					xfin_portal.wea.selectedCity = xfin_portal.wea.city_data.length - 1;
			}, 125);
	};


	function isZIP(sText) {
	   var ValidChars = "0123456789";
	   var IsNumber = true;
	   var Char;
	   for (i = 0; i < sText.length && IsNumber; i++)  { 
		  Char = sText.charAt(i); 
		  if (ValidChars.indexOf(Char) == -1) {
			 IsNumber = false;
		  }
	   }
	   return IsNumber;
	};
	  
	  
	xfin_portal.framework.setInterval(function(){ startWeatherUpdate();},xfin_portal.wea.UPDATE_FREQ);
}